/***************************************************************************
                 vlc_produccion.qs  -  description
                             -------------------
    begin                : mie nov 23 2005
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
	var ctx:Object;
	function interna( context ) { this.ctx = context; }
	    function init() { this.ctx.interna_init(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
	function oficial( context ) { interna( context ); }
	function selecciona_padre() { this.ctx.oficial_selecciona_padre(); }
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends oficial {
	function head( context ) { oficial ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
	function ifaceCtx( context ) { head( context ); }
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/**
\C Los datos generales son nicos, por tanto formulario de no presenta los botones de navegacin por registros.
\end

\D La gestin del formulario se hace de forma manual mediante el objeto f (FLFormSearchDB)
\end
\end */
function interna_init()
{
if (!this.cursor().isNull("idstock"))
	{
	debug("Esconde!!");
	this.child("fdb_codalmacen").setDisabled(true);
	this.child("fdb_referencia").setDisabled(true);
	}
else
	{
	debug("Muestra!!");
	this.child("fdb_codalmacen").setDisabled(false);
	this.child("fdb_referencia").setDisabled(false);
	}


this.child("fdb_padre").setDisabled(true);
var btn_padre = this.child("pbn_padre");
connect (btn_padre, "clicked()", this, "iface.selecciona_padre");
}

function oficial_selecciona_padre()
{
	debug("Seleccionando_padre!");
	var util = new FLUtil;
	var cursor = this.cursor();
	if (!cursor.isNull("id_linea")) {
		MessageBox.critical(util.translate("scripts","Esta produccion no puede tener padre. Es de una factura de proveedor"), MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
		return;
	} else {
		var f:Object = new FLFormSearchDB("vlc_produccion");
		f.setMainWidget();
		var id_produccion:String = f.exec("id");
		if(id_produccion)
			{
			this.cursor().setValueBuffer("id_padre", id_produccion);
			}
		}
}

//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////

//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

