/***************************************************************************
                 i_masterarticulos.qs  -  description
                             -------------------
    begin                : mar may 17 2005
    copyright            : (C) 2005 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
    function oficial( context ) { interna( context ); }
	function lanzar() {
		return this.ctx.oficial_lanzar();
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration tarifaViv */
//////////////////////////////////////////////////////////////////
//// TARIFAVIV ///////////////////////////////////////////////////
class tarifaViv extends oficial /** %from: oficial */ {
    function tarifaViv( context ) { oficial( context ); }
	function lanzar() {
		return this.ctx.tarifaViv_lanzar();
	}
}
//// TARIFAVIV ///////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends tarifaViv {
    function head( context ) { tarifaViv ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
function interna_init()
{
	connect (this.child("toolButtonPrint"), "clicked()", this, "iface.lanzar()");
}
//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
function oficial_lanzar()
{
	var cursor:FLSqlCursor = this.cursor()
	var seleccion:String = cursor.valueBuffer("id");
	if (!seleccion)
		return;

	var nombreInforme:String;
	if (cursor.valueBuffer("incluircoste"))
		nombreInforme = "i_articuloscoste";
	else
		nombreInforme = "i_articulos";

	var orderBy:String = "";
	flfactinfo.iface.pub_lanzarInforme(cursor, nombreInforme, orderBy);
}
//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition tarifaViv */
//////////////////////////////////////////////////////////////////
//// TARIFAVIV ///////////////////////////////////////////////////
function tarifaViv_lanzar()
{
	var cursor:FLSqlCursor = this.cursor()
	var seleccion:String = cursor.valueBuffer("id");
	var ordenarPor:String = "";
	var nombreInforme:String = "i_articulos";
	var orderBy:String = "";
	if (!seleccion)
		return;
	ordenarPor = cursor.valueBuffer("orden");
	if (ordenarPor == "Referencia")
		orderBy = "articulos.referencia"
	else
		orderBy = "articulos.descripcion"

	flfactinfo.iface.pub_lanzarInforme(cursor, nombreInforme, orderBy);
}
//// TARIFAVIV //////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

