/***************************************************************************
                 i_masterbalancesis.qs  -  description
                             -------------------
    begin                : lun abr 26 2004
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
    function oficial( context ) { interna( context ); } 
	function lanzar() {
		return this.ctx.oficial_lanzar();
	}
	function cargarQryReport(cursor:FLSqlCursor, idImpresion:String):Array {
		return this.ctx.oficial_cargarQryReport(cursor, idImpresion);
	}
	function rellenarDatos(idImpresion:String, cursor:FLSqlCursor) {
		return this.ctx.oficial_rellenarDatos(idImpresion, cursor);
	}
	function quitarAsientos(codEjercicio:String):String {
		return this.ctx.oficial_quitarAsientos(codEjercicio);
	}
// 	function crearNodoRow():FLDomNode {
// 		return this.ctx.oficial_crearNodoRow();
// 	}
// 	function dameNodoXML(nodoPadre:FLDomNode, ruta:String, debeExistir:Boolean):FLDomNode {
// 		return this.ctx.oficial_dameNodoXML(nodoPadre, ruta, debeExistir);
// 	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration column0 */
/////////////////////////////////////////////////////////////////
//// COLUMN0 ///////////////////////////////////////////////////
class column0 extends oficial {
        function column0( context ) { oficial ( context ); }
        function filtroTabla():String {
                return this.ctx.column0_filtroTabla();
        }
        function rellenarDatos(idImpresion:String, cursor:FLSqlCursor) {
                return this.ctx.column0_rellenarDatos(idImpresion, cursor);
        }
        function quitarAsientos(codEjercicio:String):String {
                return this.ctx.column0_quitarAsientos(codEjercicio);
        }
}
//// COLUMN0 ///////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

/** @class_declaration jrpt */
/////////////////////////////////////////////////////////////////
//// JRPT //////////////////////////////////////////////////////
class jrpt extends column0 {
    function jrpt( context ) { column0 ( context ); }
    function lanzar() { 
        return this.ctx.jrpt_lanzar();
    }
    function establecerDatosInforme(cursor:FLSqlCursor, idImpresion:Number):Array{
        return this.ctx.jrpt_establecerDatosInforme(cursor, idImpresion);
    }
    function generarDatosInforme(cursor:FLSqlCursor, idImpresion:Number, datos:Array):Array{
       return this.ctx.jrpt_generarDatosInforme(cursor, idImpresion, datos);
    }
    function generarDatosInformeEjercicio(cursor:FLSqlCursor, idImpresion:Number, datos:Array, actSaldoIni:Boolean):Array{
       return this.ctx.jrpt_generarDatosInformeEjercicio(cursor, idImpresion, datos, actSaldoIni);
    }
    function consultaSumasySaldos(cursor:FLSqlCursor, idImpresion:Number, datos:Array):FLSqlQuery{
        return this.ctx.jrpt_consultaSumasySaldos(cursor, idImpresion, datos);
    }
    function dameWhereSubcuentas(cursor:FLSqlCursor, idImpresion:Number, datos:Array):String{
        return this.ctx.jrpt_dameWhereSubcuentas(cursor, idImpresion, datos);
    }
    function dameWhereAsientos(cursor:FLSqlCursor, idImpresion:Number, datos:Array):String{
        return this.ctx.jrpt_dameWhereAsientos(cursor, idImpresion, datos);
    }
    function rellenarDatosJrpt(cursor:FLSqlCursor, idImpresion:Number, datos:Array, q:FLSqlQuery, actSaldoIni:Boolean):Boolean{
        return this.ctx.jrpt_rellenarDatosJrpt(cursor, idImpresion, datos, q, actSaldoIni);
    }
    function actualizarNivelAgrupado(cursor:FLSqlCursor, idImpresion:Number, datos:Array):Boolean{
        return this.ctx.jrpt_actualizarNivelAgrupado(cursor, idImpresion, datos);
    }
    function actualizarSaldoInicial(cursor:FLSqlCursor, idImpresion:Number, datos:Array):Boolean{
        return this.ctx.jrpt_actualizarSaldoInicial(cursor, idImpresion, datos);
    }
    function calcularSaldoInicial(idSubcuenta:String, datos:Array):Number{
		return this.ctx.jrpt_calcularSaldoInicial(idSubcuenta, datos);
    }
    function consultaSaldoApertura(idSubcuenta:String, datos:Array):FLSqlQuery{
		return this.ctx.jrpt_consultaSaldoApertura(idSubcuenta, datos);
    }
    function dameWhereApertura(idSubcuenta:String, datos:Array):String{
		return this.ctx.jrpt_dameWhereApertura(idSubcuenta, datos);
    }
    function consultaSaldoInicial(idSubcuenta:String, datos:Array):FLSqlQuery{
		return this.ctx.jrpt_consultaSaldoInicial(idSubcuenta, datos);
    }
    function dameWhereSaldoInicial(idSubcuenta:String, datos:Array):String{
		return this.ctx.jrpt_dameWhereSaldoInicial(idSubcuenta, datos);
    }
    function eliminarSubcuentasCero(cursor:FLSqlCursor, idImpresion:Number, datos:Array):Boolean{
        return this.ctx.jrpt_eliminarSubcuentasCero(cursor, idImpresion, datos);
    }
}
//// JRPT //////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration mDeposito */
/////////////////////////////////////////////////////////////////
//// M DEPOSITO /////////////////////////////////////////////////
class mDeposito extends jrpt {
    function mDeposito( context ) { jrpt ( context ); }
    function init() { this.ctx.mDeposito_init(); }
    function comprobarDocsDeposito() {        
        return this.ctx.mDeposito_comprobarDocsDeposito();
    }
    function lanzar() {
        return this.ctx.mDeposito_lanzar();
    }
}
//// M DEPOSITO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends mDeposito {
    function head( context ) { mDeposito ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
	function pub_cargarQryReport(cursor:FLSqlCursor, idImpresion:String):Array {
		return this.cargarQryReport(cursor, idImpresion);
	}
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////

/** \C El botn de impresin lanza el informe
\end */
function interna_init()
{ 
    /*var cmbBoxSearch = this.child("comboBoxFieldToSearch");
    cmbBoxSearch.currentItem = cmbBoxSearch.count - 1;*/
		connect(this.child("toolButtonPrint"), "clicked()", this, "iface.lanzar()");
}
//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
/** \D Lanza el informe 

Se hacen algunas modificacione sobre la consulta del informe:

Se aade un GROUP BY para calcular la suma de saldos de las subcuentas agrupadas por cuenta. Si se marca la opcin de consolidar ejercicio, se aaden al WHERE de la consulta los datos del ejercicio anterior para que tambin sean sumados en el informe resultante.
\end */
function oficial_lanzar()
{
	var util:FLUtil = new FLUtil;

	var cursor:FLSqlCursor = this.cursor()
	if (!cursor.isValid())
		return;
	flcontinfo.iface.numPag = 0;

	var ahora:Date = new Date;
	//var idImpresion:String = ahora.getTime().toString();
        var idImpresion:String = cursor.valueBuffer("id");
	idImpresion += sys.nameUser();

	var datos:Array = this.iface.cargarQryReport(cursor, idImpresion);
	if (!datos) {
		return false;
	}
	var q:FLSqlQuery = datos["query"];
	var nombreReport:String = datos["report"];

	var rptViewer:FLReportViewer = new FLReportViewer();
	rptViewer.setReportTemplate(nombreReport);
		rptViewer.setReportData(q);
	rptViewer.renderReport();
	rptViewer.exec();

	/*if (!util.sqlDelete("co_i_balancesis_buffer", "idimpresion = '" + idImpresion + "'")) {
		return;
	}*/
}

function oficial_cargarQryReport(cursor:FLSqlCursor, idImpresion:String):Array
{
	var util:FLUtil = new FLUtil();
	var nombreInforme:String = cursor.table();
	var nombreReport:String = nombreInforme;
	var datos:Array;
	if (cursor.valueBuffer("resumido"))
		nombreReport = "co_i_balancesis_res";
	if (cursor.valueBuffer("nivel") == "Subcuenta")
		nombreReport = "co_i_balancesis_scta";
	
	flcontinfo.iface.pub_establecerInformeActual(cursor.valueBuffer("id"), nombreInforme);
	
        var calculado:Number = util.sqlSelect("co_i_balancesis_buffer","count(id)","idimpresion='"+idImpresion+"'");
        if (!calculado) calculado=0;
        if (cursor.valueBuffer("recalculoauto")){
            this.iface.rellenarDatos(idImpresion, cursor);
        } else if(calculado<1) {
            this.iface.rellenarDatos(idImpresion, cursor);
        }

	var q:FLSqlQuery = new FLSqlQuery(nombreInforme);
	q.setWhere("idimpresion = '" + idImpresion + "'");

	if (!q.exec()) {
		MessageBox.critical(util.translate("scripts", "Fall la consulta"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
		return;
	}

	if (!q.size()) {
		MessageBox.warning(util.translate("scripts","No hay registros que cumplan los criterios de bsqueda establecidos"), MessageBox.NoButton);
		return;
	}

	datos["query"] = q;
	datos["report"] = nombreReport;
	return datos;
}

function oficial_rellenarDatos(idImpresion:String, cursor:FLSqlCursor):FLDomDocument
{
	var util:FLUtil = new FLUtil;
        
        if (!util.sqlDelete("co_i_balancesis_buffer", "idimpresion = '" + idImpresion + "'")) {
            return;
        }

	var groupBy:String = "co_cuentas.codcuenta, co_cuentas.descripcion, co_subcuentas.codsubcuenta, co_subcuentas.descripcion";
	var orderBy:String = "co_cuentas.codcuenta, co_cuentas.descripcion, co_subcuentas.codsubcuenta, co_subcuentas.descripcion";

	var ejAct:String = cursor.valueBuffer("i_co__subcuentas_codejercicio");
	var desdeAct:String = cursor.valueBuffer("d_co__asientos_fecha");
	var hastaAct:String = cursor.valueBuffer("h_co__asientos_fecha");
	var desdeScta:String = cursor.valueBuffer("d_co__subcuentas_codsubcuenta");
	var hastaScta:String = cursor.valueBuffer("h_co__subcuentas_codsubcuenta");
	
	var nivel:Number
	
	// Subcuenta por compatibilidad hacia atras
	if (cursor.valueBuffer("nivel") == "Cuenta" || cursor.valueBuffer("nivel") == "Subcuenta")
		nivel = 0;
	else
		nivel = parseFloat(cursor.valueBuffer("nivel"));
		
	var where:String = "(co_asientos.codejercicio = '" + ejAct + "'" +
		" AND co_asientos.fecha >= '" + desdeAct + "'" +
		" AND co_asientos.fecha <= '" + hastaAct + "'";
		 
	if (desdeScta)
		where += " AND co_partidas.codsubcuenta >= '" + desdeScta + "'";
		
	if (hastaScta)
		where += " AND co_partidas.codsubcuenta <= '" + hastaScta + "'";
	
	var listaAsientos:String = this.iface.quitarAsientos(ejAct);
	if (listaAsientos && listaAsientos != "") {
		where += " AND co_asientos.idasiento NOT IN (" + listaAsientos + ")";
	}

	where += ")";


	var consolidar:Boolean = false;
	if (cursor.valueBuffer("ejercicioanterior") == 1)
			consolidar = true;

	if (consolidar) {
		var ejAnt:String = cursor.valueBuffer("codejercicioant");
		var desdeAnt:String = cursor.valueBuffer("fechaant_d");
		var hastaAnt:String = cursor.valueBuffer("fechaant_h");
		desdeScta = cursor.valueBuffer("d_co__subcuentas_codsubcuenta");
		hastaScta = cursor.valueBuffer("h_co__subcuentas_codsubcuenta");
			
		where +=  " OR (co_asientos.codejercicio = '" + ejAnt + "'" +
			" AND co_asientos.fecha >= '" + desdeAnt + "'" +
			" AND co_asientos.fecha <= '" + hastaAnt + "'" +
			" AND co_partidas.codsubcuenta >= '" + desdeScta + "'" +
			" AND co_partidas.codsubcuenta <= '" + hastaScta + "'";
		
		var listaAsientosAnt:String = this.iface.quitarAsientos(ejAnt);
		if (listaAsientosAnt && listaAsientosAnt != "") {
			where += " AND co_asientos.idasiento NOT IN (" + listaAsientos + ")";
		}

		where += ")";
	}
	
	var q:FLSqlQuery = new FLSqlQuery();
	q.setTablesList("co_cuentas,co_subcuentas,co_partidas,co_asientos");
	q.setFrom("co_cuentas INNER JOIN co_subcuentas ON co_cuentas.idcuenta = co_subcuentas.idcuenta INNER JOIN co_partidas ON co_subcuentas.idsubcuenta = co_partidas.idsubcuenta INNER JOIN co_asientos ON co_partidas.idasiento = co_asientos.idasiento");
	q.setSelect("co_cuentas.codcuenta, co_cuentas.descripcion, co_subcuentas.codsubcuenta, co_subcuentas.descripcion, SUM(co_partidas.debe), SUM(co_partidas.haber), SUM(co_partidas.debe)-SUM(co_partidas.haber)");
	q.setWhere(where + " group by " + groupBy + " ORDER BY " + orderBy);
	
	if (!q.exec()) {
		MessageBox.critical(util.translate("scripts", "Fall la consulta"),
				MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
		return;
	}

 	util.createProgressDialog( util.translate( "scripts", "Recabando datos..." ), q.size() );
	var codCuenta:String;
	
	var curTab:FLSqlCursor = new FLSqlCursor("co_i_balancesis_buffer");
 	var paso:Number = 0;	
	
// 	var xmlKD:FLDomDocument = new FLDomDocument;
// 	xmlKD.setContent("<!DOCTYPE KUGAR_DATA><KugarData/>");
// 	var nodoRow:FLDomNode;
// 	var eRow:FLDomElement;
	var codCuentaAnt:String = "";
	while(q.next()) {

		util.setProgress(paso++);
		
		codSubcuenta = q.value(2);
		if (nivel == 0)
			codCuenta = q.value(0);
		else
			codCuenta = codSubcuenta.left(nivel);
		
		switch(nivel) {
			case 0:
				descCuenta = util.sqlSelect("co_cuentas", "descripcion", "codcuenta = '" + codCuenta + "' AND codejercicio = '" + ejAct + "'");
			break;				
			case 2:
				descCuenta = util.sqlSelect("co_epigrafes", "descripcion", "codepigrafe = '" + codCuenta + "' AND codejercicio = '" + ejAct + "'");
			break;				
			case 3:
				descCuenta = util.sqlSelect("co_cuentas", "descripcion", "codcuenta LIKE '" + codCuenta + "%' AND codejercicio = '" + ejAct + "'");
			break;				
			case 4:
			case 5:
				descCuenta = util.sqlSelect("co_cuentas", "descripcion", "codcuenta = '" + codCuenta + "' AND codejercicio = '" + ejAct + "'");
				if (!descCuenta)
					descCuenta = util.sqlSelect("co_cuentas", "descripcion", "codcuenta LIKE '" + codCuenta.left(3) + "%' AND codejercicio = '" + ejAct + "'");
			break;				
		}
		
		if (!descCuenta)
			descCuenta = q.value(3); 
		
		curTab.select("idimpresion = '" + idImpresion + "' AND codsubcuenta = '" + codSubcuenta + "'");
// 		nodoRow = this.iface.dameNodoXML(xmlKD.firstChild(), "Row[@co_i_balancesis_buffer.codsubcuenta=" + codSubcuenta + "]");
			
		if (curTab.first()/* && nodoRow*/) {
			/// Con tabla
			curTab.setModeAccess(curTab.Edit);
			curTab.refreshBuffer();
			curTab.setValueBuffer("debe", parseFloat(curTab.valueBuffer("debe")) + parseFloat(q.value(4)));
			curTab.setValueBuffer("haber", parseFloat(curTab.valueBuffer("haber")) + parseFloat(q.value(5)));
			curTab.setValueBuffer("saldo", parseFloat(curTab.valueBuffer("saldo")) + parseFloat(q.value(6)));
			/// Con XML
// 			eRow = nodoRow.toElement();
// 			eRow.setAttribute("co_i_balancesis_buffer.debe", parseFloat(eRow.attribute("co_i_balancesis_buffer.debe")) + parseFloat(q.value(4)));
// 			eRow.setAttribute("co_i_balancesis_buffer.haber", parseFloat(eRow.attribute("co_i_balancesis_buffer.haber")) + parseFloat(q.value(5)));
// 			eRow.setAttribute("co_i_balancesis_buffer.saldo", parseFloat(eRow.attribute("co_i_balancesis_buffer.saldo")) + parseFloat(q.value(6)));
		} else {
			/// Con tabla
			curTab.setModeAccess(curTab.Insert);
			curTab.refreshBuffer();
			curTab.setValueBuffer("idimpresion", idImpresion);
			curTab.setValueBuffer("codsubcuenta", codSubcuenta);
			curTab.setValueBuffer("codcuenta", codCuenta);
			curTab.setValueBuffer("descripcion", q.value(3));
			curTab.setValueBuffer("descripcioncuenta", descCuenta);
			curTab.setValueBuffer("debe", q.value(4));
			curTab.setValueBuffer("haber", q.value(5));
			curTab.setValueBuffer("saldo", q.value(6));
			/// Con XML
// 			if (codCuenta != codCuentaAnt) {
// 				level = 0;
// 			} else {
// 				level = 1;
// 				codCuenta = codCuentaAnt;
// 			}
// 			nodoRow = this.iface.crearNodoRow();
// 			xmlKD.firstChild().appendChild(nodoRow);
// 			eRow = nodoRow.toElement();
// 			eRow.setAttribute("empresa.nombre", flfactppal.iface.valorDefectoEmpresa("nombre"));
// 			eRow.setAttribute("co_i_balancesis_buffer.codcuenta", codCuenta);
// 			eRow.setAttribute("co_i_balancesis_buffer.codsubcuenta", codSubcuenta);
// 			eRow.setAttribute("co_i_balancesis_buffer.descripcion", q.value(3));
// 			eRow.setAttribute("co_i_balancesis_buffer.descripcioncuenta", descCuenta);
// 			eRow.setAttribute("co_i_balancesis_buffer.debe", q.value(4));
// 			eRow.setAttribute("co_i_balancesis_buffer.haber", q.value(5));
// 			eRow.setAttribute("co_i_balancesis_buffer.saldo", q.value(6));
// 			eRow.setAttribute("level", level);
// 			if (level == 0) {
// 				var nodoL1:FLDomNode = nodoRow.cloneNode();
// 				nodoL1.toElement().setAttribute("level", 1);
// 				xmlKD.firstChild().appendChild(nodoL1);
// 			}
		}
		
		curTab.commitBuffer();
	}
	
	util.destroyProgressDialog();
// 	return xmlKD;
}

// function oficial_crearNodoRow():FLDomNode
// {
// 	var xmlRow:FLDomDocument = new FLDomDocument;
// 	xmlRow.setContent("<Row/>");
// 	return xmlRow.firstChild();
// }

function oficial_quitarAsientos(codEjercicio:String):String
{
	var util:FLUtil = new FLUtil;
	var cursor:FLSqlCursor = this.cursor();

	var listaAsientos:String = "";
	var asientoPyG:String;
	var asientoCierre:String;
	
	if (cursor.valueBuffer("ignorarcierre")) {
		asientoPyG = util.sqlSelect("ejercicios", "idasientopyg", "codejercicio = '" + codEjercicio + "'");
		if (!asientoPyG) {
			asientoPyG = -1;
		}
		asientoCierre = util.sqlSelect("ejercicios", "idasientocierre", "codejercicio = '" + cursor.valueBuffer("i_co__subcuentas_codejercicio") + "'");
		if (!asientoCierre) {
			asientoCierre = -1;
		}
	
		listaAsientos += asientoPyG + ", "	+ asientoCierre;
	}
	return listaAsientos;
}


/** \C Busca un nodo en un nodo y sus nodos hijos
@param	nodoPadre: Nodo que contiene el nodo a buscar (o los nodos hijos que lo contienen)
@param	ruta: Cadena que especifica la ruta a seguir para encontrar el atributo. Su formato es NodoPadre/NodoHijo/NodoNieto/.../Nodo. Puede ser tan larga como sea necesario. Siempre se toma el primer nodo Hijo que tiene el nombre indicado.
@param	debeExistir: Si vale true la funcin devuelve false si no encuentra el atributo
@return	Nodo buscado o false si hay error o no se encuentra el nodo
\end */
// function oficial_dameNodoXML(nodoPadre:FLDomNode, ruta:String, debeExistir:Boolean):FLDomNode
// {
// 	var util:FLUtil = new FLUtil;
// 
// 	var valor:String;
// 	var nombreNodo:Array = ruta.split("/");
// 	var nodoXML:FLDomNode = nodoPadre;
// 	var i:Number;
// 	var nombreActual:String;
// 	var iInicioCorchete:Number
// 	for (i = 0; i < nombreNodo.length; i++) {
// 		nombreActual = nombreNodo[i];
// 		iInicioCorchete = nombreActual.find("[");
// 		if (iInicioCorchete > -1) {
// 			iFinCorchete = nombreActual.find("]");
// 			var condicion:String = nombreActual.substring(iInicioCorchete + 1, iFinCorchete);
// 			var paramCond:Array = condicion.split("=");
// 			if (!paramCond[0].startsWith("@")) {
// 				MessageBox.warning(util.translate("scripts", "Error al procesar la ruta XML %1 en %2").arg(ruta).arg(nombreActual), MessageBox.Ok, MessageBox.NoButton);
// 				return false;
// 			}
// 			nombreActual = nombreActual.left(iInicioCorchete);
// 			var atributo:String = paramCond[0].right(paramCond[0].length - 1);
// 			var nodoHijo:FLDomNode;
// 			for (nodoHijo = nodoXML.firstChild(); nodoHijo; nodoHijo = nodoHijo.nextSibling()) {
// 				if (nodoHijo.nodeName() == nombreActual && nodoHijo.toElement().attribute(atributo) == paramCond[1]) {
// 					break;
// 				}
// 			}
// 			if (nodoHijo) {
// 				nodoXML = nodoHijo;
// 			} else {
// 				if (debeExistir) {
// 					MessageBox.warning(util.translate("scripts", "No se encontr el nodo en la ruta ruta %1").arg(ruta), MessageBox.Ok, MessageBox.NoButton);
// 				}
// 				return false;
// 			}
// 		} else {
// 			nodoXML = nodoXML.namedItem(nombreActual)
// 			if (!nodoXML) {
// 				if (debeExistir) {
// 					MessageBox.warning(util.translate("scripts", "No se pudo leer el nodo de la ruta:\n%1.\nNo se encuentra el nodo <%2>").arg(ruta).arg(nombreNodo[i]), MessageBox.Ok, MessageBox.NoButton);
// 				}
// 				return false;
// 			}
// 		}
// 	}
// 	return nodoXML;
// }

//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition column0 */
/////////////////////////////////////////////////////////////////
//// COLUMN0 ///////////////////////////////////////////////////

function column0_filtroTabla():String
{
        var filtro:String = "";
        var col = flfactppal.iface.pub_valorDefectoEmpresa("column0");
        if (col == "1"){
                filtro = "i_co__asientos_column0 = '1'";
        }
        return filtro;
}

function column0_rellenarDatos(idImpresion:String, cursor:FLSqlCursor):FLDomDocument
{
        var util:FLUtil = new FLUtil;
        
        if (!util.sqlDelete("co_i_balancesis_buffer", "idimpresion = '" + idImpresion + "'")) {
            return;
        }

        var groupBy:String = "co_cuentas.codcuenta, co_cuentas.descripcion, co_subcuentas.codsubcuenta, co_subcuentas.descripcion";
        var orderBy:String = "co_cuentas.codcuenta, co_cuentas.descripcion, co_subcuentas.codsubcuenta, co_subcuentas.descripcion";

        var ejAct:String = cursor.valueBuffer("i_co__subcuentas_codejercicio");
        var desdeAct:String = cursor.valueBuffer("d_co__asientos_fecha");
        var hastaAct:String = cursor.valueBuffer("h_co__asientos_fecha");
        var desdeScta:String = cursor.valueBuffer("d_co__subcuentas_codsubcuenta");
        var hastaScta:String = cursor.valueBuffer("h_co__subcuentas_codsubcuenta");
        
        var control:String = cursor.valueBuffer("i_co__asientos_column0");
         
        var nivel:Number
        
        // Subcuenta por compatibilidad hacia atras
        if (cursor.valueBuffer("nivel") == "Cuenta" || cursor.valueBuffer("nivel") == "Subcuenta")
                nivel = 0;
        else
                nivel = parseFloat(cursor.valueBuffer("nivel"));
                
        var where:String = "(co_asientos.codejercicio = '" + ejAct + "'" +
                " AND co_asientos.fecha >= '" + desdeAct + "'" +
                " AND co_asientos.fecha <= '" + hastaAct + "'";
                 
        if (desdeScta)
                where += " AND co_partidas.codsubcuenta >= '" + desdeScta + "'";
                
        if (hastaScta)
                where += " AND co_partidas.codsubcuenta <= '" + hastaScta + "'";
        
        var listaAsientos:String = this.iface.quitarAsientos(ejAct);
        if (listaAsientos && listaAsientos != "") {
                where += " AND co_asientos.idasiento NOT IN (" + listaAsientos + ")";
        }

        if (control=="1" || control=="2"){
                where += " AND co_asientos.column0 = '"+control+"'";
        }
        
        where += ")";


        var consolidar:Boolean = false;
        if (cursor.valueBuffer("ejercicioanterior") == 1)
                        consolidar = true;

        if (consolidar) {
                var ejAnt:String = cursor.valueBuffer("codejercicioant");
                var desdeAnt:String = cursor.valueBuffer("fechaant_d");
                var hastaAnt:String = cursor.valueBuffer("fechaant_h");
                desdeScta = cursor.valueBuffer("d_co__subcuentas_codsubcuenta");
                hastaScta = cursor.valueBuffer("h_co__subcuentas_codsubcuenta");
                        
                where +=  " OR (co_asientos.codejercicio = '" + ejAnt + "'" +
                        " AND co_asientos.fecha >= '" + desdeAnt + "'" +
                        " AND co_asientos.fecha <= '" + hastaAnt + "'" +
                        " AND co_partidas.codsubcuenta >= '" + desdeScta + "'" +
                        " AND co_partidas.codsubcuenta <= '" + hastaScta + "'";
                
                var listaAsientosAnt:String = this.iface.quitarAsientos(ejAnt);
                if (listaAsientosAnt && listaAsientosAnt != "") {
                        where += " AND co_asientos.idasiento NOT IN (" + listaAsientos + ")";
                }

                where += ")";
        }
        
        var q:FLSqlQuery = new FLSqlQuery();
        q.setTablesList("co_cuentas,co_subcuentas,co_partidas,co_asientos");
        q.setFrom("co_cuentas INNER JOIN co_subcuentas ON co_cuentas.idcuenta = co_subcuentas.idcuenta INNER JOIN co_partidas ON co_subcuentas.idsubcuenta = co_partidas.idsubcuenta INNER JOIN co_asientos ON co_partidas.idasiento = co_asientos.idasiento");
        q.setSelect("co_cuentas.codcuenta, co_cuentas.descripcion, co_subcuentas.codsubcuenta, co_subcuentas.descripcion, SUM(co_partidas.debe), SUM(co_partidas.haber), SUM(co_partidas.debe)-SUM(co_partidas.haber)");
        q.setWhere(where + " group by " + groupBy + " ORDER BY " + orderBy);
        
        if (!q.exec()) {
                MessageBox.critical(util.translate("scripts", "Fall la consulta"),
                                MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
                return;
        }

        util.createProgressDialog( util.translate( "scripts", "Recabando datos..." ), q.size() );
        var codCuenta:String;
        
        var curTab:FLSqlCursor = new FLSqlCursor("co_i_balancesis_buffer");
        var paso:Number = 0;    
        
        var codCuentaAnt:String = "";
        while(q.next()) {

                util.setProgress(paso++);
                
                codSubcuenta = q.value(2);
                if (nivel == 0)
                        codCuenta = q.value(0);
                else
                        codCuenta = codSubcuenta.left(nivel);
                
                switch(nivel) {
                        case 0:
                                descCuenta = util.sqlSelect("co_cuentas", "descripcion", "codcuenta = '" + codCuenta + "' AND codejercicio = '" + ejAct + "'");
                        break;                          
                        case 2:
                                descCuenta = util.sqlSelect("co_epigrafes", "descripcion", "codepigrafe = '" + codCuenta + "' AND codejercicio = '" + ejAct + "'");
                        break;                          
                        case 3:
                                descCuenta = util.sqlSelect("co_cuentas", "descripcion", "codcuenta LIKE '" + codCuenta + "%' AND codejercicio = '" + ejAct + "'");
                        break;                          
                        case 4:
                        case 5:
                                descCuenta = util.sqlSelect("co_cuentas", "descripcion", "codcuenta = '" + codCuenta + "' AND codejercicio = '" + ejAct + "'");
                                if (!descCuenta)
                                        descCuenta = util.sqlSelect("co_cuentas", "descripcion", "codcuenta LIKE '" + codCuenta.left(3) + "%' AND codejercicio = '" + ejAct + "'");
                        break;                          
                }
                
                if (!descCuenta)
                        descCuenta = q.value(3); 
                
                curTab.select("idimpresion = '" + idImpresion + "' AND codsubcuenta = '" + codSubcuenta + "'");
                        
                if (curTab.first()) {
                        /// Con tabla
                        curTab.setModeAccess(curTab.Edit);
                        curTab.refreshBuffer();
                        curTab.setValueBuffer("debe", parseFloat(curTab.valueBuffer("debe")) + parseFloat(q.value(4)));
                        curTab.setValueBuffer("haber", parseFloat(curTab.valueBuffer("haber")) + parseFloat(q.value(5)));
                        curTab.setValueBuffer("saldo", parseFloat(curTab.valueBuffer("saldo")) + parseFloat(q.value(6)));
                } else {
                        /// Con tabla
                        curTab.setModeAccess(curTab.Insert);
                        curTab.refreshBuffer();
                        curTab.setValueBuffer("idimpresion", idImpresion);
                        curTab.setValueBuffer("codsubcuenta", codSubcuenta);
                        curTab.setValueBuffer("codcuenta", codCuenta);
                        curTab.setValueBuffer("descripcion", q.value(3));
                        curTab.setValueBuffer("descripcioncuenta", descCuenta);
                        curTab.setValueBuffer("debe", q.value(4));
                        curTab.setValueBuffer("haber", q.value(5));
                        curTab.setValueBuffer("saldo", q.value(6));
                }
                
                curTab.commitBuffer();
        }
        
        util.destroyProgressDialog();
}

function column0_quitarAsientos(codEjercicio:String):String
{
    var util:FLUtil = new FLUtil;
    var cursor:FLSqlCursor = this.cursor();

    var listaAsientos:String = "";
    var asientoPyG:String;
    var asientoCierre:String;
    var asientoPyGT:String;
    var asientoCierreT:String;
        
    if (cursor.valueBuffer("ignorarcierre")) {
        asientoPyG = util.sqlSelect("ejercicios", "idasientopyg", "codejercicio = '" + codEjercicio + "'");
        if (!asientoPyG) {
                asientoPyG = -1;
        }
        asientoCierre = util.sqlSelect("ejercicios", "idasientocierre", "codejercicio = '" + cursor.valueBuffer("i_co__subcuentas_codejercicio") + "'");
        if (!asientoCierre) {
                asientoCierre = -1;
        }
        
        asientoPyGT = util.sqlSelect("ejercicios", "idasientopygt", "codejercicio = '" + codEjercicio + "'");
        if (!asientoPyGT) {
                asientoPyGT = -1;
        }
        
        asientoCierreT = util.sqlSelect("ejercicios", "idasientocierret", "codejercicio = '" + cursor.valueBuffer("i_co__subcuentas_codejercicio") + "'");
        if (!asientoCierreT) {
                asientoCierreT = -1;
        }
    
        listaAsientos += asientoPyG + "," + asientoCierre + "," +asientoPyGT + "," + asientoCierreT;
    }
    
    return listaAsientos;
}
//// COLUMN0 ///////////////////////////////////////////////////
///////////////////////////////////////////////////////////////

/** @class_definition jrpt */
/////////////////////////////////////////////////////////////////
//// JRPT //////////////////////////////////////////////////////
function jrpt_lanzar()
{
    var util:FLUtil = new FLUtil;

    var cursor:FLSqlCursor = this.cursor()
    if (!cursor.isValid())
        return;
    
    if (cursor.valueBuffer("outputformat") == "kut") {
        return this.iface.__lanzar();
    }
    
    var util:FLUtil = new FLUtil;
    util.createProgressDialog( util.translate( "scripts", "Estableciendo parmetros de informe..." ), 11 );
	util.setProgress(3);
    var ahora:Date = new Date;
    var idImpresion:String = cursor.valueBuffer("id");
    idImpresion += sys.nameUser();

    var datos:Array = this.iface.establecerDatosInforme(cursor,idImpresion);
    var calculado:Number = util.sqlSelect(datos.tablaBuffer,"count(id)","idimpresion='"+idImpresion+"'");
    if (!calculado) calculado=0;
	
	util.setProgress(10);
	sys.processEvents();
	util.destroyProgressDialog();
	
    if (cursor.valueBuffer("recalculoauto")){
        if (!this.iface.generarDatosInforme(cursor,idImpresion,datos)){
            return false;
        }
    } else if(calculado<1) {
         if (!this.iface.generarDatosInforme(cursor,idImpresion,datos)){
            return false;
        }
    }
    
    var orderByImp:String = "";
    if (cursor.valueBuffer("nivel") == "Cuenta" || cursor.valueBuffer("nivel") == "Subcuenta") {
		orderByImp = " ORDER BY b.codcuenta,b.desccuenta,b.codsubcuenta,b.descsubcuenta";
	} else {
		orderByImp = " ORDER BY v.codnivel1,v.descnivel1,v.codnivel2,v.descnivel2,v.codnivel3,v.descnivel3,v.codnivel4,v.descnivel4,v.codnivel5,v.descnivel5,b.codsubcuenta.b.descsubcuenta";
	}
    
    cursor.setValueBuffer("idimpresion",idImpresion);
	cursor.setValueBuffer("orderbyimp",orderByImp);

    flcontinfo.iface.pub_lanzarInforme(cursor, datos.nombreInforme, datos.nombreReport, "","","", cursor.valueBuffer("id"));
    
    /*if (!flcontinfo.iface.vaciarBufferInforme(datos.tablaBuffer,"idimpresion",idImpresion)){
        return false;
    }*/
    
}

function jrpt_establecerDatosInforme(cursor:FLSqlCursor, idImpresion:Number):Array{
    
    var datos:Array = [];
    
    datos["nombreInforme"] = "co_i_balancesis";
    datos["nombreReport"] = "co_i_balancesis";
	//datos["orderBy"] = " ORDER BY co_cuentas.codcuenta,co_cuentas.descripcion,co_subcuentas.codsubcuenta,co_subcuentas.idsubcuenta,co_subcuentas.descripcion";
	datos["orderBy"] = "";
	datos["groupBy"] = " GROUP BY co_cuentas.codcuenta,co_cuentas.descripcion,co_subcuentas.codsubcuenta,co_subcuentas.idsubcuenta,co_subcuentas.descripcion";
    datos["tablaBuffer"] = "co_i_balancesis_buffer";
    datos["codejercicio"] = cursor.valueBuffer("i_co__subcuentas_codejercicio");
    datos["desdeFecha"] = cursor.valueBuffer("d_co__asientos_fecha");
    datos["hastaFecha"] = cursor.valueBuffer("h_co__asientos_fecha");
    datos["desdeSubcuenta"] = cursor.valueBuffer("d_co__subcuentas_codsubcuenta");
    datos["hastaSubcuenta"] = cursor.valueBuffer("h_co__subcuentas_codsubcuenta");
    datos["ignorarapertura"] = cursor.valueBuffer("ignorarapertura");
    datos["control"] = cursor.valueBuffer("i_co__asientos_column0");
    
    datos["consolidar"] = false;
    if (cursor.valueBuffer("ejercicioanterior") == 1){
        datos["consolidar"] = true;
    }
    
    var util:FLUtil = new FLUtil;
	datos["fechainicioejercicio"] = util.sqlSelect("ejercicios","fechainicio","codejercicio='"+datos["codejercicio"]+"'");
    datos["idasientoapertura"] = util.sqlSelect("ejercicios","idasientoapertura","codejercicio='"+datos["codejercicio"]+"'");
	datos["idasientoaperturat"] = util.sqlSelect("ejercicios","idasientoaperturat","codejercicio='"+datos["codejercicio"]+"'");

    datos["where"] = "";
    datos["masWhere"] = "";
    
    return datos;
    
}

function jrpt_generarDatosInforme(cursor:FLSqlCursor, idImpresion:Number, datos:Array):Boolean{

    /*Genera datos para el ejercicio actual*/
    var actSaldoIni:Boolean = true;
    if (datos["consolidar"] == true) {
        actSaldoIni = false;
    }
    var util:FLUtil = new FLUtil;
    util.createProgressDialog( util.translate( "scripts", "Iniciando buffer ..." ), 11 );
	util.setProgress(3);
	sys.processEvents();
	
    if (!flcontinfo.iface.vaciarBufferInforme(datos.tablaBuffer,"idimpresion",idImpresion)){
		util.destroyProgressDialog();
        return false;
    }
	
	util.setProgress(10);
    
	if (!this.iface.generarDatosInformeEjercicio(cursor, idImpresion, datos, actSaldoIni)){
        return false
    }
    
    if (datos["consolidar"] == true) {
        /*Si es consolidado, genera los datos para el ejercicio anterior*/
        datos["codejercicio"] = cursor.valueBuffer("codejercicioant");
        datos["desdeFecha"] = cursor.valueBuffer("fechaant_d");
        datos["hastaFecha"] = cursor.valueBuffer("fechaant_h");
		datos["fechainicioejercicio"] = util.sqlSelect("ejercicios","fechainicio","codejercicio='"+datos["codejercicio"]+"'");
		datos["idasientoapertura"] = util.sqlSelect("ejercicios","idasientoapertura","codejercicio='"+datos["codejercicio"]+"'");
		datos["idasientoaperturat"] = util.sqlSelect("ejercicios","idasientoaperturat","codejercicio='"+datos["codejercicio"]+"'");
        
        if (!this.iface.generarDatosInformeEjercicio(cursor, idImpresion, datos, true)){
            return false
        }
    }
    
    return true;
}


function jrpt_generarDatosInformeEjercicio(cursor:FLSqlCursor, idImpresion:Number, datos:Array, actSaldoIni:Boolean):Boolean{
	
    var util:FLUtil = new FLUtil;
    util.createProgressDialog( util.translate( "scripts", "Iniciando consulta ..." ), 10 );
    datos["where"] = this.iface.dameWhereSubcuentas(cursor, idImpresion, datos);
    datos["whereasientos"] = this.iface.dameWhereAsientos(cursor, idImpresion, datos);
    util.setProgress(3);
    var q:FLSqlQuery = this.iface.consultaSumasySaldos(cursor,idImpresion,datos);
    if (!q.exec()) {
        MessageBox.critical(util.translate("scripts", "Fall la consulta"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
        debug("Fallo la consulta >>> "+q.sql());
		util.destroyProgressDialog();
        return false;
    }
    
    util.setProgress(10);
    //util.destroyProgressDialog();
	
    if (!this.iface.rellenarDatosJrpt(cursor,idImpresion,datos,q, actSaldoIni)){
        return false;
    }
    
    /*if (!this.iface.actualizarNivelAgrupado(cursor,idImpresion,datos)){
        return false;
    }*/

	
    /*if (actSaldoIni) {
        if (!this.iface.actualizarSaldoInicial(cursor,idImpresion,datos)){
            return false;
        }
    }*/

    if (!this.iface.eliminarSubcuentasCero(cursor,idImpresion,datos)){
        return false;
    }
    
    return true;
}

function jrpt_consultaSumasySaldos(cursor:FLSqlCursor, idImpresion:Number, datos:Array):FLSqlQuery{
    
    /*Se recogen datos para todas las subcuentas del ejercicio independientemente si tienen movimientos en partidas en los plazos indicados en la where*/
    
    var q:FLSqlQuery = new FLSqlQuery();
    q.setTablesList("co_cuentas,co_subcuentas,co_partidas,co_asientos,ejercicios");
    q.setSelect("co_cuentas.codcuenta,co_cuentas.descripcion,co_subcuentas.codsubcuenta,co_subcuentas.idsubcuenta,co_subcuentas.descripcion,coalesce(SUM(x.debe),0),coalesce(SUM(x.haber),0), coalesce(SUM(x.debe)-SUM(x.haber),0) ");
    q.setFrom("co_subcuentas INNER JOIN co_cuentas ON co_subcuentas.idcuenta = co_cuentas.idcuenta INNER JOIN ejercicios ON co_subcuentas.codejercicio=ejercicios.codejercicio LEFT JOIN ( SELECT co_partidas.idsubcuenta, coalesce(SUM(co_partidas.debe),0) as debe,coalesce(SUM(co_partidas.haber),0) as haber FROM co_subcuentas INNER JOIN ejercicios ON co_subcuentas.codejercicio=ejercicios.codejercicio INNER JOIN co_partidas ON co_subcuentas.idsubcuenta = co_partidas.idsubcuenta INNER JOIN co_asientos ON co_partidas.idasiento = co_asientos.idasiento WHERE "+datos["whereasientos"]+ " GROUP BY co_partidas.idsubcuenta ) x ON x.idsubcuenta = co_subcuentas.idsubcuenta");
    q.setWhere(datos["where"] + datos["groupBy"] + datos["orderBy"]);
    
    debug("jrpt_consultaSumasySaldos>>>> "+q.sql());
    return q;
}

function jrpt_dameWhereSubcuentas(cursor:FLSqlCursor, idImpresion:Number, datos:Array):String{
    
    var util:FLUtil = new FLUtil;
    var where:String = " co_subcuentas.codejercicio = '" + datos.codejercicio + "'";
    
    if (datos.desdeSubcuenta) {
        where += " AND co_subcuentas.codsubcuenta >= '" + datos.desdeSubcuenta + "'";
    }
                
    if (datos.hastaSubcuenta){
        where += " AND co_subcuentas.codsubcuenta <= '" + datos.hastaSubcuenta + "'";
    }
    
    return where;
}

function jrpt_dameWhereAsientos(cursor:FLSqlCursor, idImpresion:Number, datos:Array):String{
    
    var util:FLUtil = new FLUtil;
        
    var where:String = "co_asientos.codejercicio = '" + datos.codejercicio + "'" +
                " AND co_asientos.fecha >= '" + datos.desdeFecha + "'" +
                " AND co_asientos.fecha <= '" + datos.hastaFecha + "'";
                
    if (datos.control=="1" || datos.control=="2"){
        where += " AND co_asientos.column0 = '"+datos.control+"'";
    }                
    
    if (datos.desdeSubcuenta) {
        where += " AND co_partidas.codsubcuenta >= '" + datos.desdeSubcuenta + "'";
    }
                
    if (datos.hastaSubcuenta){
        where += " AND co_partidas.codsubcuenta <= '" + datos.hastaSubcuenta + "'";
    }
        
    
    if (cursor.valueBuffer("ignorarcierre")) {
        where += " AND co_asientos.idasiento != COALESCE(ejercicios.idasientopyg,-1) AND co_asientos.idasiento != COALESCE(ejercicios.idasientocierre,-1)";
        where += " AND co_asientos.idasiento != COALESCE(ejercicios.idasientopygt,-1) AND co_asientos.idasiento != COALESCE(ejercicios.idasientocierret,-1)";
    }
    
    var ignorarApertura:Boolean = false;
    if(datos.ignorarapertura) {
        ignorarApertura = true;
    } else if (cursor.valueBuffer("saldoinicial") || cursor.valueBuffer("asignarsaldoinicial")) {
        /*Si no hay que ignorar el asiento de apertura pero hay que calcular el saldo inicial, se ignora el asiento de apertura en el clculo de debe y haber para no duplicar el importe cuando se sume el saldo inicial al saldo*/
        ignorarApertura = true;
    }
    
    if (ignorarApertura) {
        where += " AND co_asientos.idasiento != COALESCE(ejercicios.idasientoapertura,-1)";
        where += " AND co_asientos.idasiento != COALESCE(ejercicios.idasientoaperturat,-1)";
    }
    
    //debug("jrpt_dameWhereAsientos>>> "+where);
    return where;
    
}

function jrpt_rellenarDatosJrpt(cursor:FLSqlCursor, idImpresion:Number, datos:Array, q:FLSqlQuery, actSaldoIni:Boolean):Boolean{
        
    var util:FLUtil = new FLUtil;
    var paso:Number = 1;
	var mod:Number = 10;
	
    var debe:Number, haber:Number, saldo:Number;
	var saldoInicial:Number;

	util.destroyProgressDialog();
    util.createProgressDialog( util.translate( "scripts", "Recabando datos..." ), q.size() );
	if (q.size()>10000) {
		mod = 100;
		util.setProgress(5);
	} else {
		util.setProgress(2);
	}
	sys.processEvents();
	sys.processEvents();
	
	var curTab:FLSqlCursor = new FLSqlCursor(datos.tablaBuffer);
    curTab.setActivatedCheckIntegrity(false);
	
	while(q.next()) {
		if (paso%mod==0) util.setProgress(paso);
		paso++;
        debe = util.roundFieldValue(q.value(5), "co_subcuentas", "debe");
        haber = util.roundFieldValue(q.value(6), "co_subcuentas", "haber");
        saldo = util.roundFieldValue(q.value(7), "co_subcuentas", "saldo");
		saldoInicial = 0;
		
		if (actSaldoIni) {
			if (cursor.valueBuffer("asignarsaldoinicial")){
				saldoInicial = parseFloat(cursor.valueBuffer("importesaldoinicial"));
			} else {
				saldoInicial = this.iface.calcularSaldoInicial(q.value(3),datos);
			}
			if (!saldoInicial || isNaN(saldoInicial)){
				saldoInicial = 0;
			}
		}
        
        curTab.setModeAccess(curTab.Insert);
        curTab.refreshBuffer();
        curTab.setValueBuffer("idimpresion", idImpresion);
        curTab.setValueBuffer("codejercicio", datos.codejercicio);
        curTab.setValueBuffer("codcuenta", q.value(0));
        curTab.setValueBuffer("descripcioncuenta", q.value(1));
        curTab.setValueBuffer("codsubcuenta", q.value(2));
		curTab.setValueBuffer("idsubcuenta", q.value(3));
        curTab.setValueBuffer("descripcion", q.value(4));
        curTab.setValueBuffer("debe", debe);
        curTab.setValueBuffer("haber", haber);
        curTab.setValueBuffer("saldo", saldo);
		curTab.setValueBuffer("saldoinicial",saldoInicial);
		
		
        if (!curTab.commitBuffer()) {
            debug("fallo rellenarDatos para subcuenta = "+q.value(0));
            util.destroyProgressDialog();
            return false;
        }
    }
    curTab.setActivatedCheckIntegrity(true);
    util.destroyProgressDialog();

    return true;
}
        
    
function jrpt_actualizarNivelAgrupado(cursor:FLSqlCursor, idImpresion:Number, datos:Array):Boolean{
    
    var nivel:Number;
    if (cursor.valueBuffer("nivel") == "Cuenta" || cursor.valueBuffer("nivel") == "Subcuenta") {
        nivel = 0;
    } else {
        nivel = parseFloat(cursor.valueBuffer("nivel"));
    }
    
    if (nivel == 0) {
        /* Si el nivel de agrupacin es por cuenta o por subcuenta, el buffer ya tiene los valores correctos*/
        return true;
    }
    
    var util:FLUtil = new FLUtil;
    var paso:Number = 1;    
    var codSubcuenta:String;
    var codCuenta:String;
    var descCuenta:String;
                
    var curTab:FLSqlCursor = new FLSqlCursor(datos.tablaBuffer);
    curTab.setActivatedCheckIntegrity(false);
    curTab.select("idimpresion = '" + idImpresion + "' and codejercicio ='"+datos.codejercicio+"'");
    util.createProgressDialog( util.translate( "scripts", "Actualizando datos..." ), curTab.size() );
    
    while (curTab.next()) {
        util.setProgress(paso++);
        codSubcuenta = curTab.valueBuffer("codsubcuenta");
        codCuenta = codSubcuenta.left(nivel);
        switch(nivel) {
            case 2:
                descCuenta = util.sqlSelect("co_epigrafes", "descripcion", "codepigrafe = '" + codCuenta + "' AND codejercicio = '" + curTab.valueBuffer("codejercicio") + "'");
                break;                          
                
            case 3:
                descCuenta = util.sqlSelect("co_cuentas", "descripcion", "codcuenta LIKE '" + codCuenta + "%' AND codejercicio = '" + curTab.valueBuffer("codejercicio") + "'");
                break;                          
            
            case 4:
            case 5:
                descCuenta = util.sqlSelect("co_cuentas", "descripcion", "codcuenta = '" + codCuenta + "' AND codejercicio = '" + curTab.valueBuffer("codejercicio") + "'");
                if (!descCuenta){
                    descCuenta = util.sqlSelect("co_cuentas", "descripcion", "codcuenta LIKE '" + codCuenta.left(3) + "%' AND codejercicio = '" + curTab.valueBuffer("codejercicio") + "'");
                }
                break;                          
        }
                
        if (!descCuenta)
            descCuenta = ""; 
        
        curTab.setModeAccess(curTab.Edit);
        curTab.refreshBuffer();
        curTab.setValueBuffer("codcuenta",codCuenta);
        curTab.setValueBuffer("descripcioncuenta",descCuenta);
        if (!curTab.commitBuffer()){
            debug("Error actualizando cuenta para "+codSubcuenta);
            util.destroyProgressDialog();
            return false;
        }
    }
    curTab.setActivatedCheckIntegrity(true);
    util.destroyProgressDialog();
    
    return true;
}

function jrpt_actualizarSaldoInicial(cursor:FLSqlCursor, idImpresion:Number, datos:Array):Boolean{
    
    var util:FLUtil = new FLUtil;
    if (cursor.valueBuffer("asignarsaldoinicial")){
        util.sqlUpdate(datos.tablaBuffer,"saldoinicial",parseFloat(cursor.valueBuffer("importesaldoinicial")),"idimpresion='"+idImpresion+"' and codejercicio ='"+ datos.codejercicio +"'");
    } else if (cursor.valueBuffer("saldoinicial")){
        var util:FLUtil = new FLUtil;
        var paso:Number = 1;    
		var mod:Number = 1;
        var saldoInicial:Number;
                
        var curTab:FLSqlCursor = new FLSqlCursor(datos.tablaBuffer);
        curTab.setActivatedCheckIntegrity(false);
        curTab.select("idimpresion = '" + idImpresion + "' and codejercicio='"+datos.codejercicio+"'");
        util.createProgressDialog( util.translate( "scripts", "Actualizando saldos..." ), curTab.size() );	
		
		if (curTab.size()>100) {
			mod = 100;
			util.setProgress(5);
		} else {
			util.setProgress(1);
		}
		
		
        while (curTab.next()) {
			if (paso%mod) util.setProgress(paso);
			paso++;
            saldoInicial = this.iface.calcularSaldoInicial(curTab.valueBuffer("idsubcuenta"),datos);
            if (!saldoInicial || isNaN(saldoInicial)){
                saldoInicial = 0;
            }
            
            curTab.setModeAccess(curTab.Edit);
            curTab.refreshBuffer();
            curTab.setValueBuffer("saldoinicial",saldoInicial);
            if (!curTab.commitBuffer()){
                debug("Error actualizando saldo Inicial para "+curTab.valueBuffer("codsubcuenta"));
                util.destroyProgressDialog();
                return false;
            }
        }
		
        curTab.setActivatedCheckIntegrity(true);
        util.destroyProgressDialog();
    }
    
    return true;
    
}
    

function jrpt_calcularSaldoInicial(idSubcuenta:String,datos:Array):Number{
	
    var util:FLUtil = new FLUtil;
    var saldoApertura:Number;
    var saldoInicial:Number;
    var totalSaldo:Number = 0;
    
	var qA:FLSqlQuery = this.iface.consultaSaldoApertura(idSubcuenta,datos);
    
	var qI:FLSqlQuery = this.iface.consultaSaldoInicial(idSubcuenta,datos);
    
    if (!qA.exec()) {
		MessageBox.critical(util.translate("scripts", "Fall la consulta de saldo de apertura para subcuenta %1 en el ejercicio %2").arg(idSubcuenta).arg(datos.codejercicio),MessageBox.Ok,MessageBox.NoButton);
    }
    
    if (!qI.exec()) {
		MessageBox.critical(util.translate("scripts", "Fall la consulta de saldo inicial para subcuenta %1 en el ejercicio %2").arg(idSubcuenta).arg(datos.codejercicio),MessageBox.Ok,MessageBox.NoButton);
    }
    //debug("qA.sql()>> "+qA.sql());
    if (qA.first()){
        saldoApertura = qA.value(0);
        if (!saldoApertura || isNaN(saldoApertura)){
            saldoApertura = 0;
        }
    }
    //debug("qI.sql()>> "+qA.sql());
    if (qI.first()){
        saldoInicial = qI.value(0);
        if (!saldoInicial || isNaN(saldoInicial)){
            saldoInicial = 0;
        }
    }        
    
    totalSaldo += parseFloat(saldoInicial);
    if (!datos["ignorarapertura"]){
        totalSaldo += parseFloat(saldoApertura);
    }
    
    totalSaldo = util.roundFieldValue(totalSaldo, "co_i_balancesis_buffer", "saldoinicial");
    
    return totalSaldo;

}

function jrpt_consultaSaldoApertura(idSubcuenta:String,datos:Array):FLSqlQuery{
    
	var whereApertura = this.iface.dameWhereApertura(idSubcuenta,datos);
    var qA:FLSqlQuery = new FLSqlQuery();
    qA.setTablesList("co_partidas,co_asientos");
    qA.setSelect("coalesce(sum(coalesce(debe,0))-sum(coalesce(haber,0)),0)");
    //qA.setFrom("co_partidas INNER JOIN co_asientos ON co_partidas.idasiento = co_asientos.idasiento INNER JOIN ejercicios ON ejercicios.codejercicio = co_asientos.codejercicio INNER JOIN ejercicios e2 ON e2.codejercicio = co_asientos.codejercicio");
	qA.setFrom("co_partidas INNER JOIN co_asientos ON co_partidas.idasiento = co_asientos.idasiento");
    qA.setWhere(whereApertura);
    return qA;
}

function jrpt_dameWhereApertura(idSubcuenta:String, datos:Array):String {
    
    var where:String;
   // if (datos.control == "1") {
		where = "co_asientos.idasiento = "+datos["idasientoapertura"]+" AND co_partidas.idsubcuenta = "+idSubcuenta+"  GROUP BY co_partidas.idsubcuenta";
   // } else {
	//	where = "(co_asientos.idasiento = "+datos["idasientoapertura"]+" OR co_asientos.idasiento = "+datos["idasientoaperturat"]+" AND co_partidas.idsubcuenta = "+idSubcuenta+ " GROUP BY co_partidas.idsubcuenta";
   // }
    
    return where;
}

function jrpt_consultaSaldoInicial(idSubcuenta:String,datos:Array):FLSqlQuery{

	var whereSI = this.iface.dameWhereSaldoInicial(idSubcuenta,datos);
    var qI:FLSqlQuery = new FLSqlQuery();
    qI.setTablesList("co_partidas,co_asientos");
    qI.setSelect("coalesce(sum(coalesce(debe,0))-sum(coalesce(haber,0)),0)");
    qI.setFrom("co_partidas INNER JOIN co_asientos ON co_partidas.idasiento = co_asientos.idasiento");
    qI.setWhere(whereSI);
    
    return qI;
}

function jrpt_dameWhereSaldoInicial(idSubcuenta:String, datos:Array):String {
    
    var where:String;
    var masWhereControl:String= "";
    if (datos.control=="1" || datos.control == "2") {
        masWhereControl = " AND co_asientos.column0 = '"+datos.control+"'";
    }
    where = "co_asientos.fecha between '"+datos["fechainicioejercicio"]+"'::date AND (('"+datos.desdeFecha+"'::date)- 1) AND co_asientos.codejercicio='"+datos.codejercicio+"' AND co_asientos.idasiento != COALESCE("+datos["idasientoapertura"]+",-1) AND co_asientos.idasiento != COALESCE("+datos["idasientoaperturat"]+",-1) AND co_partidas.idsubcuenta = "+idSubcuenta+" "+masWhereControl+" GROUP BY co_partidas.idsubcuenta";
    
    return where;
}

function jrpt_eliminarSubcuentasCero(cursor:FLSqlCursor, idImpresion:Number, datos:Array):Boolean{

   var util:FLUtil = new FLUtil;
    /*Como la generacin inicial de la tabla de buffer se hace para todas las subcuentas del ejercicio para evitar ignorar subcuentas sin movimiento entre fechas pero con saldo inicial, al final se eliminan las subcuentas que no tuviesen ni saldo inicial ni movimientos*/
    
    var where:String = "idimpresion='"+idImpresion+"' AND codejercicio ='"+datos.codejercicio+"' AND (saldoinicial = 0 AND debe = 0 AND haber = 0 AND saldo = 0)";
    
    /*Excluye subcuentas con saldo cero*/
    if (cursor.valueBuffer("excluirsaldocero")){
        where += " OR (saldoinicial+saldo=0)";
    }
    
    if (!util.sqlDelete(datos.tablaBuffer,where)){
        return false;
    }
    
    return true;
}

//// JRPT //////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

/** @class_definition mDeposito */
/////////////////////////////////////////////////////////////////
//// M DEPOSITO /////////////////////////////////////////////////
function mDeposito_init()
{
    this.iface.__init();    
    
    this.iface.comprobarDocsDeposito();
}

function mDeposito_comprobarDocsDeposito()
{
    var util:FLUtil = new FLUtil();
    var cursor:FLSqlCursor = this.cursor();
    var mDeposito:String = util.readSettingEntry("scripts/flfacturac/mDeposito");
    var filtro:String = this.iface.filtroTabla();
    
    if (mDeposito!="Si") {
        if (filtro) filtro += " AND ";
        filtro += "i_co__asientos_column0 = '1'";
    }
    
    cursor.setMainFilter(filtro);
    this.child("tableDBRecords").refresh();
}

function mDeposito_lanzar()
{
    var util:FLUtil = new FLUtil();
    var cursor:FLSqlCursor = this.cursor();
    var mDeposito:String = util.readSettingEntry("scripts/flfacturac/mDeposito");
    
    if (mDeposito!="Si" && cursor.valueBuffer("i_co__asientos_column0")!="1") {
        return false;
    }
    
    return this.iface.__lanzar();
}
//// M DEPOSITO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
