/***************************************************************************
                      vdisco_sepa19b2b.qs  -  description
                             -------------------
    begin                : vie nov 22 2013
    copyright            : (C) 2013 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
  var ctx;
  function interna( context ) { this.ctx = context; }
  function init() { this.ctx.interna_init(); }
        function validateForm() { return this.ctx.interna_validateForm(); }
        function acceptedForm() { return this.ctx.interna_acceptedForm(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
        var xml_;
        var extensionFichero_;
        var tipoPago_;
        var tipoFichero_;
        var linea_;
        var aCuentasMandato_;
        var aMandatoElegido_;
        var fechaVenc_;
        var numEfectos_;
        var ePmtInf_;

    function oficial( context ) { interna( context ); }
  function establecerFichero() {
                return this.ctx.oficial_establecerFichero();
        }
        function ficheroTextoPlano(ruta,cursor,fichero) {
                return this.ctx.oficial_ficheroTextoPlano(ruta,cursor,fichero);
        }
        function incluirPresentadorTP(file,cursor,fichero) {
                return this.ctx.oficial_incluirPresentadorTP(file,cursor,fichero);
        }
        function incluirAcreedorTP(file, cursor) {
                return this.ctx.oficial_incluirAcreedorTP(file,cursor);
        }
        function incluirRegistroAdeudoTP(qryRecibos,file,cursor) {
                return this.ctx.oficial_incluirRegistroAdeudoTP(qryRecibos,file,cursor);
        }
        function incluirTotalFechaCobroTP(fechaPago,file,cursor) {
                return this.ctx.oficial_incluirTotalFechaCobroTP(fechaPago,file,cursor);
        }
        function incluirTotalAcreedorTP(file,cursor) {
                return this.ctx.oficial_incluirTotalAcreedorTP(file,cursor);
        }
        function incluirTotalGeneralTP(file,cursor) {
                return this.ctx.oficial_incluirTotalGeneralTP(file,cursor);
        }
        function addCampo(valor,tipo,longitud,file) {
                return this.ctx.oficial_addCampo(valor,tipo,longitud,file);
        }
        function rellenarVacios(valor,tipo,longitud) {
                return this.ctx.oficial_rellenarVacios(valor,tipo,longitud);
        }
        function devolverIdentificadorAcreedor(cursor) {
                return this.ctx.oficial_devolverIdentificadorAcreedor(cursor);
        }
        function ficheroXML(file) {
                return this.ctx.oficial_ficheroXML(file);
        }
        function crearDocumentoXML() {
                return this.ctx.oficial_crearDocumentoXML();
        }
        function incluirCabeceraXML(nodoPadre) {
                return this.ctx.oficial_incluirCabeceraXML(nodoPadre);
        }
        function incluirIdParteXML(nodoPadre) {
                return this.ctx.oficial_incluirIdParteXML(nodoPadre);
        }
        function incluirPersonaJuridicaXML(nodoPadre) {
                return this.ctx.oficial_incluirPersonaJuridicaXML(nodoPadre);
        }
        function incluirPersonaFisicaXML(nodoPadre) {
                return this.ctx.oficial_incluirPersonaFisicaXML(nodoPadre);
        }
        /// Nuevo
        function incluirInformacionPagoXML(nodoPadre, qryRecibos, PmtInfId) {
                return this.ctx.oficial_incluirInformacionPagoXML(nodoPadre, qryRecibos, PmtInfId);
        }
        /*
        function incluirInformacionPagoXML(nodoPadre) {
                return this.ctx.oficial_incluirInformacionPagoXML(nodoPadre);
        }
        */
        ///
        function incluirAcreedorXML(nodoPadre) {
                return this.ctx.oficial_incluirAcreedorXML(nodoPadre);
        }
        function incluirDireccionPostalXML(nodoPadre) {
                return this.ctx.oficial_incluirDireccionPostalXML(nodoPadre);
        }
        /// Nuevo
        function incluirInformacionTipoPagoXML(nodoPadre, qryRecibos) {
                return this.ctx.oficial_incluirInformacionTipoPagoXML(nodoPadre, qryRecibos);
        }
        /*
        function incluirInformacionTipoPagoXML(nodoPadre) {
                return this.ctx.oficial_incluirInformacionTipoPagoXML(nodoPadre);
        }
        */
        /// Fin nuevo
        function incluirOperacionAdeudoXML(nodoPadre,qryRecibos) {
                return this.ctx.oficial_incluirOperacionAdeudoXML(nodoPadre,qryRecibos);
        }
        function incluirDeudorXML(nodoPadre,qryRecibos) {
                return this.ctx.oficial_incluirDeudorXML(nodoPadre,qryRecibos);
        }
        function colgarNodo(nombreHijo, nodoPadre) {
                return this.ctx.oficial_colgarNodo(nombreHijo, nodoPadre);
        }
        function colgarNodoTexto(nodoPadre, valor, tipo, min, max, decimales) {
                return this.ctx.oficial_colgarNodoTexto(nodoPadre, valor, tipo, min, max, decimales);
        }
        function validarTextoNodo(valor, tipo, min, max, decimales) {
                return this.ctx.oficial_validarTextoNodo(valor, tipo, min, max, decimales);
        }
        function formateaFecha(fecha, tipoFecha) {
                return this.ctx.oficial_formateaFecha(fecha, tipoFecha);
        }
        function formateaCadena(c) {
                return this.ctx.oficial_formateaCadena(c);
        }
        function bngFormatoFichero_clicked(opcion) {
                return this.ctx.oficial_bngFormatoFichero_clicked(opcion);
        }
        function bngTipoPago_clicked(opcion) {
                return this.ctx.oficial_bngTipoPago_clicked(opcion);
        }
        function bngTipoFichero_clicked(opcion) {
                return this.ctx.oficial_bngTipoFichero_clicked(opcion);
        }
        function comprobarValidate() {
                return this.ctx.oficial_comprobarValidate();
        }
        function comprobarMandatos() {
                return this.ctx.oficial_comprobarMandatos();
        }
        function tbnExportarErroneos_clicked() {
                return this.ctx.oficial_tbnExportarErroneos_clicked();
        }
        function quitaApostrofes(texto){
                return this.ctx.oficial_quitaApostrofes(texto);
        }
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration mix9049x9043 */
/////////////////////////////////////////////////////////////////
//// MIX_9049_9043 //////////////////////////////////////////////
class mix9049x9043 extends oficial /** %from: oficial */  {
    	function mix9049x9043( context ) { oficial ( context ); }
    	function incluirRegistroAdeudoTP(qryRecibos,file) {
		return this.ctx.mix9049x9043_incluirRegistroAdeudoTP(qryRecibos,file);
	}
	function incluirOperacionAdeudoXML(nodoPadre,qryRecibos) {
		return this.ctx.mix9049x9043_incluirOperacionAdeudoXML(nodoPadre,qryRecibos);
	}

}
////// MIX_9049_9043 //////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

/** @class_declaration mandatoscliCuentas */
/////////////////////////////////////////////////////////////////
//// MANDATOSCLICUENTAS /////////////////////////////////////////
class mandatoscliCuentas extends mix9049x9043 {
        function mandatoscliCuentas( context ) { mix9049x9043 ( context ); }
        function incluirRegistroAdeudoTP(qryRecibos,file,cursor) {
                return this.ctx.mandatoscliCuentas_incluirRegistroAdeudoTP(qryRecibos,file,cursor);
        }
        function incluirInformacionTipoPagoXML(nodoPadre, qryRecibos) {
                return this.ctx.mandatoscliCuentas_incluirInformacionTipoPagoXML(nodoPadre, qryRecibos);
        }
        function incluirOperacionAdeudoXML(nodoPadre,qryRecibos) {
                return this.ctx.mandatoscliCuentas_incluirOperacionAdeudoXML(nodoPadre,qryRecibos);
        }
        function comprobarMandatos() {
                return this.ctx.mandatoscliCuentas_comprobarMandatos();
        }
}
//// MANDATOSCLICUENTAS /////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends mandatoscliCuentas {
        function head( context ) { mandatoscliCuentas ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
  function ifaceCtx( context ) { head( context ); }
}


//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////







const iface = new ifaceCtx( this );

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \D No de muestran los botones estndar de un formulario de registro
\end */
function interna_init()
{
        var _i = this.iface;

        with(form) {
                child("fdbDivisa").setDisabled(true);
                child("fdbCodCuenta").setDisabled(true);
                child("pushButtonAcceptContinue").close();
                child("pushButtonFirst").close();
                child("pushButtonLast").close();
                child("pushButtonNext").close();
                child("pushButtonPrevious").close();
                connect(child("pbExaminar"), "clicked()", _i, "establecerFichero");
        }

        connect(this.child("bngFormatoFichero"), "clicked(int)", _i, "bngFormatoFichero_clicked");
        connect(this.child("bngTipoPago"), "clicked(int)", _i, "bngTipoPago_clicked");
        connect(this.child("bngTipoFichero"), "clicked(int)", _i, "bngTipoFichero_clicked");
        connect(this.child("tbnExportarErroneos"), "clicked()", _i, "tbnExportarErroneos_clicked");

        _i.bngFormatoFichero_clicked(1);
        _i.bngTipoPago_clicked(0);
        _i.bngTipoFichero_clicked(0);

        if (this.child("bngTipoPago")) {
                this.child("bngTipoPago").close();
        }
}

/** \C El nombre del fichero de destino debe indicarse
\end */
function interna_validateForm()
{
        var _i = this.iface;
        var util:FLUtil = new FLUtil;

        if (this.child("leFichero").text.isEmpty()) {
                //sys.warnMsgBox(sys.translate("Debe indicar el fichero."));
                MessageBox.warning(util.translate("scripts", "Debe indicar el fichero"), MessageBox.Ok, MessageBox.NoButton);
                return false;
        }

        if (!this.child("leFichero").text.endsWith("." + _i.extensionFichero_)) {
                this.child("leFichero").text = this.child("leFichero").text + "." + _i.extensionFichero_;
        }

        return true;
}

/** \C Se genera el fichero de texto con los datos de la remesa en el fichero especificado
\end */
function interna_acceptedForm()
{
        var _i = this.iface;
        var cursor = this.cursor();
        var util:FLUtil = new FLUtil;

        if(!_i.comprobarValidate()){
                //sys.errorMsgBox(sys.translate("No se ha podido generar el fichero."));
                MessageBox.warning(util.translate("scripts", "No se ha podido generar el fichero"), MessageBox.Ok, MessageBox.NoButton);
                return false;
        }

        //aCuentasMandato_ = [];
        //aMandatoElegido_ = [];

        var ruta = this.child("leFichero").text;
        //file.open(File.WriteOnly);

        if(_i.extensionFichero_ == "xml"){
                if(!_i.ficheroXML(ruta)){
                        //file.remove();
                        //flfactppal.iface.ponMsgError(sys.translate("No se ha podido generar el fichero."), "error");
                        MessageBox.warning(util.translate("scripts", "No se ha podido generar el fichero"), MessageBox.Ok, MessageBox.NoButton);
                        //sys.errorMsgBox(sys.translate("No se ha podido generar el fichero."));
                        return false;
                }
        }
        else if(_i.extensionFichero_ == "txt"){
                if(!_i.ficheroTextoPlano(ruta, cursor)){
                        //file.remove();
                        //flfactppal.iface.ponMsgError(sys.translate("No se ha podido generar el fichero."), "error");
                        //sys.errorMsgBox(sys.translate("No se ha podido generar el fichero."));
                        MessageBox.warning(util.translate("scripts", "No se ha podido generar el fichero"), MessageBox.Ok, MessageBox.NoButton);
                        return false;
                }
        }
        else {
                //flfactppal.iface.ponMsgError(sys.translate("Revisa la extensin del archivo."), "error");
                //sys.errorMsgBox(sys.translate("Revisa la extensin del archivo."));
                MessageBox.warning(util.translate("scripts", "No se ha podido generar el fichero"), MessageBox.Ok, MessageBox.NoButton);
                return false;
        }

        //file.close();

        //flfactppal.iface.ponMsgError(sys.translate("Fichero generado en: \n\n%1\n\n").arg(this.child("leFichero").text), "info");
        //sys.infoMsgBox(sys.translate("Fichero generado en: \n\n%1\n\n").arg(this.child("leFichero").text));
        MessageBox.information(util.translate("scripts", "Fichero generado en: \n\n%1\n\n").arg(this.child("leFichero").text), MessageBox.Ok, MessageBox.NoButton);

        return true;
}

//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////

function oficial_establecerFichero()
{
        var _i = this.iface;

        this.child("leFichero").text = FileDialog.getSaveFileName("*." + _i.extensionFichero_);
}

function oficial_ficheroTextoPlano(ruta, cursor,fichero)
{
        var _i = this.iface;
        //var cursor = this.cursor();
        var util:FLUtil = new FLUtil;

        aCuentasMandato_ = [];
        aMandatoElegido_ = [];

        var file = new File(ruta);
        file.open(File.WriteOnly);

        var idRemesa = cursor.valueBuffer("idremesa");

        if(!_i.incluirPresentadorTP(file,cursor,fichero)){
                file.remove();
                return false;
        }

        if(!_i.incluirAcreedorTP(file, cursor)){
                file.remove();
                return false;
        }

        var qryRecibos = new FLSqlQuery();
        var groupBy = " GROUP BY r.codcliente, r.nombrecliente, r.codcuenta";
          qryRecibos.setSelect("r.codcliente, r.nombrecliente, r.codcuenta");
          qryRecibos.setFrom("reciboscli r INNER JOIN pagosdevolcli pd ON r.idrecibo = pd.idrecibo");
          qryRecibos.setWhere("pd.idremesa = " + idRemesa + " " + groupBy);

          if (!qryRecibos.exec()) {
                  //flfactppal.iface.ponMsgError(sys.translate("Error query."), "warn");
                //sys.warnMsgBox("Error query.");
                MessageBox.warning(util.translate("scripts", "Error query."), MessageBox.Ok, MessageBox.NoButton);
                file.remove();
                  return false;
        }

        while(qryRecibos.next()){
                if(!_i.incluirRegistroAdeudoTP(qryRecibos,file, cursor)){
                        file.remove();
                        return false;
                }
        }

        if(!_i.incluirTotalFechaCobroTP(file, cursor)){
                file.remove();
                return false;
        }

        if(!_i.incluirTotalAcreedorTP(file, cursor)){
                file.remove();
                return false;
        }

        if(!_i.incluirTotalGeneralTP(file, cursor)){
                file.remove();
                return false;
        }

        file.close();
        return true;
}

function oficial_incluirPresentadorTP(file, cursor, fichero)
{
        var _i = this.iface;
        //var cursor = this.cursor();
        _i.linea_ = "";
        var util:FLUtil = new FLUtil;

        var nombreEmpresa = flfactppal.iface.pub_valorDefectoEmpresa("nombre");
        var fechaActual = _i.formateaFecha(new Date(),"AMDhms");
        var fechaRemesa = _i.formateaFecha(cursor.valueBuffer("fecha"),"AMD");
        var idRemesa = cursor.valueBuffer("idremesa");

        var entidad = AQUtil.sqlSelect("cuentasbanco","ctaentidad","codcuenta = '" + cursor.valueBuffer("codcuenta") + "'");
        var oficina = AQUtil.sqlSelect("cuentasbanco","ctaagencia","codcuenta = '" + cursor.valueBuffer("codcuenta") + "'");

        if(!_i.tipoFichero_ || _i.tipoFichero_ == "" || _i.tipoFichero_ == "undefined"){

                _i.tipoFichero_ = fichero;

        }

        if(!_i.addCampo(1,"num",2, 2)) {return false;}

        if(_i.tipoFichero_ == "B2B") {
                if(!_i.addCampo(19445,"num",5,7)) {return false;}
        }
        else if(_i.tipoFichero_ == "CORE") {
                if(!_i.addCampo(19143,"num",5,7)) {return false;}
        }
        else if(_i.tipoFichero_ == "CORE1*") {
                if(!_i.addCampo(19154,"num",5,7)) {return false;}
        }
        else {
                return false;
        }

        var id = _i.devolverIdentificadorAcreedor(cursor);

        if(!id){
                return false;
        }

        if(!_i.addCampo(1,"num",3,10)) {return false;}
        if(!_i.addCampo(id,"String",35,45)) {return false;}
        if(!_i.addCampo(nombreEmpresa,"String",70,115)) {return false;}
        if(!_i.addCampo(fechaRemesa,"String",8,123)) {return false;}
        if(!_i.addCampo("PRE" + fechaActual + _i.rellenarVacios(idRemesa,"num",13),"String",35,158)) {return false;}
        if(!_i.addCampo(entidad,"String",4,162)) {return false;}
        if(!_i.addCampo(oficina,"String",4,166)) {return false;}
        if(!_i.addCampo(_i.rellenarVacios("","String",434),"String",434,600)) {return false;}

        file.writeLine(_i.linea_);
        _i.linea_ = "";
        return true;
}

function oficial_incluirAcreedorTP(file, cursor)
{
        var _i = this.iface;
        //var cursor = this.cursor();

        var idRemesa = cursor.valueBuffer("idremesa");

        var nombreEmpresa = flfactppal.iface.pub_valorDefectoEmpresa("nombre");
        var fechaCargo = _i.formateaFecha(cursor.valueBuffer("fechacargo"),"AMD");
        var IBAN = AQUtil.sqlSelect("cuentasbanco","iban","codcuenta = '" + cursor.valueBuffer("codcuenta") + "'");

        if(!_i.addCampo(2,"num",2, 2)) {return false;}
        if(_i.tipoFichero_ == "B2B") {
                if(!_i.addCampo(19445,"num",5,7)) {return false;}
        }
        else if(_i.tipoFichero_ == "CORE") {
                if(!_i.addCampo(19143,"num",5,7)) {return false;}
        }
        else if(_i.tipoFichero_ == "CORE1*") {
                if(!_i.addCampo(19154,"num",5,7)) {return false;}
        }
        else {
                return false;
        }

        var id = _i.devolverIdentificadorAcreedor(cursor);

        if(!id){
                return false;
        }

        if(!_i.addCampo(2,"num",3,10)) {return false;}
        if(!_i.addCampo(id,"String",35,45)) {return false;}
        if(!_i.addCampo(fechaCargo,"String",8,53)) {return false;}
        if(!_i.addCampo(nombreEmpresa,"String",70,123)) {return false;}
        if(!_i.addCampo(_i.rellenarVacios("","String",50),"String",50,173)) {return false;}
        if(!_i.addCampo(_i.rellenarVacios("","String",50),"String",50,223)) {return false;}
        if(!_i.addCampo(_i.rellenarVacios("","String",40),"String",40,263)) {return false;}
        if(!_i.addCampo(_i.rellenarVacios("","String",2),"String",2,265)) {return false;}
        if(!_i.addCampo(IBAN,"String",34,299)) {return false;}
        if(!_i.addCampo(_i.rellenarVacios("","String",301),"String",301,600)) {return false;}

        file.writeLine(_i.linea_);
        _i.linea_ = "";

        return true;
}

function oficial_incluirRegistroAdeudoTP(qryRecibos,file,cursor)
{
        var _i = this.iface;
        //var cursor = this.cursor();
        var util:FLUtil = new FLUtil;

        var curRecibos = new FLSqlCursor("reciboscli");
        /*curRecibos.select("codcliente = '" + qryRecibos.value("r.codcliente") + "' AND codcuenta = '" + qryRecibos.value("r.codcuenta") + "' AND idrecibo IN (SELECT idrecibo FROM pagosdevolcli WHERE idremesa = " + cursor.valueBuffer("idremesa") + ")");

        if(!curRecibos.first()) {
                sys.warnMsgBox(sys.translate("No se han encontrado recibos vlidos para el cliente %1").arg(qryRecibos.value("r.nombrecliente")));
                return false;
        }*/
        curRecibos.select("codcliente = '" + qryRecibos.value("r.codcliente") + "' AND fechav = '" + qryRecibos.value("r.fechav") + "' AND codcuenta = '" + qryRecibos.value("r.codcuenta") + "' AND idrecibo IN (SELECT idrecibo FROM reciboscli WHERE idremesa = " + cursor.valueBuffer("idremesa") + ")");
	debug("SQL: " + curRecibos.sql());
   if(!curRecibos.first()) {
           sys.warnMsgBox(sys.translate("No se han encontrado recibos vlidos para el cliente %1").arg(qryRecibos.value("r.nombrecliente")));
   }

        do{
                curRecibos.setModeAccess(curRecibos.Browse);
                curRecibos.refreshBuffer();

                _i.linea_ = "";

                var fechaRem = cursor.valueBuffer("fechacargo");
                var codCuenta = curRecibos.valueBuffer("codcuenta");
                var nombre = curRecibos.valueBuffer("nombrecliente");
                var codCliente = curRecibos.valueBuffer("codcliente");
                var fechaRec = curRecibos.valueBuffer("fecha");
                var fechaRecV = curRecibos.valueBuffer("fechav");
                var fechaCargo = _i.formateaFecha(fechaRem,"AMD");
                var BIC = AQUtil.sqlSelect("cuentasbcocli","bic","codcuenta = '" + codCuenta + "'");
                var IBAN = AQUtil.sqlSelect("cuentasbcocli","iban","codcuenta = '" + codCuenta + "'");

                var curMandato = new FLSqlCursor("mandatoscli");
                curMandato.select("codcuentacliente = '" + codCuenta + "' AND tipo = '" + _i.tipoFichero_ + "' AND (fechafirma < '" + fechaRecV + "' OR fechafirma IS NULL)");

                switch (curMandato.size()) {
                        case 0: {
                                break;
                        }
                        case 1: {
                                break;
                        }
                        default: {
                                var mandatoEncontrado = false;

                                for(var ind = 0; ind < aCuentasMandato_.length; ind++) {
                                        if(aCuentasMandato_[ind] == codCuenta) {
                                                curMandato.select("idmandato = " + aMandatoElegido_[ind]);
                                                mandatoEncontrado = true;
                                        }
                                }

                                if(!mandatoEncontrado) {
                                        var opId = [];
                                        var opDes = [];

                                        while (curMandato.next()) {
                                                curMandato.setModeAccess(curMandato.Browse);
                                                curMandato.refreshBuffer();

                                                opId.push(curMandato.valueBuffer("idmandato"));
                                                opDes.push(curMandato.valueBuffer("refmandato") + " - " + curMandato.valueBuffer("descripcion"));
                                        }

                                        var idOpcion = flfactppal.iface.pub_elegirOpcion(opDes, sys.translate("Escoja mandato para la cuenta %1 del cliente %2 - %3").arg(codCuenta).arg(codCliente).arg(nombre));

                                        if (idOpcion < 0) {
                                                return false;
                                        }

                                        curMandato.select("idmandato = " + opId[idOpcion]);
                                        aCuentasMandato_.push(codCuenta);
                                        aMandatoElegido_.push(opId[idOpcion]);
                                }
                                break;
                        }
                }

                var refMandato;
                var fechaCad;
                var numEfectos;
                var tipoPago;
                var fechaFirma;

                var mandatoPorDefecto = false;

                if (!curMandato.first()) {
                        refMandato = flfacturac.iface.pub_cerosIzquierda(codCliente,6) + flfacturac.iface.pub_cerosIzquierda("0", 29);
                        fechaCad = "20091031";
                        numEfectos = 0;
                        tipoPago = "Pago Recurrente";
                        fechaFirma = "20091031";
                        mandatoPorDefecto = true;
                }
                else {
                        curMandato.setModeAccess(curMandato.Edit);
                        curMandato.refreshBuffer();

                        refMandato = curMandato.valueBuffer("refmandato");
                        fechaCad = curMandato.valueBuffer("fechacaducidad");
                        fechaCad = _i.formateaFecha(fechaCad,"AMD");
                        numEfectos = curMandato.valueBuffer("numefectos");
                        tipoPago = curMandato.valueBuffer("tipopago");
                        fechaFirma = curMandato.valueBuffer("fechafirma");

                        if(!fechaFirma || fechaFirma == "") {
                                fechaFirma = "20091031";
                        }
                        else {
                                fechaFirma = _i.formateaFecha(fechaFirma,"AMD");
                        }
                }

                var tipoAdeudo;

                if(numEfectos != 0) {
                        tipoAdeudo = "RCUR";
                }
                else {
                        if(tipoPago == "Pago Recurrente") {
                                tipoAdeudo = "FRST";
                        }
                        else {
                                tipoAdeudo = "OOFF";
                        }
                }

                if(!_i.addCampo(3,"num",2, 2)) {return false;}
                if(_i.tipoFichero_ == "B2B") {
                        if(!_i.addCampo(19445,"num",5,7)) {return false;}
                }
                else if(_i.tipoFichero_ == "CORE") {
                        if(!_i.addCampo(19143,"num",5,7)) {return false;}
                }
                else if(_i.tipoFichero_ == "CORE1*") {
                        if(!_i.addCampo(19154,"num",5,7)) {return false;}
                }
                else {
                        return false;
                }

                if(!IBAN || IBAN == "") {
                        //sys.warnMsgBox(sys.translate("Falta el cdigo IBAN para la cuenta %1 del cliente %2").arg(codCuenta).arg(nombre));
                        MessageBox.warning(util.translate("scripts", "Falta el cdigo IBAN para la cuenta %1 del cliente %2").arg(codCuenta).arg(nombre), MessageBox.Ok, MessageBox.NoButton);
                        return false;
                }

                /*if(!BIC || BIC == "") {
                        sys.warnMsgBox(sys.translate("Falta el cdigo BIC para la cuenta con IBAN %1 del cliente %2").arg(IBAN).arg(nombre));
                        return false;
                }*/

                if(!_i.addCampo(3,"num",3,10)) {return false;}
                if(!_i.addCampo(curRecibos.valueBuffer("codigo"),"String",35,45)) {return false;}
                if(!_i.addCampo(refMandato,"String",35,80)) {return false;}
                if(!_i.addCampo(tipoAdeudo,"String",4,84)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",4),"String",4,88)) {return false;}
                if(!_i.addCampo(curRecibos.valueBuffer("importe"),"numDec",11,99)) {return false;}
                if(!_i.addCampo(fechaFirma,"String",8,107)) {return false;}
                if(!_i.addCampo(BIC,"String",11,118)) {return false;}
                if(!_i.addCampo(curRecibos.valueBuffer("nombrecliente"),"String",70,188)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",50),"String",50,238)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",50),"String",50,288)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",40),"String",40,328)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",2),"String",2,330)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",1),"num",1,331)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",36),"String",36,367)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",35),"String",35,402)) {return false;}
                if(!_i.addCampo("A","String",1,403)) {return false;}
                if(!_i.addCampo(IBAN,"String",34,437)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",4),"String",4,441)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",140),"String",140,581)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",19),"String",19,600)) {return false;}

                if(!mandatoPorDefecto) {
                        var curPagos = new FLSqlCursor("pagosdevolcli");
                        curPagos.select("idrecibo = " + curRecibos.valueBuffer("idrecibo") + " AND idremesa = " + cursor.valueBuffer("idremesa"));

                        while(curPagos.next()) {
                                curPagos.setModeAccess(curPagos.Edit);
                                curPagos.refreshBuffer();

                                curPagos.setValueBuffer("idmandato", curMandato.valueBuffer("idmandato"));

                                if(!curPagos.commitBuffer())
                                        return false;
                        }
                        curMandato.setValueBuffer("numefectos", formRecordmandatoscli.iface.pub_commonCalculateField("numefectos", curMandato));
                        curMandato.setValueBuffer("fechaultadeudo", cursor.valueBuffer("fechacargo"));
                        curMandato.setValueBuffer("fechacaducidad", formRecordmandatoscli.iface.pub_commonCalculateField("fechacaducidad", curMandato));

                        if (!curMandato.commitBuffer()) {
                                return false;
                        }
                }

                file.writeLine(_i.linea_);
                _i.linea_ = "";

        }while(curRecibos.next());

        return true;
}

function oficial_incluirTotalFechaCobroTP(file, cursor)
{
        var _i = this.iface;
        //var cursor = this.cursor();
        _i.linea_ = "";

        var fechaCargo = _i.formateaFecha(cursor.valueBuffer("fechacargo"),"AMD");
        var idRemesa = cursor.valueBuffer("idremesa");
        var totalImporte = AQUtil.sqlSelect("reciboscli r INNER JOIN pagosdevolcli pd ON r.idrecibo = pd.idrecibo","sum(r.importe)","pd.idremesa = " + idRemesa, "reciboscli");
        var totalRecibos = AQUtil.sqlSelect("reciboscli r INNER JOIN pagosdevolcli pd ON r.idrecibo = pd.idrecibo","count(*)","pd.idremesa = " + idRemesa, "reciboscli");

        var id = _i.devolverIdentificadorAcreedor(cursor);

        if(!id){
                return false;
        }

        if(!_i.addCampo(4,"num",2, 2)) {return false;}
        if(!_i.addCampo(id,"String",35,37)) {return false;}
        if(!_i.addCampo(fechaCargo,"String",8,45)) {return false;}
        if(!_i.addCampo(totalImporte,"numDec",17,62)) {return false;}
        if(!_i.addCampo(totalRecibos,"num",8,70)) {return false;}
        if(!_i.addCampo(totalRecibos+2,"num",10,80)) {return false;}
        if(!_i.addCampo(_i.rellenarVacios("","String",520),"String",520,600)) {return false;}

        file.writeLine(_i.linea_);
        _i.linea_ = "";

        return true;
}

function oficial_incluirTotalAcreedorTP(file,cursor)
{
        var _i = this.iface;
        //var cursor = this.cursor();
        _i.linea_ = "";

        var idRemesa = cursor.valueBuffer("idremesa");
        var totalImporte = AQUtil.sqlSelect("reciboscli r INNER JOIN pagosdevolcli pd ON r.idrecibo = pd.idrecibo","sum(r.importe)","pd.idremesa = " + idRemesa, "reciboscli");
        var totalRecibos = AQUtil.sqlSelect("reciboscli r INNER JOIN pagosdevolcli pd ON r.idrecibo = pd.idrecibo","count(*)","pd.idremesa = " + idRemesa, "reciboscli");

        var id = _i.devolverIdentificadorAcreedor(cursor);

        if(!id){
                return false;
        }

        if(!_i.addCampo(5,"num",2, 2)) {return false;}
        if(!_i.addCampo(id,"String",35,37)) {return false;}
        if(!_i.addCampo(totalImporte,"numDec",17,54)) {return false;}
        if(!_i.addCampo(totalRecibos,"num",8,62)) {return false;}
        if(!_i.addCampo(totalRecibos+3,"num",10,72)) {return false;}
        if(!_i.addCampo(_i.rellenarVacios("","String",528),"String",528,600)) {return false;}

        file.writeLine(_i.linea_);
        _i.linea_ = "";

        return true;
}

function oficial_incluirTotalGeneralTP(file,cursor)
{
        var _i = this.iface;
        //var cursor = this.cursor();
        _i.linea_ = "";

        var idRemesa = cursor.valueBuffer("idremesa");
        var totalImporte = AQUtil.sqlSelect("reciboscli r INNER JOIN pagosdevolcli pd ON r.idrecibo = pd.idrecibo","sum(r.importe)","pd.idremesa = " + idRemesa, "reciboscli");
        var totalRecibos = AQUtil.sqlSelect("reciboscli r INNER JOIN pagosdevolcli pd ON r.idrecibo = pd.idrecibo","count(*)","pd.idremesa = " + idRemesa, "reciboscli");

        if(!_i.addCampo(99,"num",2, 2)) {return false;}
        if(!_i.addCampo(totalImporte,"numDec",17,19)) {return false;}
        if(!_i.addCampo(totalRecibos,"num",8,27)) {return false;}
        if(!_i.addCampo(totalRecibos+5,"num",10,37)) {return false;}
        if(!_i.addCampo(_i.rellenarVacios("","String",563),"String",563,600)) {return false;}

        file.writeLine(_i.linea_);
        _i.linea_ = "";

        return true;
}

function oficial_addCampo(valor,tipo,longitud,longLinea)
{
        var _i = this.iface;
        var util:FLUtil = new FLUtil;

        var str = valor.toString();
        str = _i.formateaCadena(str);
        var strFormateada;

        if(tipo == "numDec"){
                var pEnt = parseInt(valor);
                var pDec = AQUtil.roundFieldValue(valor - parseInt(valor), "reciboscli", "importe");
                subDec = pDec.substring(2);
                str = pEnt.toString() + subDec.toString();
                valor = str;
        }

        if(str.length < longitud){
                strFormateada = _i.rellenarVacios(str,tipo,longitud);
        }
        else if(str.length == longitud){
                strFormateada = str;
        }
        else {
                strFormateada = str.left(longitud);
        }

        _i.linea_ += strFormateada.toString();

        var l = _i.linea_.length;
        if (l != longLinea) {
                //sys.warnMsgBox(sys.translate("Error en el formato de la linea."));
                MessageBox.warning(util.translate("scripts", "Error en el formato de la linea."), MessageBox.Ok, MessageBox.NoButton);
                return false;
        }
        return true;
}

function oficial_rellenarVacios(valor, tipo, longitud)
{
        var _i = this.iface;
        var strFormateada;

        switch(tipo){
                case "String": {
                        strFormateada = flfactppal.iface.pub_espaciosDerecha(valor,longitud);
                        break;
                }
                case "numDec":
                case "num": {
                        strFormateada = flfactppal.iface.pub_cerosIzquierda(valor,longitud);
                        break;
                }
                default: {
                        strFormateada = flfactppal.iface.pub_espaciosDerecha(valor,longitud);
                        break;
                }
        }
        return strFormateada;
}

function oficial_devolverIdentificadorAcreedor(cursor)
{
        var _i = this.iface;

        if(!cursor || cursor == "" || cursor == "undefined") {
                cursor = this.cursor();
        }

        var codCuenta = cursor.valueBuffer("codcuenta");
        var CIFNIF = flfactppal.iface.pub_valorDefectoEmpresa("cifnif");

        var tipoNorma = 19;
        if(this.child("cmbNorma").currentText == "Adeudos financiados (58)"){
                tipoNorma = 58;
        }

        var identificador = flfactppal.iface.calcularIdentificadorAcreedor(CIFNIF, codCuenta, tipoNorma);

        debug("///////////////////////////// " + identificador);

        return identificador;
}

function oficial_ficheroXML(ruta)
{
        var _i = this.iface;
        var util:FLUtil = new FLUtil;
        aCuentasMandato_ = [];
        aMandatoElegido_ = [];

        _i.numEfectos_ = -1;
        _i.fechaVenc_ = -1;

        var file = new File(ruta);
        file.open(File.WriteOnly);

        _i.crearDocumentoXML();

        var eCstmrDrctDbtInitn = _i.colgarNodo("CstmrDrctDbtInitn","raiz");

        if(!_i.incluirCabeceraXML(eCstmrDrctDbtInitn)) {
                file.remove();
                return false;
        }

        /// Nuevo
        /* 1 a N veces */
        /* En nuestro caso siempre va a ser 1 */
        /*
        var x = 0;
        while(x < 1) {
                if(!_i.incluirInformacionPagoXML(eCstmrDrctDbtInitn)) {
                        file.remove();
                        return false;
                }

                x++;
        }
        */
        var cursor = this.cursor();
        var idRemesa = cursor.valueBuffer("idremesa");

        if(!_i.tipoPago_ || _i.tipoPago_ == "") {
                _i.tipoPago_ = "RCUR";
        }

        var qryRecibos = new FLSqlQuery();
        var groupBy = " GROUP BY r.codcliente, r.nombrecliente, r.codcuenta, r.fechav, mc.numefectos ORDER BY r.fechav, mc.numefectos";
          qryRecibos.setSelect("r.codcliente, r.nombrecliente, r.codcuenta, r.fechav, mc.numefectos");
          qryRecibos.setFrom("reciboscli r LEFT JOIN mandatoscli mc ON mc.codcuentacliente = r.codcuenta AND mc.tipo = '" + _i.tipoFichero_ + "'");
          qryRecibos.setWhere("r.idremesa = " + idRemesa + " " + groupBy);

          if (!qryRecibos.exec()) {
                //sys.warnMsgBox("Error query.");
                MessageBox.warning(util.translate("scripts", "Error query."), MessageBox.Ok, MessageBox.NoButton);
                  return false;
          }
      debug("////////////////////// qryRecibos: " + qryRecibos.sql());

  _i.fechaVenc_ = "fecha";
  _i.numEfectos_ = "numefectos";

        while(qryRecibos.next()){
                //if(!_i.incluirOperacionAdeudoXML(ePmtInf,qryRecibos)){
                var identificador_pago_xml = qryRecibos.value("MIN(r.codigo)"); // <- Esto tambien puede ser por ejemplo un contador.
                if(!_i.incluirInformacionPagoXML(eCstmrDrctDbtInitn, qryRecibos, identificador_pago_xml)){
                        return false;
                }
        }
        /// Fin nuevo

        file.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
        file.write(_i.xml_.toString(2));
        file.close();
        return true;
}

function oficial_crearDocumentoXML()
{
        var _i = this.iface;

        _i.xml_ = new FLDomDocument;
        _i.xml_.setContent("<Document xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xmlns='urn:iso:std:iso:20022:tech:xsd:pain.008.001.02'/>");
}

function oficial_incluirCabeceraXML(nodoPadre)
{
        var _i = this.iface;
        var cursor = this.cursor();
        var util:FLUtil = new FLUtil;

        var curEmpresa = new FLSqlCursor("empresa");
        curEmpresa.select("cifnif = '" + flfactppal.iface.pub_valorDefectoEmpresa("cifnif") + "'");
        if(!curEmpresa.first()) {
                //sys.warnMsgBox("No hay empresa.");
                MessageBox.warning(util.translate("scripts", "No hay empresa."), MessageBox.Ok, MessageBox.NoButton);
                return false;
        }
        curEmpresa.setModeAccess(curEmpresa.Browse);
        curEmpresa.refreshBuffer();

        var idRemesa = cursor.valueBuffer("idremesa");
        var nRecibos = AQUtil.sqlSelect("reciboscli","count(*)","idremesa = " + idRemesa, "reciboscli")
        var totalImporte = AQUtil.sqlSelect("reciboscli","sum(importe)","idremesa = " + idRemesa, "reciboscli");
        totalImporte = AQUtil.roundFieldValue(totalImporte,"facturascli","totaliva");

        var eGrpHdr = _i.colgarNodo("GrpHdr",nodoPadre);

        var eMsgId = _i.colgarNodo("MsgId",eGrpHdr);

        var idRemesaNodo = idRemesa.toString();
        if(this.child("cmbNorma").currentText == "Adeudos financiados (58)"){
                var prefijo = "FSDD";
                idRemesaNodo = prefijo + idRemesaNodo;
        }
        if(!_i.colgarNodoTexto(eMsgId,idRemesaNodo,"String",1,35, 0)) {return false;}

        var eCreDtTm = _i.colgarNodo("CreDtTm",eGrpHdr);
        if (!_i.colgarNodoTexto(eCreDtTm,cursor.valueBuffer("fecha"),"DateTime",0,0,0)) {return false;}

        var eNbOfTxs = _i.colgarNodo("NbOfTxs",eGrpHdr);
        if (!_i.colgarNodoTexto(eNbOfTxs,nRecibos,"int",1,15, 0)) {return false;}

        /* 0 o 1 veces */
        if(1==1) {
                var eCtrlSum = _i.colgarNodo("CtrlSum",eGrpHdr);
                if (!_i.colgarNodoTexto(eCtrlSum,totalImporte,"double",3,19,2)) {return false;}
        }

        var eInitgPty = _i.colgarNodo("InitgPty",eGrpHdr);

        /* 0 o 1 veces */
        if(1==1) {
                var eNm = _i.colgarNodo("Nm",eInitgPty);
                if (!_i.colgarNodoTexto(eNm,curEmpresa.valueBuffer("nombre"),"String",1,70,0)) {return false;}
        }

        /* 0 o 1 veces */
        if(1==1){
                if(!_i.incluirIdParteXML(eInitgPty)){
                        return false;
                }
        }
        return true;
}

function oficial_incluirIdParteXML(nodoPadre)
{
        var _i = this.iface;

        eId = _i.colgarNodo("Id",nodoPadre);

        /* Condicion OR para OrgId y PrvtId */
        if(1==1) {
                if(!_i.incluirPersonaJuridicaXML(eId)) {
                        return false;
                }
        }
        else {
                if(!_i.incluirPersonaFisicaXML(eId)) {
                        return false;
                }
        }

        return true;
}

function oficial_incluirPersonaJuridicaXML(nodoPadre)
{
        var _i = this.iface;

        var eOrgId = _i.colgarNodo("OrgId",nodoPadre);

        /* 0 o 1 veces */
        if(1==0) {
                var eBICOrBEI = _i.colgarNodo("BICOrBEI",eOrgId);
                if (!_i.colgarNodoTexto(eBICOrBEI,/* valorBICOrBEI */ "valorBicOrBei","String",0,0,0)) {return false;}
        }

        /* 0 o 1 veces */
        if(1==1) {
                var eOthr = _i.colgarNodo("Othr",eOrgId);

                var id = _i.devolverIdentificadorAcreedor();

                if(!id){
                        return false;
                }

                var eId = _i.colgarNodo("Id",eOthr);
                if (!_i.colgarNodoTexto(eId,id,"String",1,35,0)) {return false;}

                /* 0 o 1 veces */
                if(1==0){
                        var eSchmeNm = _i.colgarNodo("SchmeNm",eOthr);

                        /* Condicion OR para Cd y ePrtry */
                        if(1==0) {
                                var eCd = _i.colgarNodo("Cd",eSchmeNm);
                                if (!_i.colgarNodoTexto(eCd,/* valorCd */ "valorCd","String",1,4,0)) {return false;}
                        }
                        else {
                                var ePrtry = _i.colgarNodo("Prtry",eSchmeNm);
                                if (!_i.colgarNodoTexto(ePrtry,/* valorPrtry */ "valorPrtry","String",1,35,0)) {return false;}
                        }
                }
                /* 0 o 1 veces */
                if(1==0){
                        var eIssr = _i.colgarNodo("Issr",eOthr);
                        if (!_i.colgarNodoTexto(eIssr,/* valorIssr */ "valorIssr","String",1,35,0)) {return false;}
                }
        }
        return true;
}

function oficial_incluirPersonaFisicaXML(nodoPadre)
{
        var _i = this.iface;

        ePrvtId = _i.colgarNodo("PrvtId",nodoPadre);

        /* 0 o 1 veces */
        if(1==0){
                var eDtAndPlcOfBirth = _i.colgarNodo("DtAndPlcOfBirth",ePrvtId);

                var eBirthDt = _i.colgarNodo("BirthDt",eDtAndPlcOfBirth);
                if (!_i.colgarNodoTexto(eBirthDt,/* valorBirthDt */ "valorBirthDt","Date",0,0,0)) {return false;}

                /* 0 o 1 veces */
                if(1==0){
                        var ePrvcOfBirth = _i.colgarNodo("PrvcOfBirth",eDtAndPlcOfBirth);
                        if (!_i.colgarNodoTexto(ePrvcOfBirth,/* valorPrvcOfBirth */ "valorPrvcOfBirth","String",1,35,0)) {return false;}
                }

                var eCityOfBirth = _i.colgarNodo("CityOfBirth",eDtAndPlcOfBirth);
                if (!_i.colgarNodoTexto(eCityOfBirth,/* valorCityOfBirth */ "valorCityOfBirth","String",1,35,0)) {return false;}

                var eCtryOfBirth = _i.colgarNodo("CtryOfBirth",eDtAndPlcOfBirth);
                if (!_i.colgarNodoTexto(eCtryOfBirth,/* valorCtryOfBirth */ "valorCtryOfBirth","String",0,0,0)) {return false;}
        }

        /* 0 o 1 veces */
        if(1==0){
                var eOthr = _i.colgarNodo("Othr",ePrvtId);

                var eId = _i.colgarNodo("Id",eOthr);
                if (!_i.colgarNodoTexto(eId,/* idEmpresa?? */ "valorId","String",1,35,0)) {return false;}

                /* 0 o 1 veces */
                if(1==0){
                        var eSchmeNm = _i.colgarNodo("SchmeNm",eOthr);

                        /* Condicion OR para Cd y ePrtry */
                        if(1==0) {
                                var eCd = _i.colgarNodo("Cd",eSchmeNm);
                                if (!_i.colgarNodoTexto(eCd,/* valorCd */ "valorCd","String",1,4,0)) {return false;}
                        }
                        else {
                                var ePrtry = _i.colgarNodo("Prtry",eSchmeNm);
                                if (!_i.colgarNodoTexto(ePrtry,/* valorPrtry */ "valorPrtry","String",1,35,0)) {return false;}
                        }
                }
                /* 0 o 1 veces */
                if(1==0){
                        var eIssr = _i.colgarNodo("Issr",eOthr);
                        if (!_i.colgarNodoTexto(eIssr,/* valorIssr */ "valorIssr","String",1,35,0)) {return false;}
                }
        }
        return true;
}
/// Nuevo
///function oficial_incluirInformacionPagoXML(nodoPadre)
function oficial_incluirInformacionPagoXML(nodoPadre, qryRecibos, PmtInfId)
/// Fin nuevo
{
        var _i = this.iface;
        var cursor = this.cursor();

        var codCuenta = cursor.valueBuffer("codcuenta");
        var idRemesa = cursor.valueBuffer("idremesa");
        var fechaCargo = cursor.valueBuffer("fechacargo");


        var numEfectosRegistro = qryRecibos.value("mc.numefectos");
        if(isNaN(numEfectosRegistro) || !numEfectosRegistro || numEfectosRegistro == undefined) {
                numEfectosRegistro = "RCUR"; // GESTIWEB: Si no hay informacion es RCUR.
        }
        else if (numEfectosRegistro == 0){
                numEfectosRegistro = "FRST";
        }
        else{
                numEfectosRegistro = "RCUR";
        }

        if(this.child("cmbNorma").currentText == "Adeudos financiados (58)"){
                fechaCargo = qryRecibos.value("r.fechav");
        }

        debug("///////////////////////////// _i.numEfectos_: " + _i.numEfectos_);
        debug("///////////////////////////// numEfectosRegistro: " + numEfectosRegistro);
        debug("///////////////////////////// _i.fechaVenc_: " + _i.fechaVenc_);
        debug("///////////////////////////// fechaCargo: " + fechaCargo);

        if(_i.fechaVenc_ == "fecha" || _i.numEfectos_ == "numefectos" || _i.fechaVenc_ != fechaCargo || numEfectosRegistro != _i.numEfectos_){
                _i.ePmtInf_ = _i.colgarNodo("PmtInf",nodoPadre);
                debug("///////////////////////////////////////////////////////////////////////// cuelgo nodo PmtInf");

                var ePmtInfId = _i.colgarNodo("PmtInfId",_i.ePmtInf_);
                if (!_i.colgarNodoTexto(ePmtInfId,idRemesa.toString() + "-" + codCuenta + "-" + PmtInfId,"String",1,35,0)) {return false;}

                var ePmtMtd = _i.colgarNodo("PmtMtd",_i.ePmtInf_);
                if (!_i.colgarNodoTexto(ePmtMtd,"DD","String",1,2,0)) {return false;}

                /* 0 o 1 veces */
                if(1==0){
                        var eBtchBookg = _i.colgarNodo("BtchBookg",_i.ePmtInf_);
                        if (!_i.colgarNodoTexto(eBtchBookg,/* valorBtchBookg */true,"boolean",0,0,0)) {return false;}
                }

                /* 0 o 1 veces */
                if(1==0){
                        var eNbOfTxs = _i.colgarNodo("NbOfTxs",_i.ePmtInf_);
                        if (!_i.colgarNodoTexto(eNbOfTxs,/* valorNbOfTxs */6,"int",1,15,0)) {return false;}
                }

                /* 0 o 1 veces */
                if(1==0) {
                        var eCtrlSum = _i.colgarNodo("CtrlSum",_i.ePmtInf_);
                        if (!_i.colgarNodoTexto(eCtrlSum,/* valorCtrlSum */6.6,"double",3,19,2)) {return false;}
                }

                /* 0 o 1 veces */
                if(1==1){
                        /// Nuevo
                        if(!_i.incluirInformacionTipoPagoXML(_i.ePmtInf_, qryRecibos)) {
                                return false;
                        }
                        /*
                        if(!_i.incluirInformacionTipoPagoXML(_i.ePmtInf_)) {
                                return false;
                        }
                        */
                        /// Fin nuevo
                }

                var eReqdColltnDt = _i.colgarNodo("ReqdColltnDt",_i.ePmtInf_);
                if (!_i.colgarNodoTexto(eReqdColltnDt,fechaCargo.toString().left(10),"Date",0,0,0)) {return false;}

                if(!_i.incluirAcreedorXML(_i.ePmtInf_)) {
                        return false;
                }

                /* 0 o 1 veces */
                if(1==0){
                        var eUltmtCdtr = _i.colgarNodo("UltmtCdtr",_i.ePmtInf_);

                        var eNm = _i.colgarNodo("Nm",eUltmtCdtr);
                        if (!_i.colgarNodoTexto(eNm,/*valorNm*/"valorNm","String",1,70,0)) {return false;}

                        /* 0 o 1 veces */
                        if(1==0) {
                                if(!_i.incluirIdParteXML(eUltmtCdtr)) {
                                        return false;
                                }
                        }
                }

                /* 0 o 1 veces */
                if(1==1){
                        var eChrgBr = _i.colgarNodo("ChrgBr",_i.ePmtInf_);
                        if (!_i.colgarNodoTexto(eChrgBr,"SLEV","String",1,4,0)) {return false;}
                }

                /* 0 o 1 veces */
                if(1==1){
                        var eCdtrSchmeId = _i.colgarNodo("CdtrSchmeId",_i.ePmtInf_);

                        var eId = _i.colgarNodo("Id",eCdtrSchmeId);

                        var ePrvtId = _i.colgarNodo("PrvtId",eId);

                        var eOthr = _i.colgarNodo("Othr",ePrvtId);

                        var cdtrId = _i.devolverIdentificadorAcreedor(cursor);

                        if(!cdtrId){
                                return false;
                        }

                        var eId2 = _i.colgarNodo("Id",eOthr);
                        if (!_i.colgarNodoTexto(eId2,cdtrId,"String",1,35,0)) {return false;}

                        var eSchmeNm = _i.colgarNodo("SchmeNm",eOthr);

                        var ePrtry = _i.colgarNodo("Prtry",eSchmeNm);
                        if (!_i.colgarNodoTexto(ePrtry,"SEPA","String",1,35,0)) {return false;}
                }
        }
        /// Nuevo
        /*
        var qryRecibos = new FLSqlQuery();
        var groupBy = " GROUP BY r.codcliente, r.nombrecliente, r.codcuenta";
          qryRecibos.setSelect("r.codcliente, r.nombrecliente, r.codcuenta");
          qryRecibos.setFrom("reciboscli r INNER JOIN pagosdevolcli pd ON r.idrecibo = pd.idrecibo");
          qryRecibos.setWhere("pd.idremesa = " + idRemesa + " " + groupBy);

          if (!qryRecibos.exec()) {
                sys.warnMsgBox("Error query.");
                  return false;
          }

        while(qryRecibos.next()){
                if(!_i.incluirOperacionAdeudoXML(_i.ePmtInf_,qryRecibos)){
                        return false;
                }
        }
        */

        _i.fechaVenc_ = fechaCargo;
        _i.numEfectos_ = numEfectosRegistro;

        if(!_i.incluirOperacionAdeudoXML(_i.ePmtInf_, qryRecibos)){
                return false;
        }
        /// Fin nuevo
        return true;
}

function oficial_incluirAcreedorXML(nodoPadre)
{
        var _i = this.iface;
        var cursor = this.cursor();
        var util:FLUtil = new FLUtil;

        var curEmpresa = new FLSqlCursor("empresa");
        curEmpresa.select("cifnif = '" + flfactppal.iface.pub_valorDefectoEmpresa("cifnif") + "'");
        if(!curEmpresa.first()) {
                //sys.warnMsgBox("No hay empresa.");
                MessageBox.warning(util.translate("scripts", "No hay empresa."), MessageBox.Ok, MessageBox.NoButton);
                return false;
        }
        curEmpresa.setModeAccess(curEmpresa.Browse);
        curEmpresa.refreshBuffer();

        var codCuenta = cursor.valueBuffer("codcuenta");

        var IBAN = AQUtil.sqlSelect("cuentasbanco","iban","codcuenta = '" + codCuenta + "'");
        var bic = AQUtil.sqlSelect("cuentasbanco","bic","codcuenta = '" + codCuenta + "'");

        var eCdtr = _i.colgarNodo("Cdtr",nodoPadre);

        /* 0 o 1 veces */
        if(1==1){
                var eNm = _i.colgarNodo("Nm",eCdtr);
                if (!_i.colgarNodoTexto(eNm,curEmpresa.valueBuffer("nombre"),"String",1,70,0)) {return false;}
        }

        /* 0 o 1 veces */
        if(1==0){
                if(!_i.incluirDireccionPostalXML(eCdtr)){
                        return false;
                }
        }

        var eCdtrAcct = _i.colgarNodo("CdtrAcct",nodoPadre);

        var eId = _i.colgarNodo("Id",eCdtrAcct);

        if(!IBAN || IBAN == "") {
                //sys.warnMsgBox(sys.translate("Falta el cdigo IBAN para la cuenta %1 del acreedor.").arg(codCuenta));
                MessageBox.warning(util.translate("scripts", "Falta el cdigo IBAN para la cuenta %1 del acreedor.").arg(codCuenta), MessageBox.Ok, MessageBox.NoButton);
                return false;
        }

        var eIBAN = _i.colgarNodo("IBAN",eId);
        if (!_i.colgarNodoTexto(eIBAN,IBAN,"String", 1, 34,0)) {return false;}

        /* 0 o 1 veces */
        /*if(1==1){
                var divisa = flfactppal.iface.pub_valorDefectoEmpresa("coddivisa");

                var eCcy = _i.colgarNodo("Ccy",eCdtrAcct);
                if (!_i.colgarNodoTexto(eCcy,divisa,"String")) {return false;}
        }*/

        var eCdtrAgt = _i.colgarNodo("CdtrAgt",nodoPadre);

        var eFinInstnId = _i.colgarNodo("FinInstnId",eCdtrAgt);

        /*if(!bic || bic == "") {
                sys.warnMsgBox(sys.translate("Falta el cdigo BIC para la cuenta con IBAN %1 del acreedor.").arg(IBAN));
                return false;
        }*/

        if(bic && bic != ""){
                var eBIC = _i.colgarNodo("BIC",eFinInstnId);
                if (!_i.colgarNodoTexto(eBIC,bic,"String", 1, 11,0)) {return false;}
        }
        /*else{
                bic = "";
                if (!_i.colgarNodoTexto(eBIC,bic,"String")) {return false;}
        }*/

        return true;
}

function oficial_incluirDireccionPostalXML(nodoPadre)
{
        var _i = this.iface;

        var ePstlAdr = _i.colgarNodo("PstlAdr",nodoPadre);

        /* 0 o 1 veces */
        var eCtry = _i.colgarNodo("Ctry",ePstlAdr);
        if (!_i.colgarNodoTexto(eCtry,/* valorCtry */ "valorCtry","String",0,0,0)) {return false;}

        /* 0 a 2 veces */
        var y = 0;
        while(y < 1) {
                var eAdrLine = _i.colgarNodo("AdrLine",ePstlAdr);
                if (!_i.colgarNodoTexto(eAdrLine,/* valorAdrLine */ "valorAdrLine","String",1,70,0)) {return false;}

                y++;
        }

        return true;
}

/// Nuevo
///function oficial_incluirInformacionTipoPagoXML(nodoPadre)
function oficial_incluirInformacionTipoPagoXML(nodoPadre, qryRecibos)
/// Fin nuevo
{
        var _i = this.iface;

        var ePmtTpInf = _i.colgarNodo("PmtTpInf",nodoPadre);

        /* 0 o 1 veces */
        if(1==1){
                var eSvcLvl = _i.colgarNodo("SvcLvl",ePmtTpInf);

                var eCd1 = _i.colgarNodo("Cd",eSvcLvl);
                if (!_i.colgarNodoTexto(eCd1,"SEPA","String",1,4,0)) {return false;}
        }

        /* 0 o 1 veces */
        if(1==1){
                var eLclInstrm = _i.colgarNodo("LclInstrm",ePmtTpInf);

                var eCd2 = _i.colgarNodo("Cd",eLclInstrm);
                if(_i.tipoFichero_ == "B2B") {
                        if (!_i.colgarNodoTexto(eCd2,"B2B","String",1,4,0)) {return false;}
                }
                else if (_i.tipoFichero_ == "CORE") {
                        if (!_i.colgarNodoTexto(eCd2,"CORE","String",1,4,0)) {return false;}
                }
                else if (_i.tipoFichero_ == "CORE1*") {
                        if (!_i.colgarNodoTexto(eCd2,"COR1*","String",1,4,0)) {return false;}
                }
                else {
                        return false;
                }
        }

        /* 0 o 1 veces */
        if(1==1) {
                /// Nuevo
                  var codCuenta = qryRecibos.value("r.codcuenta");
                var numEfectos = AQUtil.sqlSelect("mandatoscli", "numefectos", "codcuentacliente = '" + codCuenta + "' AND tipo = '" + _i.tipoFichero_ + "'");

                if(!_i.tipoPago_ || _i.tipoPago_ == "") {
                        _i.tipoPago_ = "RCUR";
                }
                var tipoPago;
                if (_i.tipoPago_ == "RCUR") {
                        if (!numEfectos || isNaN(numEfectos)) {
                                tipoPago = "FRST";
                        } else {
                                tipoPago = "RCUR";
                        }
                } else {
                        tipoPago = _i.tipoPago_;
                }
                var eSeqTp = _i.colgarNodo("SeqTp",ePmtTpInf);
                if (!_i.colgarNodoTexto(eSeqTp, tipoPago, "String", 1, 4,0)) {return false;}

                /*
                if(!_i.tipoPago_ || _i.tipoPago_ == "") {
                        _i.tipoPago_ = "RCUR";
                }
                var eSeqTp = _i.colgarNodo("SeqTp",ePmtTpInf);
                if (!_i.colgarNodoTexto(eSeqTp,_i.tipoPago_,"String")) {return false;}
                */
                ///Nuevo
        }

        /* 0 o 1 veces */
        if(1==0){
                var eCtgyPurp = _i.colgarNodo("CtgyPurp",ePmtTpInf);

                /* Condicion OR para Cd y ePrtry */
                if(1==0) {
                        var eCd3 = _i.colgarNodo("Cd",eCtgyPurp);
                        if (!_i.colgarNodoTexto(eCd3,/* valorCd */ "valorCd","String",1,4,0)) {return false;}
                }
                else {
                        var ePrtry = _i.colgarNodo("Prtry",eCtgyPurp);
                        if (!_i.colgarNodoTexto(ePrtry,/* valorPrtry */ "valorPrtry","String",1,35,0)) {return false;}
                }
        }
        return true;
}

function oficial_incluirOperacionAdeudoXML(nodoPadre, qryRecibos)
{
        var _i = this.iface;
        var cursor = this.cursor();
        var util:FLUtil = new FLUtil;

        var curRecibos = new FLSqlCursor("reciboscli");
        /*curRecibos.select("codcliente = '" + qryRecibos.value("r.codcliente") + "' AND codcuenta = '" + qryRecibos.value("r.codcuenta") + "' AND idrecibo IN (SELECT idrecibo FROM pagosdevolcli WHERE idremesa = " + cursor.valueBuffer("idremesa") + ")");

        if(!curRecibos.first()) {
                sys.warnMsgBox(sys.translate("No se han encontrado recibos vlidos para el cliente %1").arg(qryRecibos.value("r.nombrecliente")));
                return false;
        }*/
        curRecibos.select("codcliente = '" + qryRecibos.value("r.codcliente") + "' AND fechav = '" + qryRecibos.value("r.fechav") + "' AND codcuenta = '" + qryRecibos.value("r.codcuenta") + "' AND idrecibo IN (SELECT idrecibo FROM reciboscli WHERE idremesa = " + cursor.valueBuffer("idremesa") + ")");

   if(!curRecibos.first()) {
           sys.warnMsgBox(sys.translate("No se han encontrado recibos vlidos para el cliente %1").arg(qryRecibos.value("r.nombrecliente")));
   }

        do{
                curRecibos.setModeAccess(curRecibos.Browse);
                curRecibos.refreshBuffer();

                var fechaRem = cursor.valueBuffer("fechacargo");
                var codCuenta = curRecibos.valueBuffer("codCuenta");
                var codCliente = curRecibos.valueBuffer("codcliente");
                var nombre = curRecibos.valueBuffer("nombrecliente");
                var fechaRec = curRecibos.valueBuffer("fecha");
                var fechaRecV = curRecibos.valueBuffer("fechav");

                var curMandato = new FLSqlCursor("mandatoscli");
                curMandato.select("codcuentacliente = '" + codCuenta + "' AND tipo = '" + _i.tipoFichero_ + "' AND (fechafirma < '" + fechaRecV + "' OR fechafirma IS NULL)");

                switch (curMandato.size()) {
                        case 0: {
                                break;
                        }
                        case 1: {
                                break;
                        }
                        default: {
                                var mandatoEncontrado = false;

                                for(var ind = 0; ind < aCuentasMandato_.length; ind++) {
                                        if(aCuentasMandato_[ind] == codCuenta) {
                                                curMandato.select("idmandato = " + aMandatoElegido_[ind]);
                                                mandatoEncontrado = true;
                                        }
                                }

                                if(!mandatoEncontrado) {
                                        var opId = [];
                                        var opDes = [];

                                        while (curMandato.next()) {
                                                curMandato.setModeAccess(curMandato.Browse);
                                                curMandato.refreshBuffer();

                                                opId.push(curMandato.valueBuffer("idmandato"));
                                                opDes.push(curMandato.valueBuffer("refmandato") + " - " + curMandato.valueBuffer("descripcion"));
                                        }

                                        var idOpcion = flfactppal.iface.pub_elegirOpcion(opDes, sys.translate("Escoja mandato para la cuenta %1 del cliente %2 - %3").arg(codCuenta).arg(codCliente).arg(nombre));

                                        if (idOpcion < 0) {
                                                return false;
                                        }

                                        curMandato.select("idmandato = " + opId[idOpcion]);
                                        aCuentasMandato_.push(codCuenta);
                                        aMandatoElegido_.push(opId[idOpcion]);
                                }
                                break;
                        }
                }

                var refMandato;
                var fechaCad;
                var numEfectos;
                var tipoPago;
                var fechaFirma;

                var mandatoPorDefecto = false;

                if (!curMandato.first()) {
                        curMandato.setModeAccess(curMandato.Insert);
                        curMandato.refreshBuffer();

                        refMandato = flfacturac.iface.pub_cerosIzquierda(codCliente,6) + flfacturac.iface.pub_cerosIzquierda("0", 29);
                        fechaCad = "2009-10-31";
                        numEfectos = 0;
                        tipoPago = "Pago Recurrente";
                        mandatoPorDefecto = true;
                        fechaFirma = "2009-10-31";

                        if(refMandato == "" || !refMandato){
                                return false;
                        }

                        curMandato.setValueBuffer("refmandato", refMandato);
                        curMandato.setValueBuffer("codcuenta", cursor.valueBuffer("codcuenta"));
                        curMandato.setValueBuffer("descripcion", "Mandato Defecto " + curRecibos.valueBuffer("nombrecliente"));
                        curMandato.setValueBuffer("fechacaducidad", fechaCad);
                        curMandato.setValueBuffer("numefectos", numEfectos);
                        curMandato.setValueBuffer("tipopago", tipoPago);
                        curMandato.setValueBuffer("tipo", _i.tipoFichero_);
                        curMandato.setValueBuffer("fechafirma", fechaFirma);
                        curMandato.setValueBuffer("codcliente", qryRecibos.value("r.codcliente"));
                        curMandato.setValueBuffer("codcuentacliente", qryRecibos.value("r.codcuenta"));
                        curMandato.setValueBuffer("lugarfirma", "");

                        if(!curMandato.commitBuffer()){
                                return false;
                        }
                        debug("Crea el mandato.");
                }
                else {
                        curMandato.setModeAccess(curMandato.Edit);
                        curMandato.refreshBuffer();

                        debug("refMandato " + refMandato);

                        refMandato = curMandato.valueBuffer("refmandato");
                        fechaCad = curMandato.valueBuffer("fechacaducidad");
                        fechaCad = _i.formateaFecha(fechaCad,"A-M-D");
                        numEfectos = curMandato.valueBuffer("numefectos");
                        tipoPago = curMandato.valueBuffer("tipopago");
                        fechaFirma = curMandato.valueBuffer("fechafirma");

                        if(!fechaFirma || fechaFirma == "") {
                                fechaFirma = "2009-10-31";
                        }
                        else {
                                fechaFirma = _i.formateaFecha(fechaFirma,"A-M-D");
                        }
                }

                var tipoAdeudo;

                if(numEfectos != 0) {
                        tipoAdeudo = "RCUR";
                }
                else {
                        if(tipoPago == "Pago Recurrente") {
                                tipoAdeudo = "FRST";
                        }
                        else {
                                tipoAdeudo = "OOFF";
                        }
                }

                var eDrctDbtTxInf = _i.colgarNodo("DrctDbtTxInf",nodoPadre);

                var bicBanco = AQUtil.sqlSelect("cuentasbcocli","bic","codcuenta = '" + curRecibos.valueBuffer("codcuenta") + "'");
                var IBAN = AQUtil.sqlSelect("cuentasbcocli","iban","codcuenta = '" + curRecibos.valueBuffer("codcuenta") + "'");

                var ePmtId = _i.colgarNodo("PmtId",eDrctDbtTxInf);

                var eEndToEndId = _i.colgarNodo("EndToEndId",ePmtId);
                if (!_i.colgarNodoTexto(eEndToEndId,curRecibos.valueBuffer("codigo"),"String",1,35,0)) {return false;}

                var eInstdAmt = _i.colgarNodo("InstdAmt",eDrctDbtTxInf);
                eInstdAmt.setAttribute("Ccy",curRecibos.valueBuffer("coddivisa"));

                var importeRecibo = curRecibos.valueBuffer("importe");
                importeRecibo = AQUtil.roundFieldValue(importeRecibo,"facturascli","totaliva");

                if (!_i.colgarNodoTexto(eInstdAmt,importeRecibo,"double",3,12,2)) {return false;}

                /* 0 o 1 veces */
                if(1==1){
                        var eDrctDbtTx = _i.colgarNodo("DrctDbtTx",eDrctDbtTxInf);

                        var eMndtRltdInf = _i.colgarNodo("MndtRltdInf",eDrctDbtTx);

                        var eMndtId = _i.colgarNodo("MndtId",eMndtRltdInf);
                        if (!_i.colgarNodoTexto(eMndtId,refMandato,"String",1,35,0)) {return false;}

                        var eDtOfSgntr = _i.colgarNodo("DtOfSgntr",eMndtRltdInf);
                        if (!_i.colgarNodoTexto(eDtOfSgntr,fechaFirma,"Date",8,10,0)) {return false;}
                }

                var eDbtrAgt = _i.colgarNodo("DbtrAgt",eDrctDbtTxInf);

                var eFinInstnId = _i.colgarNodo("FinInstnId",eDbtrAgt);

                if(!IBAN || IBAN == "") {
                        sys.warnMsgBox(sys.translate("Falta el cdigo IBAN para la cuenta %1 del cliente %2").arg(codCuenta).arg(nombre));
                        return false;
                }

                /*if(!bicBanco || bicBanco == "") {
                        sys.warnMsgBox(sys.translate("Falta el cdigo BIC para la cuenta con IBAN %1 del cliente %2").arg(IBAN).arg(nombre));
                        return false;
                }*/

                if(bicBanco && bicBanco != ""){
                        var eBIC = _i.colgarNodo("BIC",eFinInstnId);
                        if (!_i.colgarNodoTexto(eBIC,bicBanco,"String",1,11,0)) {return false;}
                }
                /*else{
                        bicBanco = "";
                        if (!_i.colgarNodoTexto(eBIC,bicBanco,"String")) {return false;}
                }*/

                if(!_i.incluirDeudorXML(eDrctDbtTxInf,qryRecibos)){
                        return false;
                }

                var eDbtrAcct = _i.colgarNodo("DbtrAcct",eDrctDbtTxInf);

                var eId = _i.colgarNodo("Id",eDbtrAcct);

                var eIBAN = _i.colgarNodo("IBAN",eId);
                if (!_i.colgarNodoTexto(eIBAN,IBAN,"String", 1, 34,0)) {return false;}

                //if(!mandatoPorDefecto) {   //Esto se coment porque ahora creamos el mandato cuando genera uno por defecto.
                var curPagos = new FLSqlCursor("pagosdevolcli");
                curPagos.select("idrecibo = " + curRecibos.valueBuffer("idrecibo") );

                while(curPagos.next()) {
                        curPagos.setModeAccess(curPagos.Edit);
                        curPagos.refreshBuffer();

                        curPagos.setValueBuffer("idmandato", curMandato.valueBuffer("idmandato"));

                        if(!curPagos.commitBuffer())
                                return false;
                }
                curMandato.setValueBuffer("numefectos", formRecordmandatoscli.iface.pub_commonCalculateField("numefectos", curMandato));
                curMandato.setValueBuffer("fechaultadeudo", cursor.valueBuffer("fechacargo"));
                curMandato.setValueBuffer("fechacaducidad", formRecordmandatoscli.iface.pub_commonCalculateField("fechacaducidad", curMandato));

                if (!curMandato.commitBuffer()) {
                        return false;
                }
                //}

        } while(curRecibos.next());

        return true;
}

function oficial_incluirDeudorXML(nodoPadre,qryRecibos)
{
        var _i = this.iface;

        var eDbtr = _i.colgarNodo("Dbtr",nodoPadre);

        /* 0 o 1 veces */
        if(1==1){
                var eNm = _i.colgarNodo("Nm",eDbtr);

                debug("////////////////////// NOMBRE CLIENTE: " + qryRecibos.value("r.nombrecliente"));

                if (!_i.colgarNodoTexto(eNm,qryRecibos.value("r.nombrecliente"),"String",1,70,0)) {return false;}
        }

        /* 0 o 1 veces */
        if(1==0){
                if(!_i.incluirDireccionPostalXML(eDbtr)){
                        return false;
                }
        }

        if(1==0){
                if(!_i.incluirIdParteXML(eDbtr)){
                        return false;
                }
        }

        return true;
}

function oficial_colgarNodo(nombreHijo, nodoPadre)
{
        var _i = this.iface;
        var eHijo = _i.xml_.createElement(nombreHijo);
        if(nodoPadre == "raiz") {
                nodoPadre = _i.xml_.firstChild().toElement();
        }
        nodoPadre.appendChild(eHijo);
        return eHijo;
}

function oficial_colgarNodoTexto(nodoPadre, valor, tipo, min, max, decimales)
{
        var _i = this.iface;
        var tipovar = typeof(valor);
        if(tipovar == "string"){
                valor = _i.formateaCadena(valor);
        }

        if(max && max > 0){
                if (tipo == "String") {
                        valor = valor.toString().left(max);
                }
        }

        if(!_i.validarTextoNodo(valor, tipo, min, max, decimales)) {
                return false;
        }

        var eHijo = _i.xml_.createTextNode("nodoTexto");
        nodoPadre.appendChild(eHijo);
        eHijo.setNodeValue(valor);

        return true;
}

function oficial_validarTextoNodo(valor, tipo, min, max, decimales)
{
        var _i = this.iface;

        var typeOf = typeof(valor);
        var str = valor.toString();
        var util:FLUtil = new FLUtil;

        switch(tipo) {
                case "string":
                case "String": {
                        if(typeOf != "string") {
                                //sys.warnMsgBox(sys.translate("El valor debe ser una cadena de texto."));
                                debug("ERROR: debe ser texto. Valor: " + valor + ". tipo: " + typeOf);
                                MessageBox.warning(util.translate("scripts", "El valor debe ser una cadena de texto."), MessageBox.Ok, MessageBox.NoButton);
                                return false;
                        }
                        if(min && valor.length < min) {
                                //sys.warnMsgBox(sys.translate("Longitud de campo por debajo del mnimo."));
                                debug("ERROR: debe ser texto. No llega al minimo de "+min+" caracteres. Valor: " + valor + ". tipo: " + tipo);
                                MessageBox.warning(util.translate("scripts", "El valor debe ser una cadena de texto."), MessageBox.Ok, MessageBox.NoButton);
                                return false;
                        }
                        if(max && valor.length > max) {
                        /**cortar*/
                                //sys.warnMsgBox(sys.translate("Excedida la longitud mxima de campo."));
                                debug("ERROR: debe ser texto. Supera el maximo de "+max+" caracteres. Valor: " + valor + ". tipo: " + tipo);
                                //MessageBox.warning(util.translate("scripts", "Excedida la longitud mxima de campo."), MessageBox.Ok, MessageBox.NoButton);
                        debug("valor=$"+valor+"$ / tipo = "+tipo+" /max="+max);
                                sys.warnMsgBox(sys.translate("Excedida la longitud mxima de campo para el valor %1/n se limitar el tamao").arg(valor));
                                valor = valor.left(max);
                                debug("recortado valor a $"+valor+"$");
                                //return false;
                        }
                        break;
                }
                case "int": {
                        if(typeOf != "number") {
                                //sys.warnMsgBox(sys.translate("El valor debe ser un nmero entero."));
                                MessageBox.warning(util.translate("scripts", "El valor debe ser un nmero entero."), MessageBox.Ok, MessageBox.NoButton);
                                return false;
                        }
                        for(var i = 0; i < str.length; i++){
                                if(str.charAt(i) > '9' || str.charAt(i) < '0'){
                                        //sys.warnMsgBox(sys.translate("El valor no debe contener decimales."));
                                        MessageBox.warning(util.translate("scripts", "El valor no debe contener decimales."), MessageBox.Ok, MessageBox.NoButton);
                                        return false;
                                }
                        }
                        if(min && str.length < min) {
                                //sys.warnMsgBox(sys.translate("Longitud de campo por debajo del mnimo."));
                                MessageBox.warning(util.translate("scripts", "Longitud de campo por debajo del mnimo."), MessageBox.Ok, MessageBox.NoButton);
                                return false;
                        }
                        if(max && str.length > max) {
                                //sys.warnMsgBox(sys.translate("Excedida la longitud mxima de campo."));
                                MessageBox.warning(util.translate("scripts", "Excedida la longitud mxima de campo."), MessageBox.Ok, MessageBox.NoButton);
                                return false;
                        }
                        break;
                }
                case "double": {
                        if(min && str.length < min) {
                                //sys.warnMsgBox(sys.translate("Longitud de campo por debajo del mnimo."));
                                MessageBox.warning(util.translate("scripts", "Longitud de campo por debajo del mnimo."), MessageBox.Ok, MessageBox.NoButton);
                                return false;
                        }
                        if(max && str.length > max) {
                                //sys.warnMsgBox(sys.translate("Excedida la longitud mxima de campo."));
                                MessageBox.warning(util.translate("scripts", "Excedida la longitud mxima de campo."), MessageBox.Ok, MessageBox.NoButton);
                                return false;
                        }
                        if(decimales > 0) {
                                var dec = 0;
                                var punto = false;
                                for(var i = 0; i < str.length; i++){
                                        if(punto){
                                                dec++;
                                        }
                                        if(str.charAt(i) > '9' || str.charAt(i) < '0'){
                                                punto = true;
                                        }
                                }
                                if(dec > decimales) {
                                        //sys.warnMsgBox(sys.translate("La parte decimal excede la longitud requerida."));
                                        MessageBox.warning(util.translate("scripts", "La parte decimal excede la longitud requerida."), MessageBox.Ok, MessageBox.NoButton);
                                        return false;
                                }
                        }
                        break;
                }
                case "boolean": {
                        if(typeOf != "boolean") {
                                //sys.warnMsgBox(sys.translate("El valor debe ser verdadero o falso."));
                                MessageBox.warning(util.translate("scripts", "El valor debe ser verdadero o falso."), MessageBox.Ok, MessageBox.NoButton);
                                return false;
                        }
                        break;
                }
                case "date":
                case "Date": {
                        if(str.length != 10) {
                                //sys.warnMsgBox(sys.translate("El formato de la fecha debe ser 'YYYY-MM-DD'."));
                                MessageBox.warning(util.translate("scripts", "El formato de la fecha debe ser 'YYYY-MM-DD'."), MessageBox.Ok, MessageBox.NoButton);
                                return false;
                        }
                        break;
                }
                case "datetime":
                case "DateTime": {
                        if(str.length != 19) {
                                //sys.warnMsgBox(sys.translate("El formato de la fecha debe ser 'YYYY-MM-DDThh:mm:ss'."));
                                MessageBox.warning(util.translate("scripts", "El formato de la fecha debe ser 'YYYY-MM-DDThh:mm:ss'."), MessageBox.Ok, MessageBox.NoButton);
                                return false;
                        }
                        break;
                }
                default: {
                                debug("ERROR: Recibido un valor de tipo desconocido: " + tipo + ". Valor: " + valor + ". tipo: " + typeOf);

                        //sys.warnMsgBox(sys.translate("Formato no vlido."))
                        MessageBox.warning(util.translate("scripts", "El valor debe ser una cadena de texto."), MessageBox.Ok, MessageBox.NoButton);
                        return false;
                        break;
                }
        }
        return true;
}

function oficial_formateaFecha(fecha, tipoFecha)
{
        var _i = this.iface;

        var anyo, mes, dia, hora, minuto, segundo, milisegundo;

        switch(tipoFecha){
                case "AMDhms": {
                        hora = fecha.getHours().toString();
                        minuto = fecha.getMinutes().toString();
                        segundo = fecha.getSeconds().toString();
                        milisegundo = fecha.getMilliseconds().toString();
                        anyo = fecha.getYear().toString();
                        mes = fecha.getMonth().toString();
                        dia = fecha.getDate().toString();
                        break;
                }
                case "A-M-D":
                case "AMD": {
                        hora = "";
                        minuto = "";
                        segundo = "";
                        milisegundo = "";
                        anyo = fecha.getYear().toString();
                        mes = fecha.getMonth().toString();
                        dia = fecha.getDate().toString();
                        break;
                }
                default: {
                        return "";
                }
        }

        if(hora != "" && hora.length < 2) {
                hora = flfactppal.iface.pub_cerosIzquierda(hora,2);
        }
        if(minuto != "" && minuto.length < 2) {
                minuto = flfactppal.iface.pub_cerosIzquierda(minuto,2);
        }
        if(segundo != "" && segundo.length < 2) {
                segundo = flfactppal.iface.pub_cerosIzquierda(segundo,2);
        }
        if(anyo != "" && anyo.length < 4) {
                anyo = flfactppal.iface.pub_cerosIzquierda(anyo,4);
        }
        if(mes != "" && mes.length < 2) {
                mes = flfactppal.iface.pub_cerosIzquierda(mes,2);
        }
        if(dia != "" && dia.length < 2) {
                dia = flfactppal.iface.pub_cerosIzquierda(dia,2);
        }
        if(milisegundo != "" && milisegundo.length < 5) {
                milisegundo = flfactppal.iface.pub_cerosIzquierda(milisegundo,5);
        }
        else if(milisegundo > 5){
                milisegundo = milisegundo.toString().left(5);
        }

        var nuevaFecha;

        if(tipoFecha == "A-M-D") {
                nuevaFecha = anyo + "-" + mes + "-" + dia;
        }
        else {
                nuevaFecha = anyo + mes + dia + hora + minuto + segundo + milisegundo;
        }


        return nuevaFecha;
}

function oficial_formateaCadena(cIn)
{
        var cOut = "";
        var equivA = "";
        var equivB = "NnCcAaEeIiOoUuAaEeIiOoUuAaEeIiOoUuAaEeIiOoUu";
        var validos = "1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ /-?+:,.()";
        var iEq;
        for (var i = 0; i < cIn.length; i++) {
                iEq = equivA.find(cIn.charAt(i));
                if (iEq >= 0) {
                        cOut += equivB.charAt(iEq);
                } else {
                        if (validos.find(cIn.charAt(i)) >= 0) {
                                cOut += cIn.charAt(i);
                        }
                }
        }
        return cOut;
}

function oficial_bngFormatoFichero_clicked(opcion)
{
        var _i = this.iface;

        switch (opcion) {
                case 0: {
                        _i.extensionFichero_ = "txt";
                        this.child("gbxTipoPago").close();
                        break;
                }
                case 1: {
                        _i.extensionFichero_ = "xml";
                        this.child("gbxTipoPago").show();
                        break;
                }
                default: {
                        return false;
                }
        }
}

function oficial_bngTipoPago_clicked(opcion)
{
        var _i = this.iface;

        switch (opcion) {
                case 0: {
                        _i.tipoPago_ = "RCUR";
                        break;
                }
                case 1: {
                        _i.tipoPago_ = "OOFF";
                        break;
                }
                default: {
                        return false;
                }
        }
}

function oficial_bngTipoFichero_clicked(opcion)
{
        var _i = this.iface;

        switch (opcion) {
                case 0: {
                        _i.tipoFichero_ = "CORE";
                        break;
                }
                case 1: {
                        _i.tipoFichero_ = "B2B";
                        break;
                }
                case 2: {
                        _i.tipoFichero_ = "CORE1*";
                        break;
                }
                default: {
                        return false;
                }
        }

}

function oficial_comprobarValidate()
{
        var _i = this.iface;
        var cursor = this.cursor();
        var util:FLUtil = new FLUtil;

        var aDatosCuentas = _i.comprobarMandatos();

        if(!aDatosCuentas || aDatosCuentas.length == 0) {
                return false;
        }
        if(!aDatosCuentas[0]) {
                return true;
        }

        var mensaje = "";

        if(aDatosCuentas[1].length != 0) {
                mensaje += "Hay " + aDatosCuentas[1].length + " recibos que no tienen cuentas vlidas.\n";
        }
        if(aDatosCuentas[2].length != 0) {
                mensaje += "Hay " + aDatosCuentas[2].length + " cuentas que no tienen IBAN vlido.\n";
        }
        if(aDatosCuentas[4].length != 0) {
                mensaje += "Hay " + aDatosCuentas[4].length + " cuentas que no tienen BIC vlido.\n";
        }
        if(aDatosCuentas[3].length != 0) {
                mensaje += "Hay " + aDatosCuentas[3].length + " cuentas que no tienen mandatos vlidos.\n";
        }
        if(aDatosCuentas[5].length != 0) {
                mensaje += "Falta el cdigo BIC para la cuenta del acreedor.\n";
                debug("cuentas: " + aDatosCuentas[5][0][1] + " . " + aDatosCuentas[5][0][1]);
        }

        mensaje += "\nPuede exportarlas a un fichero pulsando el botn 'Exportar cuentas con mandatos errneos', en el formulario actual.\n\n"


        //if(aDatosCuentas[1].length != 0 || aDatosCuentas[2].length != 0 || aDatosCuentas[4].length != 0) {
        if(aDatosCuentas[1].length != 0 || aDatosCuentas[2].length != 0) {
                mensaje += "Debe rectificar los recibos/cuentas errneos para poder remesar los recibos.";
                //sys.infoMsgBox(sys.translate(mensaje));
                MessageBox.warning(util.translate("scripts", mensaje), MessageBox.Ok, MessageBox.NoButton);
                return false;
        }
        else if(_i.tipoFichero_ != "B2B") {
                mensaje += "De todas formas, Quiere continuar? Se asignarn valores de mandato por defecto.";

                var res = MessageBox.information(sys.translate(mensaje), MessageBox.Yes, MessageBox.No, MessageBox.NoButton);
                 if (res != MessageBox.Yes) {
                    return false;
                  }
        }
        else {
                mensaje += "En un adeudo B2B debe incluir slo mandatos vlidos.";
                //sys.infoMsgBox(sys.translate(mensaje));
                MessageBox.information(util.translate("scripts", mensaje), MessageBox.Ok, MessageBox.NoButton);
                return false;
        }

        return true;
}

function oficial_comprobarMandatos()
{
        var _i = this.iface;
        var cursor = this.cursor();
        var util:FLUtil = new FLUtil;

        var recibosError = [];
        var cuentasError = [];
        var bicError = [];
        var mandatosError = [];
        var bicErrorBanco = [];

        var error = false;

        var idRemesa = cursor.valueBuffer("idremesa");
        var fechaRem = cursor.valueBuffer("fechacargo");

        var qryRecibos = new FLSqlQuery();
        var groupBy = " GROUP BY codigo, codcliente, nombrecliente, codcuenta";
          qryRecibos.setSelect("codigo, codcliente, nombrecliente, codcuenta");
          qryRecibos.setFrom("reciboscli");
          qryRecibos.setWhere("idremesa = " + idRemesa + " " + groupBy);

          if (!qryRecibos.exec()) {
                //sys.warnMsgBox("Error query.");
                MessageBox.information(sys.translate("Error query."), MessageBox.Yes, MessageBox.No, MessageBox.NoButton);
                  return false;
          }

        while(qryRecibos.next()){
                var curRecibos = new FLSqlCursor("reciboscli");
                //                     curRecibos.select("codcliente = '" + qryRecibos.value("r.codcliente") + "' AND nombrecliente = '" + qryRecibos.value("r.nombrecliente") + "' AND codcuenta = '" + qryRecibos.value("r.codcuenta") + "' AND idrecibo IN (SELECT idrecibo FROM pagosdevolcli WHERE idremesa = " + cursor.valueBuffer("idremesa") + ")");
                curRecibos.select("codcliente = '" + qryRecibos.value("codcliente") + "' AND nombrecliente like '" + _i.quitaApostrofes(qryRecibos.value("nombrecliente")) + "' AND codcuenta = '" + qryRecibos.value("codcuenta") + "' AND idrecibo IN (SELECT idrecibo FROM reciboscli WHERE idremesa = " + cursor.valueBuffer("idremesa") + ")");

                if(!qryRecibos.value("codcuenta") || qryRecibos.value("codcuenta") == "") {
                                var nArray = [qryRecibos.value("codigo"),qryRecibos.value("codcliente"),qryRecibos.value("nombrecliente")];
                                recibosError.push(nArray);
                                error = true;
                                continue;
                }

                while(curRecibos.next()) {
                        curRecibos.setModeAccess(curRecibos.Browse);
                        curRecibos.refreshBuffer();

                        var codCuenta = curRecibos.valueBuffer("codcuenta");
                        var codCuentaBanco = curRecibos.valueBuffer("codcuenta");
                        var nombre = curRecibos.valueBuffer("nombrecliente");
                        var codCliente = curRecibos.valueBuffer("codcliente");
                        var fechaRec = curRecibos.valueBuffer("fecha");
                        var fechaRecV = curRecibos.valueBuffer("fechav");
                        var IBAN = AQUtil.sqlSelect("cuentasbcocli","iban","codcuenta = '" + codCuenta + "'");
                        var BIC = AQUtil.sqlSelect("cuentasbcocli","bic","codcuenta = '" + codCuenta + "'");
                        var BICCuentaBanco = AQUtil.sqlSelect("cuentasbanco","bic","codcuenta = '" + codCuentaBanco + "'");
                        var IBANBanco = AQUtil.sqlSelect("cuentasbanco","iban","codcuenta = '" + codCuentaBanco + "'");

                        if(!IBAN || IBAN == "") {
                                var encontrado = false;
                                for(var i = 0; i < cuentasError.length; i++) {
                                        if(cuentasError[i][0] == codCuenta) {
                                                encontrado = true;
                                                break;
                                        }
                                }
                                if(!encontrado) {
                                        var nArray = [codCuenta,codCliente,nombre];
                                        cuentasError.push(nArray);
                                        error = true;
                                }
                        }

                        if(!BIC || BIC == "") {
                                var encontrado = false;
                                for(var i = 0; i < bicError.length; i++) {
                                        if(bicError[i][0] == codCuenta) {
                                                encontrado = true;
                                                break;
                                        }
                                }
                                if(!encontrado) {
                                        if(!IBAN || IBAN == "") {
                                                IBAN = "noIBAN";
                                        }
                                        var nArray = [codCuenta,IBAN,codCliente,nombre];
                                        bicError.push(nArray);
                                        error = true;
                                }
                        }

                        if(!BICCuentaBanco || BICCuentaBanco == "") {
                                var encontrado = false;
                                for(var i = 0; i < bicErrorBanco.length; i++) {
                                        if(bicErrorBanco[i][0] == codCuentaBanco) {
                                                encontrado = true;
                                                break;
                                        }
                                }
                                if(!encontrado) {
                                        if(!IBANBanco || IBANBanco == "") {
                                                IBANBanco = "noIBAN";
                                        }
                                        var nArray = [codCuentaBanco,IBANBanco,];
                                        debug("No se encuentra el Bic del banco para codCuenta:" + codCuentaBanco + " IBAN:" + IBANBanco);
                                        //bicErrorBanco.push(nArray);
                                        //error = true;
                                }
                        }

                        var curMandato = new FLSqlCursor("mandatoscli");
                        curMandato.select("codcuentacliente = '" + codCuenta + "' AND tipo = '" + _i.tipoFichero_ + "' AND (fechafirma < '" + fechaRecV + "' OR fechafirma IS NULL)");

                        if(curMandato.size() == 0) {
                                var encontrado = false;
                                for(var i = 0; i < mandatosError.length; i++) {
                                        if(mandatosError[i][0] == codCuenta) {
                                                encontrado = true;
                                                break;
                                        }
                                }
                                if(!encontrado) {
                                        if(!IBAN || IBAN == "") {
                                                IBAN = "noIBAN";
                                        }
                                        var nArray = [codCuenta,IBAN,codCliente,nombre];
                                        mandatosError.push(nArray);
                                }
                        }
                } while(curRecibos.next());
        }

        var aDatosCuentas = [];
        aDatosCuentas.push(error);
        aDatosCuentas.push(recibosError);
        aDatosCuentas.push(cuentasError);
        aDatosCuentas.push(mandatosError);
        aDatosCuentas.push(bicError);
        aDatosCuentas.push(bicErrorBanco);

        return aDatosCuentas;
}

function oficial_tbnExportarErroneos_clicked() {
        var _i = this.iface;
        var cursor = this.cursor();
        var util:FLUtil = new FLUtil;
        var aDatosCuentas = _i.comprobarMandatos();

        if(!aDatosCuentas || aDatosCuentas.length == 0) {
                return false;
        }
        if(!aDatosCuentas[0]) {
                //sys.infoMsgBox(sys.translate("Todos los recibos, cuentas y mandatos son vlidos, no se generar el fichero."));
                MessageBox.warning(util.translate("scripts", "Todos los recibos, cuentas y mandatos son vlidos"), MessageBox.Ok, MessageBox.NoButton);
                return false;
        }

        if(aDatosCuentas[1].length != 0 || aDatosCuentas[2].length != 0 || aDatosCuentas[3].length != 0 || aDatosCuentas[4].length != 0) {
                var archivo = FileDialog.getSaveFileName("*.txt");

                if(!archivo || archivo == "") {
                        return false;
                }

                if(!archivo.endsWith(".txt")) {
                        archivo += ".txt";
                }

                var file = new File(archivo);
                file.open(File.WriteOnly);

                var mensaje = "";

                if(aDatosCuentas[1].length != 0) {
                        mensaje += "Los siguientes recibos no tienen cuentas vlidos:\n\n";
                        for(var i = 0; i < aDatosCuentas[1].length; i++) {
                                mensaje += "     Recibo " + aDatosCuentas[1][i][0] + " del cliente " + aDatosCuentas[1][i][1] + " - " + aDatosCuentas[1][i][2] + "\n";
                        }
                        mensaje += "\n\n";
                }
                if(aDatosCuentas[2].length != 0) {
                        mensaje += "Las siguientes cuentas no tienen IBAN vlido:\n\n";
                        for(var i = 0; i < aDatosCuentas[2].length; i++) {
                                mensaje += "     Cuenta " + aDatosCuentas[2][i][0] + " del cliente " + aDatosCuentas[2][i][1] + " - " + aDatosCuentas[2][i][2] + "\n";
                        }
                        mensaje += "\n\n";
                }
                if(aDatosCuentas[3].length != 0) {
                        mensaje += "Las siguientes cuentas no tienen mandatos vlidos:\n\n";
                        for(var i = 0; i < aDatosCuentas[3].length; i++) {
                                mensaje += "     Cuenta " + aDatosCuentas[3][i][0] + " - " + aDatosCuentas[3][i][1] + " del cliente " + aDatosCuentas[3][i][2] + " - " + aDatosCuentas[3][i][3] + "\n";
                        }
                        mensaje += "\n\n";
                }
                if(aDatosCuentas[4].length != 0) {
                        mensaje += "Las siguientes cuentas no tienen BIC vlido:\n\n";
                        for(var i = 0; i < aDatosCuentas[4].length; i++) {
                                mensaje += "     Cuenta " + aDatosCuentas[4][i][0] + " - " + aDatosCuentas[4][i][1] + " del cliente " + aDatosCuentas[4][i][2] + " - " + aDatosCuentas[4][i][3] + "\n";
                        }
                        mensaje += "\n\n";
                }

                file.write(mensaje);
                file.close();

                //sys.infoMsgBox(sys.translate("El fichero se ha generado con xito en %1").arg(archivo));
                MessageBox.information(util.translate("scripts", "El fichero se ha generado con xito en %1").arg(archivo), MessageBox.Ok, MessageBox.NoButton);
        }
        else {
                //sys.infoMsgBox(sys.translate("Todos los recibos, cuentas y mandatos son vlidos, no se generar el fichero."));
                MessageBox.warning(util.translate("scripts", "Todos los recibos, cuentas y mandatos son vlidos, no se generar el fichero."), MessageBox.Ok, MessageBox.NoButton);
        }

        return true;
}

function oficial_quitaApostrofes(texto){

        var cOut = "";
        var apostrofe = "'";
        for (var i = 0; i < texto.length; i++) {
                if(texto.charAt(i) == apostrofe){
                        cOut += '%';
                }
                else{
                        cOut += texto.charAt(i);
                }
        }
        debug(cOut);
        return cOut;
}

//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition mix9049x9043 */
/////////////////////////////////////////////////////////////////
//// MIX_9049_9043 //////////////////////////////////////////////

function mix9049x9043_incluirRegistroAdeudoTP(qryRecibos,file)
{
	var _i = this.iface;
	var cursor = this.cursor();

	var curRecibos = new FLSqlCursor("reciboscli");
	curRecibos.select("codcliente = '" + qryRecibos.value("codcliente") + "' AND codcuenta = '" + qryRecibos.value("codcuenta") + "' AND  idremesa = " + cursor.valueBuffer("idremesa"));

	if(!curRecibos.first()) {
		sys.warnMsgBox(sys.translate("No se han encontrado recibos válidos para el cliente %1").arg(qryRecibos.value("nombrecliente")));
		return false;
	}

	do{
		curRecibos.setModeAccess(curRecibos.Browse);
		curRecibos.refreshBuffer();

		_i.linea_ = "";

		var fechaRem = cursor.valueBuffer("fechacargo");
		var codCuenta = curRecibos.valueBuffer("codcuenta");
		var nombre = curRecibos.valueBuffer("nombrecliente");
		var codCliente = curRecibos.valueBuffer("codcliente");
		var fechaRec = curRecibos.valueBuffer("fecha");
		var fechaCargo = _i.formateaFecha(fechaRem,"AMD");
		var BIC = AQUtil.sqlSelect("cuentasbcocli","bic","codcuenta = '" + codCuenta + "'");
		var IBAN = AQUtil.sqlSelect("cuentasbcocli","iban","codcuenta = '" + codCuenta + "'");

		var curMandato = new FLSqlCursor("mandatoscli");
		curMandato.select("codcuentacliente = '" + codCuenta + "' AND tipo = '" + _i.tipoFichero_ + "' AND (fechafirma < '" + fechaRec + "' OR fechafirma IS NULL)");

		switch (curMandato.size()) {
			case 0: {
				sys.warnMsgBox(sys.translate("No se ha encontrado un mandato para la cuenta %1 del cliente %2-%3").arg(codCuenta).arg(codCliente).arg(nombre));
				break;
			}
			case 1: {
				break;
			}
			default: {
				var mandatoEncontrado = false;

				for(var ind = 0; ind < aCuentasMandato_.length; ind++) {
					if(aCuentasMandato_[ind] == codCuenta) {
						curMandato.select("idmandato = " + aMandatoElegido_[ind]);
						mandatoEncontrado = true;
					}
				}

				if(!mandatoEncontrado) {
					var opId = [];
					var opDes = [];

					while (curMandato.next()) {
						curMandato.setModeAccess(curMandato.Browse);
						curMandato.refreshBuffer();

						opId.push(curMandato.valueBuffer("idmandato"));
						opDes.push(curMandato.valueBuffer("refmandato") + " - " + curMandato.valueBuffer("descripcion"));
					}

					var idOpcion = flfactppal.iface.pub_elegirOpcion(opDes, sys.translate("Escoja mandato para la cuenta %1 del cliente %2 - %3").arg(codCuenta).arg(codCliente).arg(nombre));

					if (idOpcion < 0) {
						return false;
					}

					curMandato.select("idmandato = " + opId[idOpcion]);
					aCuentasMandato_.push(codCuenta);
					aMandatoElegido_.push(opId[idOpcion]);
				}
				break;
			}
		}

		var refMandato;
		var fechaCad;
		var numEfectos;
		var tipoPago;
		var fechaFirma;

		var mandatoPorDefecto = false;

		if (!curMandato.first()) {
			refMandato = flfacturac.iface.pub_cerosIzquierda(codCliente,6) + flfacturac.iface.pub_cerosIzquierda("0", 29);
			fechaCad = "20091031";
			numEfectos = 0;
			tipoPago = "Pago Recurrente";
			fechaFirma = "20091031";
			mandatoPorDefecto = true;
		}
		else {
			curMandato.setModeAccess(curMandato.Edit);
			curMandato.refreshBuffer();

			refMandato = curMandato.valueBuffer("refmandato");
			fechaCad = curMandato.valueBuffer("fechacaducidad");
			fechaCad = _i.formateaFecha(fechaCad,"AMD");
			numEfectos = curMandato.valueBuffer("numefectos");
			tipoPago = curMandato.valueBuffer("tipopago");
			fechaFirma = curMandato.valueBuffer("fechafirma");

			if(!fechaFirma || fechaFirma == "") {
				fechaFirma = "20091031";
			}
			else {
				fechaFirma = _i.formateaFecha(fechaFirma,"AMD");
			}
		}

		var tipoAdeudo;

		if(numEfectos != 0) {
			tipoAdeudo = "RCUR";
		}
		else {
			if(tipoPago == "Pago Recurrente") {
				tipoAdeudo = "FRST";
			}
			else {
				tipoAdeudo = "OOFF";
			}
		}

		if(!_i.addCampo(3,"num",2, 2)) {return false;}
		if(_i.tipoFichero_ == "B2B") {
			if(!_i.addCampo(19445,"num",5,7)) {return false;}
		}
		else if(_i.tipoFichero_ == "CORE") {
			if(!_i.addCampo(19143,"num",5,7)) {return false;}
		}
		else if(_i.tipoFichero_ == "CORE1*") {
			if(!_i.addCampo(19154,"num",5,7)) {return false;}
		}
		else {
			return false;
		}

		if(!IBAN || IBAN == "") {
			sys.warnMsgBox(sys.translate("Falta el código IBAN para la cuenta %1 del cliente %2").arg(codCuenta).arg(nombre));
			return false;
		}

		/*if(!BIC || BIC == "") {
			sys.warnMsgBox(sys.translate("Falta el código BIC para la cuenta con IBAN %1 del cliente %2").arg(IBAN).arg(nombre));
			return false;
		}*/

		if(!_i.addCampo(3,"num",3,10)) {return false;}
		if(!_i.addCampo(curRecibos.valueBuffer("codigo"),"String",35,45)) {return false;}
		if(!_i.addCampo(refMandato,"String",35,80)) {return false;}
		if(!_i.addCampo(tipoAdeudo,"String",4,84)) {return false;}
		if(!_i.addCampo(_i.rellenarVacios("","String",4),"String",4,88)) {return false;}
		if(!_i.addCampo(curRecibos.valueBuffer("importe"),"numDec",11,99)) {return false;}
		if(!_i.addCampo(fechaFirma,"String",8,107)) {return false;}
		if(!_i.addCampo(BIC,"String",11,118)) {return false;}
		if(!_i.addCampo(curRecibos.valueBuffer("nombrecliente"),"String",70,188)) {return false;}
		if(!_i.addCampo(_i.rellenarVacios("","String",50),"String",50,238)) {return false;}
		if(!_i.addCampo(_i.rellenarVacios("","String",50),"String",50,288)) {return false;}
		if(!_i.addCampo(_i.rellenarVacios("","String",40),"String",40,328)) {return false;}
		if(!_i.addCampo(_i.rellenarVacios("","String",2),"String",2,330)) {return false;}
		if(!_i.addCampo(_i.rellenarVacios("","String",1),"num",1,331)) {return false;}
		if(!_i.addCampo(_i.rellenarVacios("","String",36),"String",36,367)) {return false;}
		if(!_i.addCampo(_i.rellenarVacios("","String",35),"String",35,402)) {return false;}
		if(!_i.addCampo("A","String",1,403)) {return false;}
		if(!_i.addCampo(IBAN,"String",34,437)) {return false;}
		if(!_i.addCampo(_i.rellenarVacios("","String",4),"String",4,441)) {return false;}
		if(!_i.addCampo(_i.rellenarVacios("","String",140),"String",140,581)) {return false;}
		if(!_i.addCampo(_i.rellenarVacios("","String",19),"String",19,600)) {return false;}

		if(!mandatoPorDefecto) {
			numEfectos++;
			curMandato.setValueBuffer("numefectos", numEfectos);
			curMandato.setValueBuffer("fechaultadeudo", cursor.valueBuffer("fechacargo"));
			curMandato.setValueBuffer("fechacaducidad", formRecordmandatoscli.iface.pub_commonCalculateField("fechacaducidad", curMandato));

			if (!curMandato.commitBuffer()) {
				return false;
			}
		}

		file.writeLine(_i.linea_);
		_i.linea_ = "";

	}while(curRecibos.next());

	return true;
}

function mix9049x9043_incluirOperacionAdeudoXML(nodoPadre,qryRecibos)
{
	var _i = this.iface;
	var cursor = this.cursor();

	var curRecibos = new FLSqlCursor("reciboscli");
	curRecibos.select("codcliente = '" + qryRecibos.value("codcliente") + "' AND codcuenta = '" + qryRecibos.value("codcuenta") + "' AND  idremesa = " + cursor.valueBuffer("idremesa"));

	if(!curRecibos.first()) {
		sys.warnMsgBox(sys.translate("No se han encontrado recibos válidos para el cliente %1").arg(qryRecibos.value("nombrecliente")));
		return false;
	}

	do{
		curRecibos.setModeAccess(curRecibos.Browse);
		curRecibos.refreshBuffer();

		var fechaRem = cursor.valueBuffer("fechacargo");
		var codCuenta = curRecibos.valueBuffer("codCuenta");
		var codCliente = curRecibos.valueBuffer("codcliente");
		var nombre = curRecibos.valueBuffer("nombrecliente");
		var fechaRec = curRecibos.valueBuffer("fecha");

		var curMandato = new FLSqlCursor("mandatoscli");
		curMandato.select("codcuentacliente = '" + codCuenta + "' AND tipo = '" + _i.tipoFichero_ + "' AND (fechafirma < '" + fechaRec + "' OR fechafirma IS NULL)");

		switch (curMandato.size()) {
			case 0: {
				sys.warnMsgBox(sys.translate("No se ha encontrado un mandato para la cuenta %1 del cliente %2-%3").arg(codCuenta).arg(codCliente).arg(nombre));
				break;
			}
			case 1: {
				break;
			}
			default: {
				var mandatoEncontrado = false;

				for(var ind = 0; ind < aCuentasMandato_.length; ind++) {
					if(aCuentasMandato_[ind] == codCuenta) {
						curMandato.select("idmandato = " + aMandatoElegido_[ind]);
						mandatoEncontrado = true;
					}
				}

				if(!mandatoEncontrado) {
					var opId = [];
					var opDes = [];

					while (curMandato.next()) {
						curMandato.setModeAccess(curMandato.Browse);
						curMandato.refreshBuffer();

						opId.push(curMandato.valueBuffer("idmandato"));
						opDes.push(curMandato.valueBuffer("refmandato") + " - " + curMandato.valueBuffer("descripcion"));
					}

					var idOpcion = flfactppal.iface.pub_elegirOpcion(opDes, sys.translate("Escoja mandato para la cuenta %1 del cliente %2 - %3").arg(codCuenta).arg(codCliente).arg(nombre));

					if (idOpcion < 0) {
						return false;
					}

					curMandato.select("idmandato = " + opId[idOpcion]);
					aCuentasMandato_.push(codCuenta);
					aMandatoElegido_.push(opId[idOpcion]);
				}
				break;
			}
		}

		var refMandato;
		var fechaCad;
		var numEfectos;
		var tipoPago;
		var fechaFirma;

		var mandatoPorDefecto = false;

		if (!curMandato.first()) {
			refMandato = flfacturac.iface.pub_cerosIzquierda(codCliente,6) + flfacturac.iface.pub_cerosIzquierda("0", 29);
			fechaCad = "2009-10-31";
			numEfectos = 0;
			tipoPago = "Pago Recurrente";
			mandatoPorDefecto = true;
			fechaFirma = "2009-10-31";
		}
		else {
			curMandato.setModeAccess(curMandato.Edit);
			curMandato.refreshBuffer();

			debug("refMandato " + refMandato);

			refMandato = curMandato.valueBuffer("refmandato");
			fechaCad = curMandato.valueBuffer("fechacaducidad");
			fechaCad = _i.formateaFecha(fechaCad,"A-M-D");
			numEfectos = curMandato.valueBuffer("numefectos");
			tipoPago = curMandato.valueBuffer("tipopago");
			fechaFirma = curMandato.valueBuffer("fechafirma");

			if(!fechaFirma || fechaFirma == "") {
				fechaFirma = "2009-10-31";
			}
			else {
				fechaFirma = _i.formateaFecha(fechaFirma,"A-M-D");
			}
		}

		var tipoAdeudo;

		if(numEfectos != 0) {
			tipoAdeudo = "RCUR";
		}
		else {
			if(tipoPago == "Pago Recurrente") {
				tipoAdeudo = "FRST";
			}
			else {
				tipoAdeudo = "OOFF";
			}
		}

		var eDrctDbtTxInf = _i.colgarNodo("DrctDbtTxInf",nodoPadre);

		var bicBanco = AQUtil.sqlSelect("cuentasbcocli","bic","codcuenta = '" + curRecibos.valueBuffer("codcuenta") + "'");
		var IBAN = AQUtil.sqlSelect("cuentasbcocli","iban","codcuenta = '" + curRecibos.valueBuffer("codcuenta") + "'");

		var ePmtId = _i.colgarNodo("PmtId",eDrctDbtTxInf);

		var eEndToEndId = _i.colgarNodo("EndToEndId",ePmtId);
		if (!_i.colgarNodoTexto(eEndToEndId,curRecibos.valueBuffer("codigo"),"String",1,35)) {return false;}

		var eInstdAmt = _i.colgarNodo("InstdAmt",eDrctDbtTxInf);
		eInstdAmt.setAttribute("Ccy",curRecibos.valueBuffer("coddivisa"));

		var importeRecibo = curRecibos.valueBuffer("importe");
		importeRecibo = AQUtil.roundFieldValue(importeRecibo,"facturascli","totaliva");

		if (!_i.colgarNodoTexto(eInstdAmt,importeRecibo,"double",3,12,2)) {return false;}

		/* 0 o 1 veces */
		if(1==1){
			var eDrctDbtTx = _i.colgarNodo("DrctDbtTx",eDrctDbtTxInf);

			var eMndtRltdInf = _i.colgarNodo("MndtRltdInf",eDrctDbtTx);

			var eMndtId = _i.colgarNodo("MndtId",eMndtRltdInf);
			if (!_i.colgarNodoTexto(eMndtId,refMandato,"String",1,35)) {return false;}

			var eDtOfSgntr = _i.colgarNodo("DtOfSgntr",eMndtRltdInf);
			if (!_i.colgarNodoTexto(eDtOfSgntr,fechaFirma,"Date",8,10)) {return false;}
		}

		var eDbtrAgt = _i.colgarNodo("DbtrAgt",eDrctDbtTxInf);

		var eFinInstnId = _i.colgarNodo("FinInstnId",eDbtrAgt);

		if(!IBAN || IBAN == "") {
			sys.warnMsgBox(sys.translate("Falta el código IBAN para la cuenta %1 del cliente %2").arg(codCuenta).arg(nombre));
			return false;
		}

		/*if(!bicBanco || bicBanco == "") {
			sys.warnMsgBox(sys.translate("Falta el código BIC para la cuenta con IBAN %1 del cliente %2").arg(IBAN).arg(nombre));
			return false;
		}*/

		var eBIC = _i.colgarNodo("BIC",eFinInstnId);
		if (!_i.colgarNodoTexto(eBIC,bicBanco,"String")) {return false;}

		if(!_i.incluirDeudorXML(eDrctDbtTxInf,qryRecibos)){
			return false;
		}

		var eDbtrAcct = _i.colgarNodo("DbtrAcct",eDrctDbtTxInf);

		var eId = _i.colgarNodo("Id",eDbtrAcct);

		var eIBAN = _i.colgarNodo("IBAN",eId);
		if (!_i.colgarNodoTexto(eIBAN,IBAN,"String")) {return false;}

		if(!mandatoPorDefecto) {
			numEfectos++;
			curMandato.setValueBuffer("numefectos", numEfectos);
			curMandato.setValueBuffer("fechaultadeudo", cursor.valueBuffer("fechacargo"));
			curMandato.setValueBuffer("fechacaducidad", formRecordmandatoscli.iface.pub_commonCalculateField("fechacaducidad", curMandato));

			if (!curMandato.commitBuffer()) {
				return false;
			}
		}

	}while(curRecibos.next());

	return true;
}

//// MIX_9049_9043 //////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition mandatoscliCuentas */
/////////////////////////////////////////////////////////////////
//// MANDATOSCLICUENTAS /////////////////////////////////////////
/*Adaptacin para relacin de mandatos con mltiples cuentas de cliente*/
function mandatoscliCuentas_incluirRegistroAdeudoTP(qryRecibos,file,cursor)
{
        var _i = this.iface;
        //var cursor = this.cursor();

        var curRecibos = new FLSqlCursor("reciboscli");
        //var idRecibos:String = formRecordremesas.iface.idRecibosRemesa(cursor.valueBuffer("idremesa"));
        curRecibos.select("codcliente = '" + qryRecibos.value("r.codcliente") + "' AND fechav = '" + qryRecibos.value("r.fechav") + "' AND codcuenta = '" + qryRecibos.value("r.codcuenta") + "' AND idrecibo IN (SELECT idrecibo FROM pagosdevolcli WHERE idremesa = " + cursor.valueBuffer("idremesa") + ")");

        if(!curRecibos.first()) {
                flfactppal.iface.ponMsgError(sys.translate("No se han encontrado recibos vlidos para el cliente %1").arg(qryRecibos.value(1)), "warn");
                //MessageBox.warning(sys.translate("No se han encontrado recibos válidos para el cliente %1").arg(qryRecibos.value("nombrecliente")));
                return false;
        }

        do{
                curRecibos.setModeAccess(curRecibos.Browse);
                curRecibos.refreshBuffer();

                _i.linea_ = "";

                var fechaRem = cursor.valueBuffer("fechacargo");
                var codCuenta = curRecibos.valueBuffer("codcuenta");
                var nombre = curRecibos.valueBuffer("nombrecliente");
                var codCliente = curRecibos.valueBuffer("codcliente");
                var fechaRec = curRecibos.valueBuffer("fecha");
                var fechaCargo = _i.formateaFecha(fechaRem,"AMD");
                var BIC = AQUtil.sqlSelect("cuentasbcocli","bic","codcuenta = '" + codCuenta + "'");
                var IBAN = AQUtil.sqlSelect("cuentasbcocli","iban","codcuenta = '" + codCuenta + "'");

                var curMandato = new FLSqlCursor("mandatoscli");
		var select:String;
		if ( aqApp.db().driverName().startsWith("FLQPSQL"))
			{
                	select = "array_to_string(array_agg(idmandato),',')";
			}
		else
			{
			select = "GROUP_CONCAT(idmandato)";
			}

		var idsValidos = AQUtil.sqlSelect("mandatoscli", select ,"codcuentacliente='"+codCuenta+"' AND tipo = '"+ _i.tipoFichero_ +"' AND (fechafirma < '" + fechaRec + "' OR fechafirma IS NULL)","mandatoscli");
                if (!idsValidos || idsValidos == "") idsValidos = "-1";
                curMandato.select("idmandato IN ("+idsValidos+")");

                switch (curMandato.size()) {
                        case 0: {
                                break;
                        }
                        case 1: {
                                break;
                        }
                        default: {
                                var mandatoEncontrado = false;

                                for(var ind = 0; ind < aCuentasMandato_.length; ind++) {
                                        if(aCuentasMandato_[ind] == codCuenta) {
                                                curMandato.select("idmandato = " + aMandatoElegido_[ind]);
                                                mandatoEncontrado = true;
                                        }
                                }

                                if(!mandatoEncontrado) {
                                        var opId = [];
                                        var opDes = [];

                                        while (curMandato.next()) {
                                                curMandato.setModeAccess(curMandato.Browse);
                                                curMandato.refreshBuffer();

                                                opId.push(curMandato.valueBuffer("idmandato"));
                                                opDes.push(curMandato.valueBuffer("refmandato") + " - " + curMandato.valueBuffer("descripcion"));
                                        }

                                        var idOpcion = flfactppal.iface.pub_elegirOpcion(opDes, sys.translate("Escoja mandato para la cuenta %1 del cliente %2 - %3").arg(codCuenta).arg(codCliente).arg(nombre));

                                        if (idOpcion < 0) {
                                                return false;
                                        }

                                        curMandato.select("idmandato = " + opId[idOpcion]);
                                        aCuentasMandato_.push(codCuenta);
                                        aMandatoElegido_.push(opId[idOpcion]);
                                }
                                break;
                        }
                }

                var refMandato;
                var fechaCad;
                var numEfectos;
                var tipoPago;
                var fechaFirma;

                var mandatoPorDefecto = false;

                if (!curMandato.first()) {
                        refMandato = flfacturac.iface.pub_cerosIzquierda(codCliente,6) + flfacturac.iface.pub_cerosIzquierda("0", 29);
                        fechaCad = "20091031";
                        numEfectos = 0;
                        tipoPago = "Pago Recurrente";
                        fechaFirma = "20091031";
                        mandatoPorDefecto = true;
                }
                else {
                        curMandato.setModeAccess(curMandato.Edit);
                        curMandato.refreshBuffer();

                        refMandato = curMandato.valueBuffer("refmandato");
                        fechaCad = curMandato.valueBuffer("fechacaducidad");
                        fechaCad = _i.formateaFecha(fechaCad,"AMD");
                        numEfectos = curMandato.valueBuffer("numefectos");
                        tipoPago = curMandato.valueBuffer("tipopago");
                        fechaFirma = curMandato.valueBuffer("fechafirma");

                        if(!fechaFirma || fechaFirma == "") {
                                fechaFirma = "20091031";
                        }
                        else {
                                fechaFirma = _i.formateaFecha(fechaFirma,"AMD");
                        }
                }

                var tipoAdeudo;

                if(numEfectos != 0) {
                        tipoAdeudo = "RCUR";
                }
                else {
                        if(tipoPago == "Pago Recurrente") {
                                tipoAdeudo = "FRST";
                        }
                        else {
                                tipoAdeudo = "OOFF";
                        }
                }

                if(!_i.addCampo(3,"num",2, 2)) {return false;}
                if(_i.tipoFichero_ == "B2B") {
                        if(!_i.addCampo(19445,"num",5,7)) {return false;}
                }
                else if(_i.tipoFichero_ == "CORE") {
                        if(!_i.addCampo(19143,"num",5,7)) {return false;}
                }
                else if(_i.tipoFichero_ == "CORE1*") {
                        if(!_i.addCampo(19154,"num",5,7)) {return false;}
                }
                else {
                        return false;
                }

                if(!IBAN || IBAN == "") {
                        MessageBox.warning(sys.translate("Falta el cdigo IBAN para la cuenta %1 del cliente %2").arg(codCuenta).arg(nombre),MessageBox.Ok,MessageBox.NoButton);
                        return false;
                }

                /*if(!BIC || BIC == "") {
                 *                MessageBox.warning(sys.translate("Falta el código BIC para la cuenta con IBAN %1 del cliente %2").arg(IBAN).arg(nombre));
                 *                return false;
        }*/

                if(!_i.addCampo(3,"num",3,10)) {return false;}
                if(!_i.addCampo(curRecibos.valueBuffer("codigo"),"String",35,45)) {return false;}
                if(!_i.addCampo(refMandato,"String",35,80)) {return false;}
                if(!_i.addCampo(tipoAdeudo,"String",4,84)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",4),"String",4,88)) {return false;}
                if(!_i.addCampo(curRecibos.valueBuffer("importe"),"numDec",11,99)) {return false;}
                if(!_i.addCampo(fechaFirma,"String",8,107)) {return false;}
                if(!_i.addCampo(BIC,"String",11,118)) {return false;}
                if(!_i.addCampo(curRecibos.valueBuffer("nombrecliente"),"String",70,188)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",50),"String",50,238)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",50),"String",50,288)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",40),"String",40,328)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",2),"String",2,330)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",1),"num",1,331)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",36),"String",36,367)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",35),"String",35,402)) {return false;}
                if(!_i.addCampo("A","String",1,403)) {return false;}
                if(!_i.addCampo(IBAN,"String",34,437)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",4),"String",4,441)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",140),"String",140,581)) {return false;}
                if(!_i.addCampo(_i.rellenarVacios("","String",19),"String",19,600)) {return false;}

                if(!mandatoPorDefecto) {
                      //  var curRR = new FLSqlCursor("reciboscliremesa");
                      //  curRR.select("idrecibo = " + curRecibos.valueBuffer("idrecibo") + " AND idremesa = " + cursor.valueBuffer("idremesa"));

                      //  while(curRR.next()) {
                      //          curRR.setModeAccess(curRR.Edit);
                      //          curRR.refreshBuffer();

                      //          curRR.setValueBuffer("idmandato", curMandato.valueBuffer("idmandato"));

                      //          if(!curRR.commitBuffer())
                      //                  return false;
                      //  }
                        curMandato.setValueBuffer("numefectos", formRecordmandatoscli.iface.pub_commonCalculateField("numefectos", curMandato));
                        curMandato.setValueBuffer("fechaultadeudo", cursor.valueBuffer("fechacargo"));
                        curMandato.setValueBuffer("fechacaducidad", formRecordmandatoscli.iface.pub_commonCalculateField("fechacaducidad", curMandato));

                        if (!curMandato.commitBuffer()) {
                                return false;
                        }
                }

                file.writeLine(_i.linea_);
                _i.linea_ = "";

        }while(curRecibos.next());

        return true;
}


function mandatoscliCuentas_incluirInformacionTipoPagoXML(nodoPadre, qryRecibos)
{
        var _i = this.iface;

        var ePmtTpInf = _i.colgarNodo("PmtTpInf",nodoPadre);

        /* 0 o 1 veces */
        if(1==1){
                var eSvcLvl = _i.colgarNodo("SvcLvl",ePmtTpInf);

                var eCd1 = _i.colgarNodo("Cd",eSvcLvl);
                if (!_i.colgarNodoTexto(eCd1,"SEPA","String",1,4,0)) {return false;}
        }

        /* 0 o 1 veces */
        if(1==1){
                var eLclInstrm = _i.colgarNodo("LclInstrm",ePmtTpInf);

                var eCd2 = _i.colgarNodo("Cd",eLclInstrm);
                if(_i.tipoFichero_ == "B2B") {
                        if (!_i.colgarNodoTexto(eCd2,"B2B","String",1,4,0)) {return false;}
                }
                else if (_i.tipoFichero_ == "CORE") {
                        if (!_i.colgarNodoTexto(eCd2,"CORE","String",1,4,0)) {return false;}
                }
                else if (_i.tipoFichero_ == "CORE1*") {
                        if (!_i.colgarNodoTexto(eCd2,"COR1*","String",1,4,0)) {return false;}
                }
                else {
                        return false;
                }
        }

        /* 0 o 1 veces */
        if(1==1) {
                /// Nuevo
                    var tipoPago;

                    var codCuenta = qryRecibos.value("r.codcuenta");
                    var numEfectos = AQUtil.sqlSelect("mandatoscli", "numefectos", "codcuentacliente = '" + codCuenta + "' AND tipo = '" + _i.tipoFichero_ + "'");
                    debug("Num Efectos: " + numEfectos);
                    if(!_i.tipoPago_ || _i.tipoPago_ == "") {
                            _i.tipoPago_ = "RCUR";
                    }
                    if (_i.tipoPago_ == "RCUR") {
                            if (!numEfectos || isNaN(numEfectos)) {
                                    tipoPago = "FRST";
                            } else {
                                    tipoPago = "RCUR";
                            }
                    } else {
                            tipoPago = _i.tipoPago_;
                    }
                var eSeqTp = _i.colgarNodo("SeqTp",ePmtTpInf);
                if (!_i.colgarNodoTexto(eSeqTp, tipoPago, "String", 1, 4,0)) {return false;}

                /*
                 *                if(!_i.tipoPago_ || _i.tipoPago_ == "") {
                 *                        _i.tipoPago_ = "RCUR";
        }
        var eSeqTp = _i.colgarNodo("SeqTp",ePmtTpInf);
        if (!_i.colgarNodoTexto(eSeqTp,_i.tipoPago_,"String")) {return false;}
        */
                ///Nuevo
        }

        /* 0 o 1 veces */
        if(1==0){
                var eCtgyPurp = _i.colgarNodo("CtgyPurp",ePmtTpInf);

                /* Condicion OR para Cd y ePrtry */
                if(1==0) {
                        var eCd3 = _i.colgarNodo("Cd",eCtgyPurp);
                        if (!_i.colgarNodoTexto(eCd3,/* valorCd */ "valorCd","String",1,4,0)) {return false;}
                }
                else {
                        var ePrtry = _i.colgarNodo("Prtry",eCtgyPurp);
                        if (!_i.colgarNodoTexto(ePrtry,/* valorPrtry */ "valorPrtry","String",1,35,0)) {return false;}
                }
        }

        return true;
}

function mandatoscliCuentas_incluirOperacionAdeudoXML(nodoPadre, qryRecibos)
{
        var _i = this.iface;
        var cursor = this.cursor();
        var util:FLUtil = new FLUtil;

        var curRecibos = new FLSqlCursor("reciboscli");
        //var idRecibos:String = formRecordremesas.iface.idRecibosRemesa(cursor.valueBuffer("idremesa"));
        curRecibos.select("codcliente = '" + qryRecibos.value("r.codcliente") + "' AND fechav = '" + qryRecibos.value("r.fechav") + "' AND codcuenta = '" + qryRecibos.value("r.codcuenta") + "' AND idrecibo IN (SELECT idrecibo FROM reciboscli WHERE idremesa = " + cursor.valueBuffer("idremesa") + ")");

	debug("SQL : incluirOperacionAdeudoXML");
        if(!curRecibos.first()) {
                sys.warnMsgBox(sys.translate("No se han encontrado recibos validos para el cliente %1").arg(qryRecibos.value("r.nombrecliente")));
                return false;
        }

        do{
                curRecibos.setModeAccess(curRecibos.Browse);
                curRecibos.refreshBuffer();

                var fechaRem = cursor.valueBuffer("fechacargo");
                var codCuenta = curRecibos.valueBuffer("codcuenta");
                var codCliente = curRecibos.valueBuffer("codcliente");
                var nombre = curRecibos.valueBuffer("nombrecliente");
                var fechaRec = curRecibos.valueBuffer("fecha");

                var curMandato = new FLSqlCursor("mandatoscli");
                //var curMC = new FLSqlCursor("mandatosclicuentas");
                //debug("select array_to_string(array_agg(m.idmandato),',') from mandatoscli m inner join mandatosclicuentas c on m.idmandato = c.idmandato where c.codcuentacliente='"+codCuenta+"' AND m.tipo = '"+ _i.tipoFichero_ +"' AND (m.fechafirma < '" + fechaRec + "' OR m.fechafirma IS NULL");
		var select:String;
		if ( aqApp.db().driverName().startsWith("FLQPSQL"))
			{
                	select = "array_to_string(array_agg(idmandato),',')";
			}
		else
			{
			select = "GROUP_CONCAT(idmandato)";
			}

                var idsValidos:String = AQUtil.sqlSelect("mandatoscli",select,"codcuentacliente='"+codCuenta+"' AND tipo = '"+ _i.tipoFichero_ +"' AND (fechafirma < '" + fechaRec + "' OR fechafirma IS NULL)","mandatoscli");

                if (!idsValidos || idsValidos == "") idsValidos = "-1";

                curMandato.select("idmandato IN ("+idsValidos+")");

                switch (curMandato.size()) {
                        case 0: {
                                break;
                        }
                        case 1: {
                                break;
                        }
                        default: {
                                var mandatoEncontrado = false;

                                for(var ind = 0; ind < aCuentasMandato_.length; ind++) {
                                        if(aCuentasMandato_[ind] == codCuenta) {
                                                curMandato.select("idmandato = " + aMandatoElegido_[ind]);
                                                mandatoEncontrado = true;
                                        }
                                }

                                if(!mandatoEncontrado) {
                                        var opId = [];
                                        var opDes = [];

                                        while (curMandato.next()) {
                                                curMandato.setModeAccess(curMandato.Browse);
                                                curMandato.refreshBuffer();

                                                opId.push(curMandato.valueBuffer("idmandato"));
                                                opDes.push(curMandato.valueBuffer("refmandato") + " - " + curMandato.valueBuffer("descripcion"));
                                        }

                                        var idOpcion = flfactppal.iface.pub_elegirOpcion(opDes, sys.translate("Escoja mandato para la cuenta %1 del cliente %2 - %3").arg(codCuenta).arg(codCliente).arg(nombre));

                                        if (idOpcion < 0) {
                                                return false;
                                        }

                                        curMandato.select("idmandato = " + opId[idOpcion]);
                                        aCuentasMandato_.push(codCuenta);
                                        aMandatoElegido_.push(opId[idOpcion]);
                                }
                                break;
                        }
                }

                var refMandato;
                var fechaCad;
                var numEfectos;
                var tipoPago;
                var fechaFirma;

                var mandatoPorDefecto = false;

                if (!curMandato.first()) {
                        curMandato.setModeAccess(curMandato.Insert);
                        curMandato.refreshBuffer();

                        refMandato = flfacturac.iface.pub_cerosIzquierda(codCliente,6) + flfacturac.iface.pub_cerosIzquierda("0", 29);
                        fechaCad = "2009-10-31";
                        numEfectos = 0;
                        tipoPago = "Pago Recurrente";
                        mandatoPorDefecto = true;
                        fechaFirma = "2009-10-31";

                        if(refMandato == "" || !refMandato){
                                return false;
                        }

                        curMandato.setValueBuffer("refmandato", refMandato);
                        curMandato.setValueBuffer("codcuenta", cursor.valueBuffer("codcuenta"));
                        curMandato.setValueBuffer("descripcion", "Mandato Defecto " + curRecibos.valueBuffer("nombrecliente"));
                        curMandato.setValueBuffer("fechacaducidad", fechaCad);
                        curMandato.setValueBuffer("numefectos", numEfectos);
                        curMandato.setValueBuffer("tipopago", tipoPago);
                        curMandato.setValueBuffer("tipo", _i.tipoFichero_);
                        curMandato.setValueBuffer("fechafirma", fechaFirma);
                        curMandato.setValueBuffer("codcliente", qryRecibos.value("r.codcliente"));
                        curMandato.setValueBuffer("codcuentacliente", qryRecibos.value("r.codcuenta"));
                        curMandato.setValueBuffer("lugarfirma", "");

                        if(!curMandato.commitBuffer()){
                                return false;
                        }
                        debug("Crea el mandato.");

                        //curMC.setModeAccess(curMC.Insert);
                        //curMC.refreshBuffer();
                        //curMC.setValueBuffer("idmandato",curMandato.valueBuffer("idmandato"));
                        //curMC.setValueBuffer("codcuentacliente", qryRecibos.value("r.codcuenta"));
                        //if (!curMC.commitBuffer()){
                        //    return false;
                        //}

                }
                else {
                        curMandato.setModeAccess(curMandato.Edit);
                        curMandato.refreshBuffer();
                        refMandato = curMandato.valueBuffer("refmandato");
                        debug("refMandato " + refMandato);

                        fechaCad = curMandato.valueBuffer("fechacaducidad");
                        fechaCad = _i.formateaFecha(fechaCad,"A-M-D");
                        numEfectos = curMandato.valueBuffer("numefectos");
                        tipoPago = curMandato.valueBuffer("tipopago");
                        fechaFirma = curMandato.valueBuffer("fechafirma");

                        if(!fechaFirma || fechaFirma == "") {
                                fechaFirma = "2009-10-31";
                        }
                        else {
                                fechaFirma = _i.formateaFecha(fechaFirma,"A-M-D");
                        }
                }

                var tipoAdeudo;

                if(numEfectos != 0) {
                        tipoAdeudo = "RCUR";
                }
                else {
                        if(tipoPago == "Pago Recurrente") {
                                tipoAdeudo = "FRST";
                        }
                        else {
                                tipoAdeudo = "OOFF";
                        }
                }

                var eDrctDbtTxInf = _i.colgarNodo("DrctDbtTxInf",nodoPadre);

                var bicBanco = AQUtil.sqlSelect("cuentasbcocli","bic","codcuenta = '" + curRecibos.valueBuffer("codcuenta") + "'");
                var IBAN = AQUtil.sqlSelect("cuentasbcocli","iban","codcuenta = '" + curRecibos.valueBuffer("codcuenta") + "'");

                var ePmtId = _i.colgarNodo("PmtId",eDrctDbtTxInf);

                var eEndToEndId = _i.colgarNodo("EndToEndId",ePmtId);
                if (!_i.colgarNodoTexto(eEndToEndId,curRecibos.valueBuffer("codigo"),"String",1,35,0)) {return false;}

                var eInstdAmt = _i.colgarNodo("InstdAmt",eDrctDbtTxInf);
                eInstdAmt.setAttribute("Ccy",curRecibos.valueBuffer("coddivisa"));

                var importeRecibo = curRecibos.valueBuffer("importe");
                importeRecibo = AQUtil.roundFieldValue(importeRecibo,"facturascli","totaliva");

                if (!_i.colgarNodoTexto(eInstdAmt,importeRecibo,"double",3,12,2)) {return false;}

                /* 0 o 1 veces */
                if(1==1){
                        var eDrctDbtTx = _i.colgarNodo("DrctDbtTx",eDrctDbtTxInf);

                        var eMndtRltdInf = _i.colgarNodo("MndtRltdInf",eDrctDbtTx);

                        var eMndtId = _i.colgarNodo("MndtId",eMndtRltdInf);
                        if (!_i.colgarNodoTexto(eMndtId,refMandato,"String",1,35,0)) {return false;}

                        var eDtOfSgntr = _i.colgarNodo("DtOfSgntr",eMndtRltdInf);
                        if (!_i.colgarNodoTexto(eDtOfSgntr,fechaFirma,"Date",8,10,0)) {return false;}
                }

                var eDbtrAgt = _i.colgarNodo("DbtrAgt",eDrctDbtTxInf);

                var eFinInstnId = _i.colgarNodo("FinInstnId",eDbtrAgt);

                if(!IBAN || IBAN == "") {
                        MessageBox.warning(sys.translate("Falta el código IBAN para la cuenta %1 del cliente %2").arg(codCuenta).arg(nombre),MessageBox.Ok,MessageBox.NoButton);
                        return false;
                }

                if(!bicBanco || bicBanco == "") {
                        MessageBox.warning(sys.translate("Falta el código BIC para la cuenta con IBAN %1 del cliente %2").arg(IBAN).arg(nombre),MessageBox.Ok,MessageBox.NoButton);
                                bicBanco = "";
                                 //return false;
                }

                if(bicBanco && bicBanco != ""){
                        var eBIC = _i.colgarNodo("BIC",eFinInstnId);
                        if (!_i.colgarNodoTexto(eBIC,bicBanco,"String",1,11,0)) {return false;}
                }
                /*else{
                        bicBanco = "";
                        if (!_i.colgarNodoTexto(eBIC,bicBanco,"String")) {return false;}
                }*/

                if(!_i.incluirDeudorXML(eDrctDbtTxInf,qryRecibos)){
                        return false;
                }

                var eDbtrAcct = _i.colgarNodo("DbtrAcct",eDrctDbtTxInf);

                var eId = _i.colgarNodo("Id",eDbtrAcct);

                var eIBAN = _i.colgarNodo("IBAN",eId);
                if (!_i.colgarNodoTexto(eIBAN,IBAN,"String", 1, 34,0)) {return false;}

                //if(!mandatoPorDefecto) {   //Esto se coment porque ahora creamos el mandato cuando genera uno por defecto.
                 //       var curRR = new FLSqlCursor("reciboscliremesa");
                 //       curRR.select("idrecibo = " + curRecibos.valueBuffer("idrecibo") + " AND idremesa = " + cursor.valueBuffer("idremesa"));

                 //       while(curRR.next()) {
                 //               curRR.setModeAccess(curRR.Edit);
                 //               curRR.refreshBuffer();
                 //               curRR.setValueBuffer("idmandato", curMandato.valueBuffer("idmandato"));

                 //               if(!curRR.commitBuffer())
                 //                       return false;
                 //       }

                        //curMandato.setValueBuffer("numefectos", formRecordmandatoscli.iface.pub_commonCalculateField("numefectos", curMandato));
			curMandato.setValueBuffer("numefectos", curMandato.valueBuffer("numefectos") + 1);
                        curMandato.setValueBuffer("fechaultadeudo", cursor.valueBuffer("fechacargo"));
                        curMandato.setValueBuffer("fechacaducidad", formRecordmandatoscli.iface.pub_commonCalculateField("fechacaducidad", curMandato));

                        if (!curMandato.commitBuffer()) {
                                return false;
                        }
                //}

        } while(curRecibos.next());

        return true;
}

function mandatoscliCuentas_comprobarMandatos()
{
        var _i = this.iface;
        var cursor = this.cursor();
        var util:FLUtil = new FLUtil;

        var recibosError = [];
        var cuentasError = [];
        var bicError = [];
        var mandatosError = [];
        var bicErrorBanco = [];

        var error = false;

        var idRemesa = cursor.valueBuffer("idremesa");
        var fechaRem = cursor.valueBuffer("fechacargo");
	var idRecibos:String = "(SELECT idrecibo FROM reciboscli WHERE idremesa = " + cursor.valueBuffer("idremesa") + ")";

        var qryRecibos = new FLSqlQuery();
        var groupBy = " GROUP BY r.codigo, r.codcliente, r.codcuenta ";
        qryRecibos.setSelect("r.codigo, r.codcliente, max(r.nombrecliente), r.codcuenta");
        qryRecibos.setFrom("reciboscli r ");
        qryRecibos.setWhere("r.idrecibo IN(" + idRecibos + ") " + groupBy);

        if (!qryRecibos.exec()) {
                MessageBox.warning("Error query.",MessageBox.Ok,MessageBox.NoButton);
                return false;
        }

        while(qryRecibos.next()){
                var curRecibos = new FLSqlCursor("reciboscli");
                curRecibos.select("codcliente = '" + qryRecibos.value("r.codcliente") +"' AND codcuenta = '" + qryRecibos.value("r.codcuenta") + "' AND idrecibo IN ("+idRecibos+")");
                /*
                 * YeboYebo aqu lo que hizo fue cambiar el filtro de los recibos, para que el nombre del cliente soporte cambios en acentos, etctera.
                 * ... pero nosotros hace tiempo que lo quitamos. Tambin por este motivo. Igual interesa volverlo a poner.
                 *
                 *     Cambi: "' AND nombrecliente =    '" + qryRecibos.value("r.nombrecliente")                     + "'
                 *     Por:    "' AND nombrecliente like '" + _i.quitaApostrofes(qryRecibos.value("r.nombrecliente")) + "'
                 *
                 * */

                if(!qryRecibos.value("r.codcuenta") || qryRecibos.value("r.codcuenta") == "") {
                        var nArray = [qryRecibos.value("r.codigo"),qryRecibos.value("r.codcliente"),qryRecibos.value(2)];
                        recibosError.push(nArray);
                        error = true;
                        continue;
                }

                while(curRecibos.next()) {
                        curRecibos.setModeAccess(curRecibos.Browse);
                        curRecibos.refreshBuffer();

                        var codCuenta = curRecibos.valueBuffer("codcuenta");
                        var codCuentaBanco = curRecibos.valueBuffer("codcuenta");
                        var nombre = curRecibos.valueBuffer("nombrecliente");
                        var codCliente = curRecibos.valueBuffer("codcliente");
                        var fechaRec = curRecibos.valueBuffer("fecha");
                        var IBAN = AQUtil.sqlSelect("cuentasbcocli","iban","codcuenta = '" + codCuenta + "'");
                        var BIC = AQUtil.sqlSelect("cuentasbcocli","bic","codcuenta = '" + codCuenta + "'");
                        var BICCuentaBanco = AQUtil.sqlSelect("cuentasbanco","bic","codcuenta = '" + codCuentaBanco + "'");
                        var IBANBanco = AQUtil.sqlSelect("cuentasbanco","iban","codcuenta = '" + codCuentaBanco + "'");

                        if(!IBAN || IBAN == "") {
                                var encontrado = false;
                                for(var i = 0; i < cuentasError.length; i++) {
                                        if(cuentasError[i][0] == codCuenta) {
                                                encontrado = true;
                                                break;
                                        }
                                }
                                if(!encontrado) {
                                        var nArray = [codCuenta,codCliente,nombre];
                                        cuentasError.push(nArray);
                                        error = true;
                                }
                        }

                        if(!BIC || BIC == "") {
                                var encontrado = false;
                                for(var i = 0; i < bicError.length; i++) {
                                        if(bicError[i][0] == codCuenta) {
                                                encontrado = true;
                                                break;
                                        }
                                }
                                if(!encontrado) {
                                        if(!IBAN || IBAN == "") {
                                                IBAN = "noIBAN";
                                        }
                                        var nArray = [codCuenta,IBAN,codCliente,nombre];
                                        bicError.push(nArray);
                                        error = true;
                                }
                        }

                        if(!BICCuentaBanco || BICCuentaBanco == "") {
                                var encontrado = false;
                                for(var i = 0; i < bicErrorBanco.length; i++) {
                                        if(bicErrorBanco[i][0] == codCuentaBanco) {
                                                encontrado = true;
                                                break;
                                        }
                                }
                                if(!encontrado) {
                                        if(!IBANBanco || IBANBanco == "") {
                                                IBANBanco = "noIBAN";
                                        }
                                        debug("No se encuentra el Bic del banco para codCuenta:" + codCuentaBanco + " IBAN:" + IBANBanco);

                                        var nArray = [codCuentaBanco,IBANBanco,];
                                        //bicErrorBanco.push(nArray);
                                        //error = true;
                                }
                        }


                        var curMandato = new FLSqlCursor("mandatoscli");

			var select:String;
			if ( aqApp.db().driverName().startsWith("FLQPSQL"))
				{
                		select = "array_to_string(array_agg(idmandato),',')";
				}
			else
				{
				select = "GROUP_CONCAT(idmandato)";
				}

                        var idsValidos:String = AQUtil.sqlSelect("mandatoscli",select,"codcuentacliente='"+codCuenta+"' AND tipo = '"+ _i.tipoFichero_ +"' AND (fechafirma < '" + fechaRec + "' OR fechafirma IS NULL)","mandatoscli");
                        if (!idsValidos || idsValidos == "") idsValidos = "-1";
                        //debug("select array_to_string(array_agg(idmandato),',') from mandatoscli where codcuentacliente='"+codCuenta+"' AND tipo = '"+ _i.tipoFichero_ +"' AND (fechafirma < '" + fechaRec + "' OR fechafirma IS NULL");
                        curMandato.select("idmandato IN ("+idsValidos+")");
                        debug("idsvalidos ===="+idsValidos);
                        if(curMandato.size() == 0) {
                                var encontrado = false;
                                for(var i = 0; i < mandatosError.length; i++) {
                                        if(mandatosError[i][0] == codCuenta) {
                                                encontrado = true;
                                                break;
                                        }
                                }
                                if(!encontrado) {
                                        if(!IBAN || IBAN == "") {
                                                IBAN = "noIBAN";
                                        }
                                        var nArray = [codCuenta,IBAN,codCliente,nombre];
                                        mandatosError.push(nArray);
                                }
                        }
                } while(curRecibos.next());
        }

         var aDatosCuentas = [];
        aDatosCuentas.push(error);
        aDatosCuentas.push(recibosError);
        aDatosCuentas.push(cuentasError);
        aDatosCuentas.push(mandatosError);
        aDatosCuentas.push(bicError);
        aDatosCuentas.push(bicErrorBanco);

        return aDatosCuentas;

}
//// MANDATOSCLICUENTAS /////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

