/***************************************************************************
                 cargamercancia.qs  -  description
                             -------------------
    begin                : dom feb 08 2015
    copyright            : Jos Antonio Fernndez Fernndez
    email                : aullasistemas@gmail.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
    function validateForm():Boolean {
    	return this.ctx.interna_validateForm();
    }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
    function oficial( context ) { interna( context ); } 
}

//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends oficial {
    function head( context ) { oficial ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \C
Este es el formulario maestro de presupuestos a cliente.
\end */
function interna_init()
{
//debug("init de cargaMerancia");
}

function interna_validateForm():Boolean
{
//debug("ValidateForm");
var util:FLUtil = new FLUtil();
var cursor = this.cursor();
var id:Number = cursor.valueBuffer("idalbaran");
var fechaCarga:String = cursor.valueBuffer("fechacarga"); 
var matricula:String = cursor.valueBuffer("matricula");
var idChofer:String = cursor.valueBuffer("idchofer");


if (!fechaCarga || fechaCarga == "0000-00-00")
	{
	MessageBox.critical(util.translate("scripts", "La fecha de carga no puede estar vaca"), MessageBox.Ok, MessageBox.NoButton);
	return false;
	}
else
	{
	fechaCarga = fechaCarga.toString().left(10);
//	debug("fechaCarga = " + fechaCarga);
	util.sqlUpdate("albaranescli","fechacarga",fechaCarga,"idalbaran = " + id);

	}
if (!matricula)
	{
		MessageBox.critical(util.translate("scripts", "La matricula no puede estar vaca"), MessageBox.Ok, MessageBox.NoButton);
	return false;
	}	
else
	util.sqlUpdate("albaranescli","matricula",matricula,"idalbaran = " + id);


if (!idChofer)
	{
	MessageBox.critical(util.translate("scripts", "El transportista no puede estar vaco"), MessageBox.Ok, MessageBox.NoButton);
	return false;
	}	
else
	util.sqlUpdate("albaranescli","idchofer",idChofer,"idalbaran = " + id);


cursor.setValueBuffer("matricula", cursor.valueBufferCopy("matricula"));
cursor.setValueBuffer("fechacarga", cursor.valueBufferCopy("fechacarga"));
cursor.setValueBuffer("idchofer", cursor.valueBufferCopy("idchofer"));
return true;

}
//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////

//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
